//
//  main.m
//
//  Created by Everett Kaser October 2022.
//  Copyright © 2022 Everett Kaser Software. All rights reserved.
//



/*

 1.0m1 FIXES:
   1) Crash caused by ExecKE being called before startup code had completed.
      Changed KEloaded from BOOL to LONG so it could reflect several different
      steps in the start-up phase, allowing some code to avoid running until
      everything was ready, while allowing other code to run part-way there.
   2) Mouse movement problems, caused by race conditions between adding/editing
      mouse-moved messages in the KEmsgs[] queue while the ExecKE thread was
      removing them.  Changes in mousemoved, mouseddragged, etc, and SendNextMsg.
 
   Both of these only showed up on a few systems, primarily ones with additional
   CPU cores and/or faster speeds.
*/






#import <Cocoa/Cocoa.h>
#import "kintAppDelegate.h"

#import <AVFoundation/AVFoundation.h>
#import <Foundation/Foundation.h>
#import <CoreFoundation/CoreFoundation.h>
#import <Carbon/Carbon.h>
//#import <AudioToolbox/AudioToolbox.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>

#import "kintMAIN.h"
#import "kintPMACH.h"
#import "kintView.h"

//****************************

 #include <math.h>
 #include <sys/time.h>

#if EKDBG
char    EKDbuf[1024];
#endif

 // *********************************************************************************
/*
 void Dwrite(char *str) {
 
 NSString *targetName;
 NSString *docDir;
 NSArray *paths;
 FILE    *Dfile;
 
 paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
 docDir = [paths objectAtIndex:0];
 targetName = [NSString stringWithFormat:@"%@/%@", docDir, @"Debug"];
 Dfile = fopen([targetName cStringUsingEncoding:1], "a");
 //fseek(Dfile, 0, SEEK_END);
 fwrite((void *)str, 1, strlen(str), Dfile);
 fwrite((void *)"\r\n", 1, 2, Dfile);
 fclose(Dfile);
 }
void Ddel() {
	NSString *targetName;
	NSString *docDir;
	NSArray *paths;
	
	paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	docDir = [paths objectAtIndex:0];
	targetName = [NSString stringWithFormat:@"%@/%@", docDir, @"Debug"];
	unlink([targetName cStringUsingEncoding:1]);
}
*/

int main(int argc, const char * argv[]) {

    NSArray*tl;
    NSApplication *application = [NSApplication sharedApplication];
    [[NSBundle mainBundle] loadNibNamed:@"MainMenu" owner:application topLevelObjects:&tl];
//	Dwrite("main");
//    kintAppDelegate *applicationDelegate = [[kintAppDelegate alloc] init];
//    [application setDelegate:applicationDelegate];
    [application run];
   // return NSApplicationMain(argc, argv);
    return 0;
}

//***************************************************************************************
//***************************************************************************************
//***************************************************************************************
//***************************************************************************************
//***************************************************************************************
//***************************************************************************************
//***************************************************************************************

BYTE    *mainKE;

KLONG     PhysicalScreenW, PhysicalScreenH, ScreenW, ScreenH, MaxScreenW, MaxScreenH;
SKBM    scrBM;
DWORD        HeapLockedCnt=0;/// prevents the feet of the idiot KINT programmer
DWORD        NonHeapLen, HeapLen, HeapTop, HighestHeapTop;    /// offset to start of HEAP, length of HEAP, top of HEAP (next allocatable offset above ALL allocated blocks)

KLONG	KEloaded=0, killpgm=0;
char    PgmPath[PATHLEN], TmpPath[PATHLEN], TmpPath2[PATHLEN], AppDataPath[PATHLEN], AppPath[PATHLEN];

BOOL MusicPlaying=FALSE;

struct	stat	fstats;
//FindFileList	*FirstNextList=NULL;
struct firstnext {
	struct firstnext *pNext;
	BOOL AppData;
	BYTE attrib;
	BYTE fname[3];	// [3] just rounds us up to a DWORD, the MALLOC will add the actual strlen(fname) to the sizeof(FIRSTNEXT)
};
typedef struct firstnext FIRSTNEXT;
FIRSTNEXT *pFirstNext=NULL, *pNextNext=NULL;

#define MAXFILES 16
KLONG	filesCnt=0;
FILE *files[MAXFILES];
//FindFileList	*FirstNextList=NULL;

BOOL InSetWindowPos=FALSE;
BOOL        InSleep=FALSE;    /// set when .KE requests a SLEEP period

//**********************************************************************
void FlushScreen(void) {

//	dispatch_async( dispatch_get_main_queue(), ^{
/*	inSleep = true;
	InvDirty();
	usleep(20000);
	inSleep = false;
*/
//	});
	//	HIWindowFlush ((HIWindowRef) gMacWindow);
}

//char BPname[PATHLEN];

///=====================================================================================
///    In the Windows implementation, all files must have their
/// full name give, including subfolder paths and file extensions.
///
/// This routine MUST build the full file path in 'TmpPath', as that's
/// where the calling functions expect to find it.
///
void BuildPath(char *pMem, BOOL AppData) {

//    TCHAR    *p;
//    int        bufLen;

    strcpy((char*)TmpPath, (char*)(AppData ? AppDataPath : PgmPath));    /// start with either AppDataPath or PgmPath
    if( !strncmp(pMem, "../MUSIC", 8) ) pMem += 3;
    strcat((char*)TmpPath, pMem);
//    bufLen = sizeof(TmpPath)/sizeof(TCHAR) - _tcslen(TmpPath)-1;    /// calc remaining available room
//    MultiByteToWideChar(CP_UTF8, 0, pMem, -1, TmpPath+_tcslen(TmpPath), bufLen);    /// convert and append filename (pMem)
//    for(p=TmpPath; *p; p++) if( *p==L'/' ) *p = L'\\';    /// DOS/Windows path conversion
}

///=====================================================================================
/// return file handle if successful, else -1
DWORD Kopen(char *fname, int oflags) {

    TCHAR    *p, tmpbuf[PATHLEN];

    /// if O_WRBIN or O_WRBINNEW
        /// if open(O_RDBIN) in AppData
            /// close file
        /// else if open(O_RDBIN) in PgmPath
            /// close file
            /// build AppData filename and copy to tmpbuf
            /// KCopyFile(fname, tmpbuf);
        /// open(oflags) in AppData
        /// return handle
    /// else
        /// if open(O_RDBIN) in AppData
            /// return handle
        /// else if open(O_RDBIN) in PgmData
            /// return handle
    /// return -1

    FILE    *fp;
    char    mode[8];
    
    switch (oflags) {
        case O_WRBIN:
            strcpy(mode, "r+b");
            break;
        case O_WRBINNEW:
            strcpy(mode, "w+b");
            break;
        case O_RDBIN:
        default:
            strcpy(mode, "rb");
            break;
    }
    
    if( oflags==O_RDBIN ) {    // if just READING
        BuildPath(fname, TRUE);    // try AppData first
        fp = fopen(TmpPath, mode);
        if( fp==NULL ) {
            BuildPath(fname, FALSE);    // try PgmPath second
            fp = fopen(TmpPath, mode);
        }
    } else {                // if WRITING
        BuildPath(fname, TRUE);    // try AppData first
        strcpy(tmpbuf, TmpPath);        // save AppData target name
        fp = fopen(tmpbuf, "rb");
        if( fp==NULL ) {
            // make sure target AppData path exists
            for(p=tmpbuf+strlen(tmpbuf)-1; p>tmpbuf && *p!='/'; p--) ;    // find end of 'path' portion
            if( p > tmpbuf ) {
                char    *b[64];
                long    bcnt;
                //                mode_t    process_mask;
                
                bcnt = 0;
                b[bcnt] = p;
                *b[bcnt] = 0;    // cut off file name portion, just keep path portion
                ++bcnt;
                while( -1==stat(tmpbuf, &fstats) ) {    // find 'lowest' portion of path that already exists
                    for(b[bcnt]=b[bcnt-1]-1; b[bcnt]>tmpbuf && *b[bcnt]!='/'; --b[bcnt]) ;    // find next higher folder
                    if( b[bcnt] <= tmpbuf ) break;
                    *b[bcnt] = 0;
                    ++bcnt;
                }
                if( b[bcnt-1] > tmpbuf ) {
                    while( bcnt>1 ) {            // create the rest of the path folders that didn't already exist
                        --bcnt;
                        *b[bcnt] = '/';
                        //                        process_mask = umask(0);
                        mkdir(tmpbuf, 0777);
                        //                        umask(process_mask);
                    }
                }
                *b[0] = '/';
            }
            BuildPath(fname, FALSE);    // try PgmPath second
            fp = fopen(TmpPath, "rb");
            if( fp != NULL ) {
                fclose(fp);
//                KCopyFile(fname, tmpbuf);
            }
        } else fclose(fp);
#if GEEKDEBUG
        if( !strcmp(tmpbuf+strlen(tmpbuf)-9, "debug.log") ) strcpy(debfile, tmpbuf);
#endif
        fp = fopen(tmpbuf, mode);
    }
    if( fp==NULL ) return (DWORD)-1;
    files[filesCnt] = fp;
    return (DWORD)filesCnt++;
}

//*********************************************************************************
// make a sub-folder of the DIR_GAME folder or a sub-folder thereof
// return non-zero if successful, else return zero if fail
int KMakeFolder(char *fname)
{
	int result;
	
#if _DEBUG && DEBUG_FILE
	printf ("KMakeFolder: %s\n", fname);
#endif
    BuildPath(fname, TRUE);
	
	result = mkdir(TmpPath, 0777);
	
	// If the path already exists, don't return an error
	if( result != 0 && errno == EEXIST ) result = 0;
	
	return result;
}

//*********************************************************************************
// Delete an empty folder (can NOT contain ANY files)
void KDelFolder(char *fname) {
	
#if _DEBUG && DEBUG_FILE
	//	MacNotImplemented();
	printf ("KDelFolder: %s\n", fname);
#endif
	
	BuildPath(fname, TRUE);
	rmdir(TmpPath);
}

//********************************************************************************
// return file length if successful, else -1
DWORD Kstat(char *fname, DWORD *modtim, BYTE *filtyp) {
	
	FILE	*fp;
	DWORD	len;
	
	BuildPath(fname, TRUE);	// try AppData first
	if( -1==stat(TmpPath, &fstats) ) {
		BuildPath(fname, FALSE);
		if( -1==stat(TmpPath, &fstats) ) return 0xFFFFFFFF;
	}
	*modtim = (DWORD)fstats.st_mtime;
	if( (fstats.st_mode & S_IFMT)==S_IFDIR ) *filtyp = 2;
	else *filtyp = 1;
	
	fp = fopen(TmpPath, "rb");
	if( fp==NULL ) return 0xFFFFFFFF;
	
	fseek(fp, 0, SEEK_END);
	len = (DWORD)ftell(fp);
	fclose(fp);
	
	return len;
}

//********************************************************************************
// In KINT/KASM, 'origin' has these values (in case your language is different):
//		SEEK_SET    0
//		SEEK_CUR    1
//		SEEK_END    2
// return new file pointer position or -1 if error
DWORD Kseek(DWORD fhandle, DWORD foffset, int origin)
{
	DWORD retVal = -1;
	FILE	*fp;
	
	if( fhandle==(DWORD)-1 || fhandle>=filesCnt  ) goto badHandle;
	fp = files[fhandle];
	
	if( 0!=fseek(fp, foffset, origin) ) goto cantSeek;
	
	retVal = (DWORD)ftell (fp);
	
#if _DEBUG && DEBUG_FILE
	printf("Kseek %08x offset: %d, origin: %02x retval: %08x\n", fhandle, foffset, origin, retVal);
#endif
	
badHandle:
cantSeek:
	return retVal;
}

//*********************************************************************************
void Kclose(DWORD fhandle)
{
#if _DEBUG && DEBUG_FILE
	printf("Kclose %08x\n", fhandle);
#endif
	if( fhandle>=filesCnt || fhandle==0xFFFFFFFF ) goto badHandle;
	
	fclose(files[fhandle]);
	files[fhandle] = NULL;
	
	while( filesCnt && files[filesCnt-1]==NULL ) --filesCnt;
	
badHandle:
	return;
}

//********************************************************************************
//	return 1 if at EOF, 0 if not at EOF, -1 if error
DWORD Keof(DWORD fhandle)
{
	DWORD retVal = -1;
	if( fhandle==0xFFFFFFFF || fhandle>=filesCnt ) goto badHandle;
	retVal = feof(files[fhandle]);
	if( retVal ) retVal = 1;
	
#if _DEBUG && DEBUG_FILE
	printf("Keof %08x, %d\n", fhandle, retVal);
#endif
	
badHandle:
	return retVal;
}

//******************************************************
DWORD Kread(DWORD fhandle, BYTE *pMem, DWORD numbytes)
{
	DWORD retVal = 0;
	
	if( fhandle==0xFFFFFFFF || fhandle>=filesCnt || pMem==NULL ) goto badHandle;
	if( !feof(files[fhandle]) ) retVal = (DWORD)fread(pMem, 1, numbytes, files[fhandle]);
	else retVal = 0;
#if _DEBUG && DEBUG_FILE
	printf("Kread %08x, numbytes: %d, result: %d\n", fhandle, numbytes, retVal);
#endif
	
badHandle:
	return retVal;
}

//*******************************************************
DWORD Kwrite(DWORD fhandle, BYTE *pMem, DWORD numbytes)
{
	DWORD retVal = 0;
	
	if( fhandle==0xFFFFFFFF || fhandle>=filesCnt || pMem==NULL ) goto badHandle;
	
	retVal = (DWORD)fwrite (pMem, 1, numbytes, files[fhandle]);
	
#if _DEBUG && DEBUG_FILE
	printf("Kwrite %08x, numbytes: %d, result: %d\n", fhandle, numbytes, retVal);
#endif
	
badHandle:
	return retVal;
}

//*************************************************


//NOTE: Windows deletes the file from BOTH the PGM and DATA folders, but the MAC KINT only deletes from the DATA folder.

void Kdelete(char *fname)
{
#if _DEBUG && DEBUG_FILE
	printf ("Kdelete: %s\n", fname);
#endif
	
	if( fname==NULL ) goto badFileName;
	BuildPath (fname, TRUE);
	unlink(TmpPath);
badFileName:
	return;
}

//***************************************************
void Krename(char *fname, char *tname) {
    
    BuildPath(tname, TRUE);
    NSString    *tstr = [NSString stringWithCString:TmpPath encoding:NSUTF8StringEncoding];
    BuildPath(fname, TRUE);
    NSString    *fstr = [NSString stringWithCString:TmpPath encoding:NSUTF8StringEncoding];
    NSError *error=nil;
    [[NSFileManager defaultManager] moveItemAtPath:fstr toPath:tstr error:&error];
}

//*****************************************************
void KGetTime(KTIME *pT)
{
	NSDate *now = [NSDate date];
	NSCalendar *sysCalendar = [NSCalendar currentCalendar];
	NSDateComponents *conversionInfo = [sysCalendar components:(NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay ) fromDate:now];
//	CFTimeZoneRef timeZone = CFTimeZoneCopyDefault();
//	CFGregorianDate curtime = CFAbsoluteTimeGetGregorianDate(CFAbsoluteTimeGetCurrent(), timeZone);
	
//	if (timeZone) 	CFRelease(timeZone);
	
	pT->y = [conversionInfo year];
	pT->mo= [conversionInfo month];
	pT->d = [conversionInfo day];
	pT->h = [conversionInfo hour];
	pT->mi= [conversionInfo minute];
	pT->s = [conversionInfo second];
}

//******************************************************
void KTimeToString(BYTE *pMem)
{
	NSDate *now = [NSDate date];
	NSCalendar *sysCalendar = [NSCalendar currentCalendar];
	NSDateComponents *conversionInfo = [sysCalendar components:(NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay ) fromDate:now];
	//	CFTimeZoneRef timeZone = CFTimeZoneCopyDefault();
	//	CFGregorianDate curtime = CFAbsoluteTimeGetGregorianDate(CFAbsoluteTimeGetCurrent(), timeZone);
	
	//	if (timeZone) 	CFRelease(timeZone);
	
	sprintf((char *)pMem, "%4.4u-%2.2u-%2.2u %2.2u:%2.2u:%2.2u", (unsigned int)[conversionInfo year], (unsigned int)[conversionInfo month], (unsigned int)[conversionInfo day], (unsigned int)[conversionInfo hour], (unsigned int)[conversionInfo minute], (unsigned int)[conversionInfo second]);
}

//****************************************************************************
//		Return a millisecond count which doesn't necessarily bear
//		any resemblance to "real" time, but rather is a counter that is
//		a reasonably accurate "millisecond counter" that may eventually
//		roll over to 0, but which should not do so more often than once a day,
//		and who's count value continues upwards (until such time as a roll-over
//		might occur).  This is accomplished on the MS-Windows platform using
//		the GetTickCount() function.  Other platforms may choose to implement
//		this in whatever way seems easiest, while meeting the above criteria.
//		This counter value is only used for timing the speed of animations
//		and brief delays in actions.  So, reasonable accuracy down to 5 or 10
//		milliseconds would be very nice, and the roll-over (if and when it
//		occurs) should only cause (at most) a slight burp in any animation
//		or screen action that is going on at the moment (but from which it
//		should recover almost immediately).
//    NOTE: It is IMPORTANT that his count be relative accurate, as it is
//		used for generating the elapsed time count for solving puzzles!
//	It could be done getting the time of day, and subtracting that from the
//  time of day when the program started, but the Windows GetTickCount() function
//	works nicely, too.

DWORD KGetTicks(void)
{
	static double sMillisecondsPerBeat = 0.0;
	DWORD	retval;
	
	// If this is the first time here, create a conversion factor
	// so we can convert the timebase registers to milliseconds.
	if (sMillisecondsPerBeat == 0.0)
	{
		mach_timebase_info_data_t timebase;
		mach_timebase_info (&timebase);
		
		// Convert nanosecond result to milliseconds
		sMillisecondsPerBeat = (double) timebase.numer / (double) timebase.denom * 0.000001;
	}
	
	// Read the timebase registers and convert to ms.
	uint64_t ticks = mach_absolute_time();
	retval = (DWORD)(ticks * sMillisecondsPerBeat);
	return retval;
}

//*****************************************************************
bool inSleep=false;

void KSleep(DWORD tm) {
	
	if( tm>0 ) {
		inSleep = true;
		InvDirty();
		usleep((useconds_t)(tm*1000));
		inSleep = false;
	}
}

//**********************************************************
void KSetCursor(WORD curtype)
{
	//	curtype = 0 for normal, 1 for wait, 2 for hotlink
	switch (curtype) {
		case 0:		[[NSCursor arrowCursor] set]; break;
			//		case 1:		[[NSCursor watchCursor] set]; break;
		case 2:		[[NSCursor pointingHandCursor] set]; break;
		default:	[[NSCursor arrowCursor] set]; break;
	}
}

void KCaptureMouse(BOOL cap)
{
	//	MacNotImplemented();
}

bool inSetTitle=false;

// We can't pass this as function argument because the function gets run ASYNCHRONOUSLY on the UI thread,
// so the value will lilkely have changed by the time the UI thread runs the code.
char titleBuf[512];

//**********************************************************
void KSetTitle(void) {
	
    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
//	dispatch_async( dispatch_get_main_queue(), ^{
		NSString *windowTitle;
		
		windowTitle = [NSString stringWithCString:(const char*)titleBuf encoding:NSUTF8StringEncoding];
		inSetTitle = true;
		[[kApp window] setTitle:windowTitle];
		inSetTitle = false;
//	});
    }];
	return;
}

// We can't pass these as function arguments because the function gets run ASYNCHRONOUSLY on the UI thread,
// so the values will lilkely have changed by the time the UI thread runs the code.
DWORD	SWPopt=0, SWPh, SWPw, SWPy, SWPx, SWPvw=1100, SWPvh=600;
DWORD dS1,dS2,dS3,dS4,dS5;

void (^SSWPblock)(void);

volatile DWORD sswpFLAG;
void SetSWPv(void) {
	
    if( sswpFLAG ) NSLog(@"sswpFLAG");
    if( NSThread.currentThread.isMainThread ) {
        sswpFLAG = false;
//        Dwrite("SetSWPv isMain");
        SWPvw = SWPw-(DWORD)(kApp.window.frame.size.width - [kApp.window contentRectForFrameRect:[kApp.window frame]].size.width);
        SWPvh = SWPh-(DWORD)(kApp.window.frame.size.height - [kApp.window contentRectForFrameRect:[kApp.window frame]].size.height);
    } else {
        sswpFLAG = true;
//        Dwrite("SetSWPv notMain");
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            DWORD x,y,w,h;
            x = [[kApp window].contentView frame].origin.x;
            y = [[kApp window].contentView frame].origin.y;
            w = [[kApp window].contentView frame].size.width;
            h = [[kApp window].contentView frame].size.height;

            SWPvw = SWPw-(DWORD)(kApp.window.frame.size.width - [kApp.window contentRectForFrameRect:[kApp.window frame]].size.width);
            SWPvh = SWPh-(DWORD)(kApp.window.frame.size.height - [kApp.window contentRectForFrameRect:[kApp.window frame]].size.height);
            sswpFLAG = false;
        }];
    }
    while( sswpFLAG )
        ;
}

DWORD   lastGoodGetX, lastGoodGetY, lastGoodGetW, lastGoodGetH, lastGoodGetOpt;
volatile DWORD   swpFLAG;
//***********************************************************************
void KINT_SetWindowPos(void)
{
    BOOL t = InSetWindowPos;

//    if( swpFLAG ) NSLog(@"swpFLAG");
//    Dwrite("KINT_SetWindowPos 1");
    if( SWPw<1 || SWPh<1 ) {
        SWPx = lastGoodGetX;
        SWPy = lastGoodGetY;
        SWPw = lastGoodGetW;
        SWPh = lastGoodGetH;
        SWPopt = lastGoodGetOpt;
    }
    if( SWPw<600 || SWPh<400 ) {
        SWPx = 30;
        SWPy = 20;
        SWPw = 600;
        SWPh = 400;
    }
    if (!windowReady) return;
    if( !NORMblock ) {
        NORMx = SWPx;
        NORMy = SWPy;
        NORMw = SWPw;
        NORMh = SWPh;
    }
    if( NSThread.currentThread.isMainThread ) {
        swpFLAG = false;
/*        {
            char dBuf[128];
            sprintf(dBuf,"KINT_SetWindowPos m: %d,%d,%d,%d",SWPx,SWPy,SWPw,SWPh);
            Dwrite(dBuf);
        }
*/
        InSetWindowPos = TRUE;
        if( SWPopt==0 ) {
            NSRect    rect = NSMakeRect((CGFloat)SWPx, (CGFloat)SWPy, (CGFloat)SWPw, (CGFloat)SWPh);
            [[kApp window] setFrame:rect display:YES];
        }
        if( (SWPopt && !isFullScreen) || (!SWPopt && isFullScreen) ) {
//THIS? SetSWPv();
            [[kApp window] toggleFullScreen:nil];
        }
        InSetWindowPos = t;
    } else {
        swpFLAG = true;
/*        {
            char dBuf[128];
            sprintf(dBuf,"KINT_SetWindowPos n: %d,%d,%d,%d",SWPx,SWPy,SWPw,SWPh);
            Dwrite(dBuf);
        }
*/        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
		InSetWindowPos = TRUE;
        if( SWPopt==0 ) {
            NSRect	rect = NSMakeRect((CGFloat)SWPx, (CGFloat)SWPy, (CGFloat)SWPw, (CGFloat)SWPh);
            [[kApp window] setFrame:rect display:YES];
        }
        if( (SWPopt && !isFullScreen) || (!SWPopt && isFullScreen) ) {
            [[kApp window] toggleFullScreen:nil];
        }
		InSetWindowPos = t;
        swpFLAG = false;
        }];
    }
    while( swpFLAG )
        ;
//THIS?    SetSWPv();
}

volatile DWORD gwpFLAG;
//**************************************************************************
void KINT_GetWindowPos(DWORD *r11, DWORD *r12, DWORD *r13, DWORD *r14, DWORD *r15)
{
    if (!windowReady) return;
    dS1 = (DWORD)isFullScreen;
    if( NSThread.currentThread.isMainThread ) {
        gwpFLAG = 0;
        NSRect windowBounds = [[kApp window] frame];
        dS5 = windowBounds.origin.x; // x
        dS4 = windowBounds.origin.y; // y
        dS3 = windowBounds.size.width; // w
        dS2 = windowBounds.size.height; // h
    } else {
        gwpFLAG = 1;
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            NSRect windowBounds = [[kApp window] frame];
            dS5 = windowBounds.origin.x;
            dS4 = windowBounds.origin.y;
            dS3 = windowBounds.size.width;
            dS2 = windowBounds.size.height;
        }];
        gwpFLAG = 0;
    }
    while( gwpFLAG )
        ;
    if( NORMblock ) {
        dS5 = NORMx;
        dS4 = NORMy;
        dS3 = NORMw;
        dS2 = NORMh;
//        dS1 = NORMo;
    } else {
        NORMx = dS5;
        NORMy = dS4;
        NORMw = dS3;
        NORMh = dS2;
//THIS?        SetSWPv();
    }
    // the following save is in case a 0 or negative value is sent
    // for SETTING the window position, and we can use this instead.
    if( dS3>0 && dS2>0 ) {
        lastGoodGetX = dS5;
        lastGoodGetY = dS4;
        lastGoodGetW = dS3;
        lastGoodGetH = dS2;
        lastGoodGetOpt = dS1;
    }
    *r11 = dS5;
    *r12 = dS4;
    *r13 = dS3;
    *r14 = dS2;
    *r15 = dS1;
}

MusicPlayer	musicPlayer;
MusicSequence sequence;
uint32_t nTracks;
MusicTimeStamp sequenceLength;

//*********************************************************
void StopMusic(void) {
	
	Boolean retval;
	
	if( MusicPlaying ) {
		MusicPlayerIsPlaying(musicPlayer, &retval);
		if( retval ) {
			MusicPlayerStop(musicPlayer);
			DisposeMusicPlayer(musicPlayer);
			DisposeMusicSequence(sequence);
		}
	}
	MusicPlaying = 0;
}

//******************************
int KMusicIsBusy(void) {
	
	Boolean	retval=NO;
	MusicTimeStamp curTime;
	
	if( MusicPlaying ) {
		MusicPlayerIsPlaying(musicPlayer, &retval);
		if( retval ) {
			MusicPlayerGetTime(musicPlayer, &curTime);
			if( curTime >= sequenceLength ) {
				StopMusic();
				AddMsg(KMSG_MUSIC_DONE, 0, 0, 0);
			}
			retval = MusicPlaying;
		}
	}
	return (int)retval;
}

//****************************************************************************
void PlayMusic(char *pMem)
{
#if _DEBUG && DEBUG_SOUND
	printf("PlayMusic: %s\n", pMem);
#endif
//	BuildPath(pMem, FALSE);
    if( !strncmp(pMem, "../MUSIC", 8) ) pMem += 3;

	StopMusic();
	
	OSStatus	res=noErr;
	
	res = NewMusicPlayer(&musicPlayer);
	res = NewMusicSequence(&sequence);
//	strcpy(TmpPath, "MUSIC/");
//	strcat(TmpPath, pMem);
//	strcat(TmpPath, ".MID");
	NSString *iName = [NSString stringWithUTF8String:pMem];
	NSURL   *url = [[NSBundle mainBundle] URLForResource:iName withExtension:nil];
	
	res = MusicSequenceFileLoad (sequence, (__bridge CFURLRef _Nonnull)(url), 0, kMusicSequenceLoadSMF_ChannelsToTracks);
	res = MusicPlayerSetSequence(musicPlayer, sequence);
	res = MusicSequenceGetTrackCount(sequence, &nTracks);
	sequenceLength = 0;
	for(int i=0; i<nTracks; i++) {
		MusicTrack track;
		MusicTimeStamp trackLength=0;
		unsigned int propsize=sizeof(MusicTimeStamp);
		res = MusicSequenceGetIndTrack(sequence, i, &track);
		res = MusicTrackGetProperty(track, kSequenceTrackProperty_TrackLength, &trackLength, &propsize);
		if( trackLength > sequenceLength ) sequenceLength = trackLength;
	}
	sequenceLength += 1;	// or however many beats you want to add on the end for settling time
	res = MusicPlayerSetTime(musicPlayer, (MusicTimeStamp)0);
	res = MusicPlayerStart(musicPlayer);
	
	if( res==noErr ) MusicPlaying = 1;
}

//*******************************************************************
void KPlaySound(char *pMem) {
	
#if _DEBUG && DEBUG_SOUND
	printf("KPlaySound: %s\n", pMem);
#endif
	strcpy(TmpPath, pMem);
//	strcat(TmpPath, ".WAV");
    if( NSThread.currentThread.isMainThread ) {
        float    volume=100.0;
        NSString *iName = [NSString stringWithUTF8String:TmpPath];
        NSURL   *url = [[NSBundle mainBundle] URLForResource:iName withExtension:nil];
        NSError *error;
        pKV.audioPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&error];
        pKV.audioPlayer.numberOfLoops = 0;
        pKV.audioPlayer.volume = (float)volume/100.0;
        if( pKV.audioPlayer==nil ) NSLog(@"%@", [error description]);
        else [pKV.audioPlayer play];
    } else {
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            float    volume=100.0;

            NSString *iName = [NSString stringWithUTF8String:TmpPath];
            NSURL   *url = [[NSBundle mainBundle] URLForResource:iName withExtension:nil];
            NSError *error;
            pKV.audioPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&error];
            pKV.audioPlayer.numberOfLoops = 0;
            pKV.audioPlayer.volume = (float)volume/100.0;
            if( pKV.audioPlayer==nil ) NSLog(@"%@", [error description]);
            else [pKV.audioPlayer play];
        }];
    }
}

//*******************************************************************
void KPlaySoundMem(char *pMem, KLONG len, BOOL nostop) {
	
    if( NSThread.currentThread.isMainThread ) {
        float	volume=100.0;

        if( [pKV.audioPlayer isPlaying]==YES ) {
            if( nostop ) return;
            [pKV.audioPlayer stop];
        }
        NSError *error;
        pKV.audioPlayer = [[AVAudioPlayer alloc] initWithData:[[NSData alloc] initWithBytes:pMem length:len] error:&error];
    //	NSLog(@"%@",error);
        pKV.audioPlayer.numberOfLoops = 0;
        pKV.audioPlayer.volume = (float)volume/100.0;
        if( pKV.audioPlayer==nil ) NSLog(@"%@", [error description]);
        else [pKV.audioPlayer play];
    } else {
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            float    volume=100.0;

            if( [pKV.audioPlayer isPlaying]==YES ) {
                if( nostop ) return;
                [pKV.audioPlayer stop];
            }
            NSError *error;
            pKV.audioPlayer = [[AVAudioPlayer alloc] initWithData:[[NSData alloc] initWithBytes:pMem length:len] error:&error];
        //    NSLog(@"%@",error);
            pKV.audioPlayer.numberOfLoops = 0;
            pKV.audioPlayer.volume = (float)volume/100.0;
            if( pKV.audioPlayer==nil ) NSLog(@"%@", [error description]);
            else [pKV.audioPlayer play];
        }];
    }
}

//------------------------------------------------------------------------------------
// • wildicmp
//------------------------------------------------------------------------------------
// Case-insensitive wildcard matching.
// Matches against ? and *. Returns nonzero if match found, 0 if no match.

int wildicmp(const char *string, const char *wild)
{
	const char *charP = NULL, *wildP = NULL;
	
	// Attempt to match the string up to the first "*"
	while ((*string) && (*wild != '*'))
	{
		// No exact or ? match, so fail
		if ((*wild != '?') && (tolower(*wild) != tolower(*string)))
			return 0;
		
		// Otherwise move to the next char in each string
		wild++;
		string++;
	}
	
	// Match the rest of the string.
	while (*string)
	{
		// See if we hit a * token
		if (*wild == '*')
		{
			// If we're at the end of the wild string, we're done and we match.
			if (!*++wild)
				return 1;
			
			// wild and wildP are now the char after the * token
			wildP = wild;
			// advance to the next source char after this.
			charP = string+1;
		}
		// No * token, check for exact and ? matches.
		else if ((*wild == '?') || (tolower(*wild) == tolower(*string)))
		{
			wild++;
			string++;
		}
		else
		{
			// No match. If wildP is not NULL, we've got a * search and can consume another entry
			// in "string".
			// Otherwise we'll fail the match next time through the loop due to wild being NULL.
			wild = wildP;
			string = charP++;
		}
	}
	
	// Consume any * tokens at the end of the string
	while (*wild == '*')
		wild++;
	
	// If we're past the last * token in the wild string, we'll either be NULL or we won't
	// match (i.e. the wild string was longer than the source).
	return !*wild;
}

int stricmp(const char *s, const char *d) {
	
	while( *s && *d ) {
		if( tolower(*s) != tolower(*d) ) break;
		++s;
		++d;
	}
	if( *s < *d ) return -1;
	if( *s > *d ) return  1;
	return 0;
}

//****************************************************
// Terminate the Kfindfirst()/Kfindnext() process
void Kfindclose() {
	
	FIRSTNEXT	*pNext;
	
	while( pFirstNext != NULL ) {
		pNext = pFirstNext->pNext;
		free(pFirstNext);
		pFirstNext = pNext;
	}
	pNextNext = NULL;
}

char macName[256];

//**************************************
void Kff(BOOL AppData) {
	
	FIRSTNEXT	*pLast;
	char		nbuf[PATHLEN];
	int			i;
	DWORD		attribs;
	
	for(i=(int)strlen(TmpPath)-1; i>=0; i--) if( TmpPath[i]=='/' ) break;
	if( i>=0 && TmpPath[i]=='/' ) {
		strcpy(macName, TmpPath+i+1);
		TmpPath[i+1] = 0;
	} else {
		strcpy(macName, TmpPath);
		strcpy(TmpPath, "./");
	}
	
	NSString *fPath = [NSString stringWithUTF8String:TmpPath];
	NSString *filename=nil;
	NSFileManager *fileManager = [[NSFileManager alloc] init];
	NSURL	*fileURL = [NSURL fileURLWithPath:fPath];
	
	NSDirectoryEnumerator *dirEnum = [fileManager enumeratorAtURL:fileURL includingPropertiesForKeys:[NSArray arrayWithObject:NSURLIsDirectoryKey] options:NSDirectoryEnumerationSkipsSubdirectoryDescendants | NSDirectoryEnumerationSkipsHiddenFiles | NSDirectoryEnumerationSkipsPackageDescendants errorHandler:nil];//localFileManager enumeratorAtPath:fPath];
	for(NSURL *urlItem in dirEnum) {
		attribs = 0;
		NSNumber *isDir=nil;
		if( [urlItem getResourceValue:&isDir forKey:NSURLIsDirectoryKey error:nil]) {
			if( [isDir isEqual:[NSNumber numberWithInt:1]] ) {
				attribs |= 0x10;
			}
		}
		filename = [urlItem lastPathComponent];
		[filename getCString:nbuf maxLength:sizeof(nbuf) encoding:NSUTF8StringEncoding];
		if( wildicmp(nbuf, macName) ) {
			// if first one, just alloc a struct and go on
			if( pFirstNext==NULL ) {
				pFirstNext = pLast = (FIRSTNEXT *)malloc(sizeof(FIRSTNEXT)+strlen(nbuf));
				// else if not first one, check for duplicate fname
			} else {
				for(pLast=pFirstNext; ; pLast=pLast->pNext) {
					// if duplicate fname, skip this one, don't add it, don't allocate, don't collect $200
					if( !stricmp((char*)(pLast->fname), (char*)nbuf) ) goto dupe;
					if( pLast->pNext==NULL ) break;
				}
				// new fname, alloc a struct and go on
				pLast->pNext = (FIRSTNEXT *)malloc(sizeof(FIRSTNEXT)+strlen(nbuf));
				if( pLast->pNext!=NULL ) pLast = pLast->pNext;
				else SystemMessage("kFF:N");
			}
			
			pLast->pNext = NULL;
			pLast->AppData = AppData;
			pLast->attrib = (BYTE)attribs;
			strcpy((char*)(pLast->fname), (char*)nbuf);
		dupe:;
		}
	}
}

//******************************************************************
// Search for a filename (possibly containing '*' as wild card)
DWORD Kfindfirst(char *fname, BYTE *fbuf, BYTE *attrib, BYTE *appdata) {
	
	Kfindclose();
	
	BuildPath(fname, TRUE);
	Kff(TRUE);
	
	BuildPath(fname, FALSE);	// now search the PgmPath directory tree
	Kff(FALSE);
	
	if( pFirstNext ) {
		*attrib = pFirstNext->attrib;
		*appdata = pFirstNext->AppData;
		strcpy((char*)fbuf, (char*)(pFirstNext->fname));
		pNextNext = pFirstNext->pNext;
		return 0;
	}
	return 0xFFFFFFFF;
}

//********************************************************************
// Search for next filename in sequence started by Kfindfirst()
DWORD Kfindnext(BYTE *fbuf, BYTE *attrib, BYTE *appdata) {
	
	if( pNextNext!=NULL ) {
		*attrib = pNextNext->attrib;
		*appdata = pNextNext->AppData;
		strcpy((char*)fbuf, (char*)(pNextNext->fname));
		pNextNext = pNextNext->pNext;
		return 0;
	}
	return 0xFFFFFFFF;
}

void KillProgram(void) {

//	DumpDR();
	ForceMsg(KMSG_SHUTDOWN, 0, 0, 0);
//	SysCleanup();
	exit(0);
}

//*********************************************************************
// store the appropriate End-Of-Line sequence into buffer 'pMem' and
// return the number of bytes written to 'pMem'.
KLONG GetSystemEOL(BYTE *pMem) {
    
    *pMem++ = '\n';
    return 1;
}

BYTE    BytBuf[8192];

///=========================================================================================
/// Load MAIN.KE
BOOL LoadKE(void) {

    DWORD    fh, readcnt;
    DWORD    codesize, zerosize, staksize;


    /// Open .KE file
    if( -1==(fh=Kopen("MAIN.KE", O_RDBIN)) ) {
        SystemMessage("MAIN.KE file not found");
        return FALSE;
    }
    /// Read .KE header
    if( 512!=(readcnt=Kread(fh, BytBuf, 512)) ) {
        SystemMessage("Error reading .KE file");
        Kclose(fh);
        return FALSE;
    }
    if( strcmp((char*)BytBuf+KEHED_MARKER, "KINT6") ) {
        SystemMessage("Not a KINT 6 .KE file");
        Kclose(fh);
        return FALSE;
    }
    if( (BytBuf[KEHED_MAJORREV] < 0)
     || (BytBuf[KEHED_MAJORREV] > INTERP_MAJORREV)
     || (BytBuf[KEHED_MAJORREV]==INTERP_MAJORREV
         && BytBuf[KEHED_MINORREV] > INTERP_MINORREV) ) {
        SystemMessage("Mismatched KINT.EXE and MAIN.KE files");
        Kclose(fh);
        return FALSE;
    }

    /// Get size of initialized code/data in file
    mainKE = BytBuf;        /// point mainKE at BytBuf TEMPORARILY so GETMEMD/SETMEMD work on BytBuf
    codesize = GETMEMD(KEHED_CODESIZE);
    zerosize = GETMEMD(KEHED_ZEROSIZE);
    staksize = GETMEMD(KEHED_STACKSIZE);
    HeapLen  = GETMEMD(KEHED_HEAPSIZE);
    /// Save pointer to base of stack
    SETMEMD(KEHED_SE, (DWORD)(codesize+zerosize));
    NonHeapLen = codesize+zerosize+staksize;
    SETMEMD(KEHED_SB, (DWORD)NonHeapLen);
    SETMEMD(KEHED_SP, (DWORD)NonHeapLen);

    /// Get size of memory required (init code/data size + uninit data size + stack size + HeapLen)
    /// NonHeapLen is the offset in mainKE of the start of the Heap, which grows upward, away from the Stack
    /// So, NonHeapLen+HeapLen is the current size of mainKE's allocated memory
    InitHeap();    /// create first dummy Heap entry

    /// Allocate .KE memory, set mainKE to its final REAL value
    if( NULL==(mainKE=(BYTE *)malloc(NonHeapLen+HeapLen)) ) {
        SystemMessage("Error allocating .KE memory");
        Kclose(fh);
        return FALSE;
    }
#if KDEBUG
{
DWORD    hFile;
sprintf(ScratBuf,"LoadKE malloc(%d)=[0x%8.8X]\n", NonHeapLen+HeapLen, mainKE);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, ScratBuf, strlen(ScratBuf));
Kclose(hFile);
}
#endif
    /// Copy first 512 bytes that we already read, and setup ptr for rest of reading
    memcpy(mainKE, BytBuf, 512);
    /// Read rest of .KE file into memory
    readcnt = Kread(fh, mainKE+512, codesize-512);
    Kclose(fh);
    if( readcnt!=codesize-512 ) return FALSE;
    /// Initialize uninitialized area to 0.
    memset(mainKE+codesize, 0, zerosize+staksize+HeapLen);    /// zero out everything but the code and initialized data

    *(BYTE*)(mainKE+0x0C3) = 0;    // clear "auto-run" flags (bit 0 is auto-export Help)
    *(BYTE*)(mainKE+0x0C4) = INTERP_MAJORREV;
    *(BYTE*)(mainKE+0x0C5) = INTERP_MINORREV;
    *(WORD*)(mainKE+0x0C6) = INTERP_MICROREV;

    /// Allocate one permanent, small Heap block as HeapPtrs[0], to prevent anyone else from ever having a 0 HANDLE.
    /// This way, a HANDLE of 0 can be used by others to mean... whatever they want, that is NOT a HANDLE.
#if KDEBUG
{
DWORD    hFile;
sprintf(ScratBuf,"LoadKE AllocHeap(4)\n");
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, ScratBuf, strlen(ScratBuf));
Kclose(hFile);
}
#endif
    fh = AllocHeap(4);
#if KDEBUG
{
DWORD    hFile;
sprintf(ScratBuf,"LoadKE handle=%d\n", fh);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, ScratBuf, strlen(ScratBuf));
Kclose(hFile);
}
#endif

    return TRUE;
}

///======================================================================
/// KE MESSAGING ROUTINES
///======================================================================

///==============================================================
/// Set up for calling interpreter
BOOL KEmsg(DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

    DWORD    sp;

/*    if( msg!=KMSG_POINTER_MOVE ) {
        sp = 0;    /// place holder for a breakpoint during development/debugging
    }
*/
    if( inKE ) NSLog(@"inKE KEmsg");
    inKE = true;
    
    if( (killpgm & 2) && msg!=KMSG_SHUTDOWN ) return FALSE;    /// if program is dying, ONLY pass on SHUT_DOWN message

    sp = GETMEMD(KEHED_SP);    /// get Stack Pointer
    if( sp-100 < GETMEMD(KEHED_SE) ) {
        SystemMessage("Out of stack");
        exit(1);
    }
    /// push args on stack for EventProc()
    sp -= 4;
    SETMEMD(sp, arg3);
    sp -= 4;
    SETMEMD(sp, arg2);
    sp -= 4;
    SETMEMD(sp, arg1);
    sp -= 4;
    SETMEMD(sp, msg);
    sp -= 4;
    SETMEMD(sp, 16);    /// push length of args
    sp -= 4;
    SETMEMD(sp, 0);        /// push dummy return address for EventProc()
    SETMEMD(KEHED_SP, sp);    /// save updated stack pointer
    SETMEMD(KEHED_PC, KEHED_EVENTPROC);    /// init the PC

    /// The EF opcde at the end of EventProc() will clean the above off the stack, but must check for return_address==0 and terminate interpretation.
    /// The return_address will be 0 for any EventProc() call, whether before (outside of) any MODBEG call/frame or not.
    /// See design7.txt for details on MODBEG/MODEND and the stack effects.

    ExecKE();    /// call K interpreter
    /// Any return value from the .KE code comes back in KEHED_EVENTVAL (see return below)
    /// KMSG_QUERY_QUIT returns 1 if it's okay to quit the program.
    /// All other cases return 0.
    /// The return value is then returned by KEmsg() (this function)

    if( HeapTop>HighestHeapTop ) HighestHeapTop = HeapTop;    // for checking whether our Heap is too small
    CompactHeap();

    inKE = false;
    /// Check if the .KE code has called it quits by setting killpgm==1
    /// If so, we set killpgm==3 to prevent successive calls to KillProgram().
    if( killpgm==1 ) {
        killpgm |= 2;
        KillProgram();
    }
    if( !killpgm && dirtyX1<dirtyX2 ) {
        InvDirty();
    }
    return (BOOL)GETMEMB(KEHED_EVENTVAL);
}

///=================================================================
/// Discard all KMSG_POINTER_MOVE and KMSG_TIMER messages,
/// then scan the message buffer and return the first KMSG_KEY_DOWN or KMSG_KEY_UP message,
/// removing it from the queue if *cmd==true at entry. Return FALSE if no key message waiting, else return TRUE.
BOOL KeyMsg(DWORD *cmd, DWORD *arg1, DWORD *arg2, DWORD *arg3) {

    DWORD    i, remit;

    remit = *cmd;
    *cmd = 0;
    // now find last POINTER_MOVE msg
    while( KINTmsgrem != KINTmsgadd && ((i=KINTmsgs[KINTmsgrem*4])==KMSG_POINTER_MOVE || i==KMSG_TIMER || i==KMSG_KEY_DOWN || i==KMSG_KEY_UP) ) {
        if( i==KMSG_KEY_DOWN || i==KMSG_KEY_UP ) {
            *cmd = KINTmsgs[KINTmsgrem*4];
            *arg1=KINTmsgs[KINTmsgrem*4+1];
            *arg2=KINTmsgs[KINTmsgrem*4+2];
            *arg3=KINTmsgs[KINTmsgrem*4+3];
            if( remit && ++KINTmsgrem >= MAXMSGS ) KINTmsgrem = 0;
            return TRUE;
        }
        if( ++KINTmsgrem >= MAXMSGS ) KINTmsgrem = 0;
    }
    return FALSE;
}

///=================================================================
/// Discard all KMSG_TIMER messages, then scan the message buffer,
/// discarding all leading KMSG_POINTER_MOVE messages except the last one
/// before the queue end OR a non-POINTER_MOVE message. Store that last
/// POINTER_MOVE message in the vars and return TRUE, or return FALSE if none.
BOOL PtrMsg(DWORD *cmd, DWORD *arg1, DWORD *arg2, DWORD *arg3) {

    *cmd = 0;
    while( KINTmsgrem != KINTmsgadd && (KINTmsgs[KINTmsgrem*4]==KMSG_POINTER_MOVE || KINTmsgs[KINTmsgrem*4]==KMSG_TIMER) ) {
        if( KINTmsgs[KINTmsgrem*4]==KMSG_POINTER_MOVE ) {
            *cmd  = KINTmsgs[KINTmsgrem*4];
            *arg1 = KINTmsgs[KINTmsgrem*4+1];
            *arg2 = KINTmsgs[KINTmsgrem*4+2];
            *arg3 = KINTmsgs[KINTmsgrem*4+3];
        }
        if( ++KINTmsgrem >= MAXMSGS ) KINTmsgrem = 0;
    }
    return( *cmd==KMSG_POINTER_MOVE );
}

///=========================================================
void AddMsg(DWORD cmd, DWORD arg1, DWORD arg2, DWORD arg3) {

    if( !inKE && (inSleep || !windowReady || TimerID==nil) ) {
        KINTnonTimer(cmd, arg1, arg2, arg3);
    } else if( !InSleep ) {
        KINTmsgs[KINTmsgadd*4] = cmd;
        KINTmsgs[KINTmsgadd*4+1] = arg1;
        KINTmsgs[KINTmsgadd*4+2] = arg2;
        KINTmsgs[KINTmsgadd*4+3] = arg3;
        ++KINTmsgadd;
        if( KINTmsgadd >= MAXMSGS ) KINTmsgadd = 0;
        if( KINTmsgadd == KINTmsgrem ) {
            --KINTmsgadd;
            if( KINTmsgadd < 0 ) KINTmsgadd = MAXMSGS-1;
        }
    }
}

///==========================================
void SendNextMsg(void) {

    DWORD    cmd, arg1, arg2, arg3;

    if( !InSleep && KINTmsgrem != KINTmsgadd ) {
        cmd  = KINTmsgs[KINTmsgrem*4];
        arg1 = KINTmsgs[KINTmsgrem*4+1];
        arg2 = KINTmsgs[KINTmsgrem*4+2];
        arg3 = KINTmsgs[KINTmsgrem*4+3];
        ++KINTmsgrem;
        if( KINTmsgrem >= MAXMSGS ) KINTmsgrem = 0;

        KEmsg(cmd, arg1, arg2, arg3);
    }
}

//******************************************************************
void SetPhysicalScreenSize (void)
{
#if FAKE_SCREEN_SIZE
    int width = FAKE_SCREEN_SIZE_W;
    int height = FAKE_SCREEN_SIZE_H;
#else
    // Get the resolution of the main display
    CGRect mainRect = CGDisplayBounds (kCGDirectMainDisplay);
    
    int height = mainRect.size.height;
    int width = 0;//mainRect.size.width;
    
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"mainScreenW=%d mainScreenH=%d)\n", width, height);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
    {
        NSArray *screens = [NSScreen screens];
        for(NSScreen *screen in screens) {
            int sw=(int)screen.frame.size.width;
            int sh=(int)screen.frame.size.height;
            width += sw;
            height = max(height, sh);

#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"screenW=%d screenH=%d)\n", (int)screenWidth, (int)screenHeight);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
       }
    }
    
#endif
    
    PhysicalScreenW = width;
    PhysicalScreenH = height;
}

///===============================================================
void SetupScreen(void) {

//    HDC        hDC;
//    RECT    rc;
//    int        maxw, maxh;

//    maxw = GetSystemMetrics(SM_CXVIRTUALSCREEN);
//    maxh = GetSystemMetrics(SM_CYVIRTUALSCREEN);

    if( scrBM.cgImage != NULL ) {
//    if( scrBM.hBitmap && (maxw>MaxScreenW || maxh>MaxScreenH) ) {
        DeleteSBM(&scrBM);
        scrBM.cgImage = NULL;

        FreeSysFonts();

        /// let game know we're quitting so it can save game, clean up
/****/    KEmsg(KMSG_QUERY_QUIT, 1, 0, 0);
        while( KINTmsgadd != KINTmsgrem ) SendNextMsg();
        KINTmsgadd = KINTmsgrem = 0;

        SystemMessage("Screen change: game ending, restart game");
        KillProgram();
        return;
    }
    /// create the scrBM screen bitmap.
    /// the KASM code does ALL of it's drawing to scrBM, a memory bitmap.
    /// when Windows needs to update the REAL screen, the WM_PAINT message
    /// in this program merely BitBlt's from scrBM to the screen DC.

    SetPhysicalScreenSize();
    MaxScreenW = PhysicalScreenW;
    MaxScreenH = PhysicalScreenH;
    
    ScreenW = PhysicalScreenW;
    ScreenH = PhysicalScreenH;

/*
    hDC = GetDC(NULL);
    ScreenW = GetDeviceCaps(hDC, HORZRES);
    ScreenH = GetDeviceCaps(hDC, VERTRES);
    ReleaseDC(NULL, hDC);
    if( hWndMain ) {
        GetClientRect(hWndMain, &rc);
        ClientW = rc.right - rc.left;
        ClientH = rc.bottom - rc.top;
    }
 */

    if( scrBM.cgImage==0 ) {
        ScreenW = PhysicalScreenW;
        ScreenH = PhysicalScreenH;
        if( !CreateSBM(&scrBM, MaxScreenW, MaxScreenH) ) {
            SystemMessage("Failed creating screen BITMAP. Terminating. So sorry!");
            exit(1);
        }
        wndW = MaxScreenW;
        wndH = MaxScreenH;
        InitSysFonts();
    }
    /// initialize the ENTIRE screen bitmap to black
    DrawRect(0, 0, 0, MaxScreenW, MaxScreenH, 0xFF000000, 0x00000000);

// call the SCREEN_CHANGE code in the KE module
//****/    AddMsg(KMSG_SCREEN_CHANGE, 0, 0, 0);
//    SendNextMsg();
}

///=====================================================================================
///=====================================================================================
///=====================================================================================
///
/// All HEAP functions
///
///=====================================================================================
///=====================================================================================
///=====================================================================================
/**=======================================================================
NonHeap memory starts at 0 in mainKE, the Heap starts at NonHeapLen offset
in mainKE, and the end of mainKE memory is at offset NonHeapLen+HeapLen.

Managing the Heap comprises two parts: 1) slicing up the Heap and
allocating parts of it on request, and 2) managing the Heap managers.

The Heap contains nothing but just straight blocks of memory. They're
allocated, organized, moved, and freed via the HeapPtrs[] structure.
The MAIN.KE program, when it requests memory from the heap, receives
a "heap handle" which is just an index into the "heap manager." When
the MAIN.KE program wants to actually ACCESS the allocated memory,
it must first LOCK the memory, at which point it receives a 'pointer'
to the memory, which is really just the offset from the base of mainKE
to the block of memory.

A Heap block is 'locked' via the LOCK opcode, which takes a HeapPtrs[]
index, locks the memory from being moved in the Heap, and returns
in R6 the offset from the start of mainKE to that block of memory. These
LOCK offsets ("pointers") should NOT be saved in global or static
variables (or only with great care), usually only in local (stack)
non-static variables, as the blocks get automatically 'unlocked' at
the end of an event if SP>lockedSP. They may also be manually 'unlocked'
with the UNLOCK opcode. LOCK saves the current SP in the HEAPPTR that
is locked. Entries in HeapPtrs[] are NEVER moved, as the index into
HeapPtrs[] is the HANDLE used for the memory block.

The HeapPtrs[] are kept in a separate malloc()'d memory block from the
mainKE memory block, so that it may be increased in size as necessary
during Heap allocation without forcing relative movement of Heap blocks
during interpretation of an Event.

All of the entries in HeapPtrs[] are linked into one of four 'chains' of
HeapPtrs (HPchain[4]): HPC_NONE, HPC_FREE, HPC_USED, HPC_LOCK.

Each of these four contain the index of the FIRST HeapPtr[] in that chain,
or -1 if the chain is empty. Each HeapPtr[] then has 'prev' and 'next'
entries that point backward and forward in the chain, with a value of -1
meaning "end of chain." Each HeapPtrs[] also contains a 'chain' member
which is set to the type of chain it's in.

InitHeap() malloc()'s the default array of HeapPtrs[] and then chains all
of them into HPchain[HPC_NONE], which is the chain of unused HeapPtrs[] entries.
During AllocHeap(), memory is 'found' on the Heap, and the entry from HPchain[HPC_NONE]
is used to point to (manage) it, with the 'next' HPchain[HPC_NONE]-chained HeapPtrs[]
moved into HPchain[HPC_NONE], and the newly allocated one chained in as the new
HPchain[HPC_USED] and linked 'next' to the old HPchain[HPC_USED]. When an HPchain[HPC_USED]
entry is LOCK'd, it is excised from the HPchain[HPC_USED] chain and inserted into
the HPchain[HPC_LOCK] chain. When a block is FreeHeap()'d, it is removed from
it's current chain (HPC_USED or HPC_LOCK) and added to the HPC_FREE chain. Blocks
on the HPC_FREE chain may get re-allocated during AllocHeap(), or may get deleted
entirely and their HeapPtrs[] entry moved to the HPC_NONE chain during Heap compaction.
Heap compaction only occurs outside of Events (when the MAIN.KE is not being
interpreted/executed). After EF and EFR opcodes finish popping the stack frame, they
go through the HPchain[HPC_LOCK] chain and unlock any HeapPtrs[] that have an 'sp' < SP
(which means that the function that locked them has terminated/returned to its caller).

=====================================================================================
*/

///=============================================
#define    HPC_NONE    0
#define    HPC_FREE    1
#define    HPC_USED    2
#define    HPC_LOCK    3

KLONG    HPchains[4];

/// NOTE: There must be NO absolute pointers in this structure, only offsets from mainKE!
typedef struct {
    DWORD    base;    /// offset from mainKE
    DWORD    actlen;    /// actual length of Heap block
    DWORD    loglen;    /// requested length of Heap block at time of allocation (loglen <= actlen)
    KLONG    prev;    /// index of the prev HEAPPTR in this chain (<0 if first)
    KLONG    next;    /// index of the next HEAPPTR in this chain (<0 if last)
    KLONG    chain;    /// which chain (HPC_NONE, HPC_FREE, HPC_USED, HPC_LOCK) this HEAPPTR is linked into
    DWORD    sp;        /// non-0 if LOCKED. If SP>HEAPPTR.sp at end of Event, HEAPPTR is automatically unlocked.
    DWORD    lockcnt;/// number of times this block has been locked. 'sp' only gets set on the FIRST lock request.
                    /// So, subsequent lock requests just get the 'base' ptr, and a FreeHeap() with lockcnt>1
                    /// is an error.
    KLONG    allprev;/// index of prev HEAPPTR when sorting by 'base' for compaction purposes
    KLONG    allnext;/// index of next HEAPPTR when sorting by 'base' for compaction purposes
    KLONG    free;    /// if a 'free' block (not being used)
} HEAPPTR;

#define    HPCNT    65536
HEAPPTR        HeapPtrs[HPCNT];    /// max 64K unique heap allocations at one time

///===================================================
void CompactHeap(void) {

    KLONG    ix, nx, px, c, first=-1, base, start;

    start = HeapTop;
    if( HeapLockedCnt || HPchains[HPC_LOCK]>=0 ) {
        SystemMessage("Hey, Dummy! You shouldn't have left blocks locked when CompactHeap() needs to run!");
        exit(1);
    }
    /// First, build linked list (via .allprev and .allnext) in 'base' address order of ALL allocated HeapPtrs
    /// Ignore HPC_NONE (no actual blocks there) and HPC_LOCKED (we checked above that there ARE NONE)
    for(c=HPC_FREE; c<=HPC_USED; c++) {
        for(ix=HPchains[c]; ix>=0; ix=HeapPtrs[ix].next) {
            HeapPtrs[ix].free = (c==HPC_FREE);
            if( first==-1 ) {
                /// this is the very first Heap block, so it goes in 'first', and it's allprev/allnext links point nowhere
                first = ix;
                HeapPtrs[ix].allprev = HeapPtrs[ix].allnext = -1;
            } else {
                /// this is NOT the first Heap block, so we start with the "prev index" pointing nowhere
                px = -1;
                /// then we search through the already linked list of base-sorted blocks until we find either the end (nx==-1) or the first block who's address is > THIS block's
                for(px=-1, nx=first; nx>=0 && HeapPtrs[ix].base > HeapPtrs[nx].base; px=nx, nx=HeapPtrs[nx].allnext) ;
                if( px==-1 ) {
                    /// THIS block has a lower address than the previous 'first' block, so add it to the FRONT of the chain
                    HeapPtrs[ix].allprev = -1;
                    HeapPtrs[ix].allnext = first;
                    first = ix;
                } else {
                    /// THIS block is either in the middle or on the end of the chain
                    HeapPtrs[ix].allprev = px;
                    HeapPtrs[ix].allnext = nx;
                    if( nx >= 0 ) HeapPtrs[nx].allprev = ix;
                    HeapPtrs[px].allnext = ix;
                }
            }
        }
    }

    /// Second, move any blocks down when there's a gap, adjusting HeapTop appropriately, changing 'free' blocks to 'none' blocks
    /// 'base' keeps track of the current "beginning of the moving hole of space being compacted".
    /// if 'base' is < HeapPtrs[ix].base, then the block needs to be moved down to 'base' and 'base' moved to the new (moved) HeapPtrs[ix].base + HeapPtrs[ix].actlen
    for(ix=first, base=HeapPtrs[ix].base; ix>=0; ix=HeapPtrs[ix].allnext) {
        if( HeapPtrs[ix].free ) {    /// HPC_FREE, throw it away and leave 'base' where it is
            /// unchain from HPchains[HPC_FREE] and chain into HPchains[HPC_NONE]
            UnchainHeap(ix);
            ChainHeap(ix, HPC_NONE);
        } else {                    /// HPC_USED, move block if needed, move 'base' above it
            if( base!=HeapPtrs[ix].base ) {    /// there's empty space below so, so move the block down
                memcpy(mainKE+base, mainKE+HeapPtrs[ix].base, HeapPtrs[ix].actlen);    // move the block down
                HeapPtrs[ix].base = base;    // update its new base address
            }
            /// update the new 'base' value
            base = HeapPtrs[ix].base + HeapPtrs[ix].actlen;
        }
    }
    HeapTop = base;
}

///===================================================
void ChainHeap(KLONG ix, KLONG chain) {

//    KLONG   *pHPchaings=HPchains;
//    KLONG   *pMaxScreenW=&MaxScreenW;
    
    if( ix>=0 && ix<HPCNT ) {
        HeapPtrs[ix].chain = chain;            /// set THIS block's chain membership
        HeapPtrs[ix].prev  = -1;            /// this will be the new "head of chain" block, so no 'previous' member
        HeapPtrs[ix].next  = HPchains[chain]; /// set this block's NEXT link to the old "head of chain"
        if( HPchains[chain]>=0 ) HeapPtrs[HPchains[chain]].prev = ix;/// set the old "head of chain"'s PREV link to THIS block
        HPchains[chain] = ix;                /// set new "head of chain" # to THIS block
    }
}

///===================================================
void UnchainHeap(KLONG ix) {

    if( ix>=0 && ix<HPCNT ) {
        /// if HeapPtrs[ix].prev<0 (==-1), it's the "head of chain"
        /// else it must have a valid .prev link to the block that is closer to "head of chain"
        if( HeapPtrs[ix].prev<0 ) HPchains[HeapPtrs[ix].chain] = HeapPtrs[ix].next;
        else HeapPtrs[HeapPtrs[ix].prev].next = HeapPtrs[ix].next;
        /// if HeapPtrs[ix].next >= 0, there's a following block that needs unlinked
        if( HeapPtrs[ix].next>=0 ) HeapPtrs[HeapPtrs[ix].next].prev = HeapPtrs[ix].prev;
        HeapPtrs[ix].prev = HeapPtrs[ix].next = -1;    /// not in a chain, so shouldn't point to a bogus .prev or .next blocks
    }
}

///==================================================
/// USE WITH GREAT RESPONSIBILITY, SPIDER-MAN!
DWORD GetHeapAdr(KLONG ix) {

   if( ix>=0 && ix<HPCNT ) {
        return HeapPtrs[ix].base;
    } else {
{
DWORD    hFile;
char    bbuf[128];
sprintf(bbuf,"====== GetHeapAdr(%d) FAILED! HPCNT=%d PC=0x%8.8X\n", (int)ix, HPCNT, (int)*(DWORD*)(mainKE+0x01F8));
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)bbuf, (DWORD)strlen(bbuf));
Kclose(hFile);
}
        SystemMessage("GetHeapAdr() failed");
    }
    return -1;
}

///==================================================
DWORD LockHeap(KLONG ix) {

    if( ix>=0 && ix<HPCNT ) {
        if( HeapPtrs[ix].lockcnt==0 ) {
            HeapPtrs[ix].sp = GETMEMD(KEHED_SP);
            UnchainHeap(ix);
            ChainHeap(ix, HPC_LOCK);
        }
        ++HeapPtrs[ix].lockcnt;

        return HeapPtrs[ix].base;
    } else {
{
DWORD    hFile;
char    bbuf[128];
sprintf(bbuf,"====== LockHeap(%d) FAILED! HPCNT=%d PC=0x%8.8X PCpreJSR=0x%8.8X\n", (int)ix, HPCNT, (int)(*(DWORD*)(mainKE+0x088)), (int)PCpreJSR);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)bbuf, (DWORD)strlen(bbuf));
Kclose(hFile);
}
        SystemMessage("LockHeap() failed");
    }
    return -1;
}

///==================================================
void UnlockHeap(KLONG ix) {

    if( ix>=0 && ix<HPCNT && HeapPtrs[ix].lockcnt ) {
        if( --HeapPtrs[ix].lockcnt==0 ) {
            HeapPtrs[ix].sp = 0;
            UnchainHeap(ix);
            ChainHeap(ix, HPC_USED);
        }
    } else if( ix>=0 && ix<HPCNT ) {

    } else {
        SystemMessage("UnlockHeap() bad index");
    }
}

///==================================================
/// When KINT needs a real pointer to a Heap object,
/// it calls GetHeapPtr(), which increments the HeapLockedCnt.
/// As long as HeapLockedCnt is non-zero, AllocHeap() will fail
/// because too many bugs will happen if some idiot gets a
/// hard pointer (rather than mainKE-relative) into the Heap,
/// and then calls (directly or indirectly) AllocHeap(), which
/// sooner or later will have to increase the size of the Heap,
/// which will do a realloc(mainKE), which will cause any
/// hard pointers into the Heap to suddenly be totally bogus. Like, totally.
///==================================================
void* GetHeapPtr(KLONG ix) {

    ++HeapLockedCnt;
    return (void*)(mainKE+LockHeap(ix));
}

///==================================================
/// NOTE: It's the idiot KINT programmer's responsibility
/// to make DAMNED sure that GetHeapPtr() and RelHeapPtr()
/// calls exist in pairs, surrounding any code that
/// accesses Heap memory!
void RelHeapPtr(KLONG ix) {

    --HeapLockedCnt;
    UnlockHeap(ix);
}

///==================================================
void FreeHeap(KLONG ix) {

    if( ix>=0 && ix<HPCNT ) {
        HeapPtrs[ix].lockcnt = 0;
        UnchainHeap(ix);
        ChainHeap(ix, HPC_FREE);
    } else {
//#if KDEBUG
{
DWORD    hFile;
char    bbuf[128];
sprintf(bbuf,"====== FreeHeap(%d) FAILED! HPCNT=%d PC=0x%8.8X\n", (int)ix, HPCNT, (unsigned int)(*(DWORD*)(mainKE+0x01F0)));
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)bbuf, (DWORD)strlen(bbuf));
Kclose(hFile);
}
//#endif
        SystemMessage("FreeHeap() failed");
    }
}

///============================================
/// Call ONCE, in LoadKE, to initialze the Heap, called BEFORE the mainKE memory is actually allocated, so don't do ANYTHING that refers to mainKE!
void InitHeap(void) {

    KLONG    i;

    HeapTop = NonHeapLen;        /// nothing allocated on heap to start with
    memset(HeapPtrs, 0, sizeof(HeapPtrs));

    /// initialize all HeapPtrs[] to HPC_NONE (nothing allocated to them) and linked into HPchains[HPC_NONE]
    HPchains[HPC_NONE] = HPchains[HPC_FREE] = HPchains[HPC_USED] = HPchains[HPC_LOCK] = -1;
    for(i=HPCNT-1; i>=0; i--) ChainHeap(i, HPC_NONE);
}

///===================================================
/// Fatal error, terminates, if unable to allocate (which it can't do if ANY Heap blocks are LOCKED, since the .
/// Else, returns HeapPtrs[] index for the memory, so, from the KINT interpreter's point of view:
///     hHeap = AllocHeap(somelen)
///        BYTE *pHeap = GetHeapPtr(hHeap)
/// will allocate some memory, lock it (preventing any further AllocHeaps() until RelHeapPtr()s have been done), and returns a real C ptr to the memory.
///
/// From the MAIN.KE code's point of view, it will do something like:
///        hHeap = HeapAlloc(somelen)
///        BYTE *pHeap = HeapLock(hHeap)
///
/// AllocHeap() either crashes and terminates, or else ALWAYS returns an index into HeapPtrs[].
///
//DWORD DbgHeapCnt=0;

DWORD AllocHeap(DWORD len) {

    KLONG    i;
//++DbgHeapCnt;
    /// First, make sure that KINT itself hasn't locked up the Heap by getting a REAL pointer into the Heap
    if( HeapLockedCnt ) {
        SystemMessage("Hey, Dummy! You can't AllocHeap() while you have a pointer INTO the Heap!");
        exit(1);
    }
    /// try to find an HPC_FREE chain block that is >=len and < len + min(1024, len)
    /// the "+ min(1024, len)" limits allocating REALLY large blocks of Heap to REALLY small requests.
    for(i=HPchains[HPC_FREE]; i>=0; i=HeapPtrs[i].next) if( HeapPtrs[i].actlen >= len && HeapPtrs[i].actlen < len + min(1024, len) ) break;
    if( i>=0 ) {    /// found re-usable block
        UnchainHeap(i);    /// remove this HeapPtr from its current chain
        ChainHeap(i, HPC_USED);    /// chain it into HPC_USED
        HeapPtrs[i].loglen = len;    /// set loglen to the length they requested (actlen continues to contain the REAL length, the rest is 'wasted' for now)
        HeapPtrs[i].lockcnt = 0;    /// not locked
        return i;
    }
    /// get an available HeapPtr from HPchains[HPC_NONE], realloc()'ing HeapPtrs if necessary
    if( HPchains[HPC_NONE]<0 ) {    /// none available, programmer failed to plan appropriately
        SystemMessage("Terminating: insufficient HeapPtrs. So sorry.");
        exit(1);
    }
    /// if not enough room for block at end of heap, programmer failed to plan appropriately
    if( NonHeapLen+HeapLen-HeapTop < len ) {
        SystemMessage("Terminating: insufficient Heap space. So sorry.");
        exit(1);
    }
    /// Unchain HPchains[HPC_NONE], set it up for new block, and chain it into HPchains[HPC_USED]
    i = HPchains[HPC_NONE];
    UnchainHeap(i);
    ChainHeap(i, HPC_USED);
    HeapPtrs[i].base = HeapTop;
    HeapTop += len;
    HeapPtrs[i].actlen = HeapPtrs[i].loglen = len;
    HeapPtrs[i].lockcnt = 0;
    return i;
}

///===================================================
/// ONLY called from EF/EFR opcode!
/// Goes through the HPC_LOCK chain, looking for blocks that can be auto-unlocked.
void AutoUnlockHeap(DWORD curSP) {

    KLONG    i;

    for(i=HPchains[HPC_LOCK]; i>=0; i=HeapPtrs[i].next) {
        /// if there's >= 1 lock on a Heap block, and the current SP is higher than when the FIRST lock was applied, then ALL locks must be removed
        if( HeapPtrs[i].lockcnt && HeapPtrs[i].sp<curSP ) {
            HeapPtrs[i].lockcnt = 1;
            UnlockHeap(i);
        }
    }
}

