//
//  kintKINT.m
//
//  Copyright (c) 2018 Everett Kaser. All rights reserved.
//

/*********************  Header Files  *********************/

#include <CoreFoundation/CoreFoundation.h>
#import <Cocoa/Cocoa.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>

#include <mach/mach_time.h>
#include <unistd.h>

#import "kintMAIN.h"
#import "kintPMACH.h"
#import "kintView.h"
#import "kintAppDelegate.h"

CFStringRef	gAppName;

@implementation kintKINT

@end

#include "kintMAIN.h"

void DoSys(void);

KLONG    SMODcnt=0;
KLONG    sslen[4]={1,2,4,8};
char    OSctrl_cmdSTR[32] = "Cmd";

char    lastMusic[1024]="";

NSTimer     *KINTmsgTimer=NULL;

DWORD        KINTmsgs[4*MAXMSGS];
KLONG        KINTmsgadd, KINTmsgrem;
DWORD    KINTptrmove[4];

//**************************************************************************
void SetAppDataPath(void) {
    
    CFURLRef pgmURL = NULL;

    // setup AppPath[]
    if( NULL!=(pgmURL = CFBundleCopyBundleURL (CFBundleGetMainBundle())) ) {
        CFURLGetFileSystemRepresentation(pgmURL, true, (UInt8 *)AppPath, sizeof(AppPath));
        CFRelease(pgmURL);
//        strcat(AppDataPath, "/");
    }
    // setup PgmPath[]
    if( NULL!=(pgmURL = CFBundleCopyResourcesDirectoryURL(CFBundleGetMainBundle())) ) {
        CFURLGetFileSystemRepresentation(pgmURL, true, (UInt8 *)PgmPath, sizeof(PgmPath));
        CFRelease(pgmURL);
        strcat(PgmPath, "/");
    }

    // setup AppDataPath[]
    gAppName = (CFStringRef)CFBundleGetValueForInfoDictionaryKey(CFBundleGetMainBundle(), CFSTR("EKSGameName"));

    // Look in ~/Library/Application Support/Everett Kaser Software/<EKSGameName>"

    NSFileManager* fm = [NSFileManager defaultManager];
    NSURL *dirPath = nil;
    NSArray *appSupportDir = [fm URLsForDirectory:NSApplicationSupportDirectory inDomains:NSUserDomainMask];
    if( [appSupportDir count] > 0 ) {
        dirPath = [[appSupportDir objectAtIndex:0] URLByAppendingPathComponent:@"Everett Kaser Software"];
        NSString *pPath=[[[dirPath path] stringByAppendingString:@"/"] stringByAppendingString:(__bridge NSString * _Nonnull)(gAppName)];
        [pPath getCString:AppDataPath maxLength:sizeof(AppDataPath) encoding:NSUTF8StringEncoding];
        strcat(AppDataPath, "/");
    }
//    NSLog(@"AppDataPath=%s",AppDataPath);
//    NSLog(@"AppPath=%s",AppPath);
//    NSLog(@"PgmPath=%s",PgmPath);
}

char SMbuf[1024];
DWORD smFLAG;
//********************************************************************
// Display the NULL-terminated message in 'pMem' using OS resources.
void SystemMessage(char *pMem) {
    
    if( smFLAG ) NSLog(@"smFLAG");
    if( strlen(pMem)>sizeof(SMbuf)-1 ) strncpy(SMbuf, pMem, sizeof(SMbuf)-1);
    else strcpy(SMbuf, pMem);
    
    if( NSThread.currentThread.isMainThread ) {
        smFLAG = false;
        NSAlert    *alert = [[NSAlert alloc] init];
        [alert addButtonWithTitle: @"Sigh"];
        [alert setMessageText:CFBridgingRelease(CFStringCreateWithCString(NULL, SMbuf, kCFStringEncodingMacRoman))];
        [alert setAlertStyle: NSAlertStyleWarning];
        [alert runModal];
        smFLAG = false;
    } else {
        smFLAG = true;
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            NSAlert    *alert = [[NSAlert alloc] init];
            [alert addButtonWithTitle: @"Sigh"];
            [alert setMessageText:CFBridgingRelease(CFStringCreateWithCString(NULL, SMbuf, kCFStringEncodingMacRoman))];
            [alert setAlertStyle: NSAlertStyleWarning];
            [alert runModal];
            smFLAG = false;
        }];
    }
    while( smFLAG )
        ;
}

//****************************************************************
// This function can return as much (well, up to 512 bytes including NUL)
// or as little information as you want regarding the current OS.  This
// information is ONLY used for display purposes within the Help, and
// does NOT affect the program execution in any other way.
DWORD KGetOSversion(BYTE *pMem) {

    if( @available(macOS 10.10, *) ) {
        NSOperatingSystemVersion ver = [[NSProcessInfo processInfo] operatingSystemVersion];
        sprintf((char *)pMem, "KINT %d.%d - Mac OS X %d.%d.%d", (int)INTERP_MAJORREV, (int)INTERP_MINORREV, (int)ver.majorVersion, (int)ver.minorVersion, (int)ver.patchVersion);
            // as written, this should handle up to OS X 99.99.99
            //        gOSXVersion32 = ((majorVersion / 10) << 20) |
            //        ((majorVersion % 10) << 16) |
            //        ((minorVersion / 10) << 12) |
            //        ((minorVersion % 10) << 8) |
            //        ((bugFixVersion / 10) << 4) |
            //        ((bugFixVersion % 10) << 0);
        return (DWORD)((ver.minorVersion<<24) | (ver.majorVersion<<16)) | 1;
    }
    return 1;
}

//************************************************
//* The K interpreter
//*        Event Kode must put return value into R39 before HALTing
//*
//* NOTE: "result" contains the KCPU "flags" for equality,
//*        least-significant bit, and most-significant bit.
//*        The "result" flags are set by these instructions:
//*            SHL SHR ROL ROR SUB B2I "RET 0" and "RET 1"
//*            AND XOR CMP INC DEC NOT NEG TST FCMP
//*        When the operation is a WORD or BYTE, the result
//*        is first cast to a SHORT or a CHAR before being
//*        cast to a DWORD in order to make sure that the
//*        most-significant bit gets propagated correctly.
//*
//*        The instructions that are affected by the 'signedmath' flag are:
//*            SHR, DIV, MOD, SUB, CMP
//*        The f--- floating point opcodes are ALWAYS signed operations.

//DWORD opcnts[256];
//DWORD minstack=64*1024;
//DWORD entryr7, entryr3;

KLONG    stklen[4]={2,2,4,8};
bool inKE=false;
bool windowReady=false;

DWORD    PCpreJSR;    // in case of crashes, gets us back one JSR from where the crash occurred. Might help.

#define    TRACE    1

#if TRACE
DWORD    TraceBuf[1024];
KLONG    TBix=0;
#endif

void ExecKE(void) {

    int        i;
    BYTE    b, FLAGS;
    DWORD    opcode;
    WORD    w;
    DWORD    dw, PC, SP, FP, dptr, aptr, *pdw1;
    QWORD    qw, *qwp;
    static    float    fv, *fvp, fv2;
    static    double    dv, *dvp, dv2;

    PC = GETMEMD(KEHED_PC);    /// get local copy of PC
    SP = GETMEMD(KEHED_SP);    /// get local copy of SP
    FP = GETMEMD(KEHED_FP);    /// get local copy of FP
    FLAGS = GETMEMB(KEHED_FLAGS);    /// get local copy of FLAGS

    while( TRUE ) {

        if( PC==0x056B84 ) {
            i = 3;
        }

#if TRACE
        TraceBuf[TBix++] = PC;
        if( TBix >= sizeof(TraceBuf)/sizeof(TraceBuf[0]) ) TBix = 0;
#endif
        opcode = GETMEMD(PC);
        PC += 4;

        switch( opcode & 0x3FF ) {
         case 0x000: case 0x080: case 0x100: case 0x180: case 0x200: case 0x280: case 0x300: case 0x380:    ///    B TLJ $,=x        (DWORD address)
            // get $ number from PC-immediate value, add 1 for NULL-ptr-register-offset, multiply by 8 (<<3)
            // get byte contents of that register $
            // set the flags based on that byte
            // skip the PC past the used-up register#
            SETSTSB(GETMEMB((GETMEMD(PC)+1)<<3));    /// set FLAGS
TLJ:
            PC += 4; // skip the PC past the used-up immediate value
         case 0x034: case 0x0B4: case 0x134: case 0x1B4: case 0x234: case 0x2B4: case 0x334: case 0x3B4:    /// LJ =x             (DWORD address)
            dw = ((opcode>>8) & 0x00FFFFFC);    // convert DWORD offset to BYTE offset into codeseg
            switch( opcode & 0x380 ) {    /// switch on condition
             case 0x000:        /// TLJEQ
                if( ISEQ ) PC = dw;
                break;
             case 0x080:        /// TLJNE
                if( ISNE ) PC = dw;
                break;
             case 0x100:        /// TLJGE
                if( ISGE ) PC = dw;
                break;
             case 0x180:        /// TLJGT
                if( ISGT ) PC = dw;
                break;
             case 0x200:        /// TLJLE
                if( ISLE ) PC = dw;
                break;
             case 0x280:        /// TLJLT
                if( ISLT ) PC = dw;
                break;
             case 0x300:        /// TLJEV
                if( ISEV ) PC = dw;
                break;
             case 0x380:        /// TLJOD
                if( ISOD ) PC = dw;
                break;
            }
            break;
         case 0x020: case 0x0A0: case 0x120: case 0x1A0: case 0x220: case 0x2A0: case 0x320: case 0x3A0:    ///    W TLJ $,=x        (DWORD address)
            SETSTSW(GETMEMW((GETMEMD(PC)+1)<<3));    /// set FLAGS
//            PC += 4;
            goto TLJ;
         case 0x040: case 0x0C0: case 0x140: case 0x1C0: case 0x240: case 0x2C0: case 0x340: case 0x3C0:    ///    D TLJ $,=x        (DWORD address)
            SETSTSD(GETMEMD((GETMEMD(PC)+1)<<3));    /// set FLAGS
//            PC += 4;
            goto TLJ;
         case 0x060: case 0x0E0: case 0x160: case 0x1E0: case 0x260: case 0x2E0: case 0x360: case 0x3E0:    ///    Q TLJ $,=x        (DWORD address)
            SETSTSQ(GETMEMQ((GETMEMD(PC)+1)<<3));    /// set FLAGS
//            PC += 4;
            goto TLJ;

         case 0x010: case 0x090: case 0x110: case 0x190: case 0x210: case 0x290: case 0x310: case 0x390:    ///    B TLJ [$],=x        (DWORD address)
            // get $ number from PC-immediate value, add 1 for NULL-ptr-register-offset, multiply by 8 (<<3)
            // get contents of that register [$]
            // get byte pointed to by the contents of that register
            // set the flags based on that byte
            SETSTSB(GETMEMB(GETMEMD((GETMEMD(PC)+1)<<3)));    /// set FLAGS
            goto TLJ;
         case 0x030: case 0x0B0: case 0x130: case 0x1B0: case 0x230: case 0x2B0: case 0x330: case 0x3B0:    ///    W TLJ [$],=x        (DWORD address)
            SETSTSW(GETMEMW(GETMEMD((GETMEMD(PC)+1)<<3)));    /// set FLAGS
            goto TLJ;
         case 0x050: case 0x0D0: case 0x150: case 0x1D0: case 0x250: case 0x2D0: case 0x350: case 0x3D0:    ///    D TLJ [$],=x        (DWORD address)
            SETSTSD(GETMEMD(GETMEMD((GETMEMD(PC)+1)<<3)));    /// set FLAGS
            goto TLJ;
         case 0x070: case 0x0F0: case 0x170: case 0x1F0: case 0x270: case 0x2F0: case 0x370: case 0x3F0:    ///    Q TLJ [$],=x        (DWORD address)
            SETSTSQ(GETMEMQ(GETMEMD((GETMEMD(PC)+1)<<3)));    /// set FLAGS
            goto TLJ;

         case 0x008: case 0x088: case 0x108: case 0x188: case 0x208: case 0x288: case 0x308: case 0x388:    ///    B TLJ [con],=x        (DWORD address)
            // get address (con) from PC-immediate value
            // get byte from that memory location [con]
            // set the flags based on that byte
            SETSTSB(GETMEMB(GETMEMD(PC)));    /// set FLAGS
            goto TLJ;
         case 0x028: case 0x0A8: case 0x128: case 0x1A8: case 0x228: case 0x2A8: case 0x328: case 0x3A8:    ///    W TLJ [con],=x        (DWORD address)
            SETSTSW(GETMEMW(GETMEMD(PC)));    /// set FLAGS
            goto TLJ;
         case 0x048: case 0x0C8: case 0x148: case 0x1C8: case 0x248: case 0x2C8: case 0x348: case 0x3C8:    ///    D TLJ [con],=x        (DWORD address)
            SETSTSD(GETMEMD(GETMEMD(PC)));    /// set FLAGS
            goto TLJ;
         case 0x068: case 0x0E8: case 0x168: case 0x1E8: case 0x268: case 0x2E8: case 0x368: case 0x3E8:    ///    Q TLJ [con],=x        (DWORD address)
            SETSTSQ(GETMEMQ(GETMEMD(PC)));    /// set FLAGS
            goto TLJ;

         case 0x018: case 0x098: case 0x118: case 0x198: case 0x218: case 0x298: case 0x318: case 0x398:    ///    B TLJ [FP][con],=x        (DWORD address)
            // get address (con) from PC-immediate value
            // get byte from that stack frame memory location [FP][con]
            // set the flags based on that byte
            SETSTSB(GETMEMB(FP+GETMEMD(PC)));    /// set FLAGS
            goto TLJ;
         case 0x038: case 0x0B8: case 0x138: case 0x1B8: case 0x238: case 0x2B8: case 0x338: case 0x3B8:    ///    W TLJ [FP][con],=x        (DWORD address)
            SETSTSW(GETMEMW(FP+GETMEMD(PC)));    /// set FLAGS
            goto TLJ;
         case 0x058: case 0x0D8: case 0x158: case 0x1D8: case 0x258: case 0x2D8: case 0x358: case 0x3D8:    ///    D TLJ [FP][con],=x        (DWORD address)
            SETSTSD(GETMEMD(FP+GETMEMD(PC)));    /// set FLAGS
            goto TLJ;
         case 0x078: case 0x0F8: case 0x178: case 0x1F8: case 0x278: case 0x2F8: case 0x378: case 0x3F8:    ///    Q TLJ [FP][con],=x        (DWORD address)
            SETSTSQ(GETMEMQ(FP+GETMEMD(PC)));    /// set FLAGS
            goto TLJ;

         case 0x004: case 0x024: case 0x044: case 0x064: case 0x084: case 0x0A4: case 0x0C4: case 0x0E4:
         case 0x104: case 0x124: case 0x144: case 0x164: case 0x184: case 0x1A4: case 0x1C4: case 0x1E4:
         case 0x204: case 0x224: case 0x244: case 0x264: case 0x284: case 0x2A4: case 0x2C4: case 0x2E4:
         case 0x304: case 0x324: case 0x344: case 0x364: case 0x384: case 0x3A4: case 0x3C4: case 0x3E4:
            goto badop; /// unused
         case 0x014:    /// DBG ($15 = address of string for KINT to output)
                {
                    DWORD   hFile;
                    char    *pBuf;
                    
                    pBuf = (char*)(mainKE + GETMEMD(KEHED_R15));
                    if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
                    Kseek(hFile, 0, SEEK_END);
                    Kwrite(hFile, (BYTE*)pBuf, (DWORD)strlen(pBuf));
                    Kclose(hFile);

                }
                break;
         case 0x094: /// unused
               goto badop;
         case 0x114:    /// SYS
            /// $15 = address of arguments
            /// If there is a return value, it must be in $14 (or $14 must be a pointer to whatever).
            DoSys();
            break;
         case 0x194:    /// BRK
             dw = 1;
            /// NOP for now. May be of use if a debugger is added
            break;
         case 0x214:    /// TERM
            /// ONLY to be used if the MAIN.KE program encounters a FATAL error it can't keep running after.
            /// This will signal KINT that it needs to die. KINT will not send ANY further messages to MAIN.KE
            /// EXCEPT for KMSG_SHUTDOWN.
            killpgm |= 1;
            PC -= 4;        // move back to the TERM opcode, just for safety
            goto stopint;
         case 0x294:    /// NOP
            // nothing to do
            break;
         case 0x314:    /// SMOD
            SP -= 8*16;
            memcpy(mainKE+SP, mainKE+KEHED_R0, 8*16);    // push all 16 general registers
            SP -= 4;
            SETMEMD(SP, PC);        // save PC
            SP -= 4;
            SETMEMD(SP, FP);        // save FP
            SP -= 4;
            SETMEMD(SP, GETMEMD(KEHED_MP));    // save MP
            SETMEMD(KEHED_MP, SP);            // MP = SP
            ++SMODcnt;                        // bump modal count
            goto stopint;                    // done of now, we're in modal mode
         case 0x394:    /// EMOD
            if( SMODcnt<1 ) {
                sprintf((char*)TmpPath, "Illegal EMOD at 0x%8.8X", (unsigned int)GETMEMD(KEHED_PC));
                SystemMessage((char*)TmpPath);
                goto stopint;
            }
            --SMODcnt;                        // decrease the MOD count
            SP = GETMEMD(KEHED_MP);            // SP = MP
            SETMEMD(KEHED_MP, GETMEMD(SP));                // pop MP
            SP += 4;
            FP = GETMEMD(SP);                // pop FP
            SP += 4;
            PC = GETMEMD(SP);                // pop PC
            SP += 4;
            memcpy(mainKE+KEHED_R0, mainKE+SP, 8*16);    // pop all 16 general registers
            SP += 8*16;
            break;                            // resume interpretation from right after the original SMOD instruction

         case 0x254:    /// EFR r (where 'r' is the register restore count, starting at $13-r+1 and working upward)
            dw = (opcode>>10) & 0x0F;    // get saved register count
            memcpy(mainKE+8*(1+13-dw+1), mainKE+SP, 8*dw);
            SP = FP;            // mov SP,FP
            FP = GETMEMD(SP);    // pop FP
            SP += 4;
            PC = GETMEMD(SP);    // pop PC (return address)
            SP += 4;
            SP += 4+GETMEMD(SP);// throw away size of function arguments and function arguments
            AutoUnlockHeap(SP);    // unlock locked Heap blocks who's function is finishing
            if( PC==0 ) goto stopint;    // if end of EventProc() (only time popped return address should be 0! Otherwise, bug, and you deserve to crash and burn) R6 should have already been loaded by the "return xxx" that led us here.
            break;
         case 0x154:    /// SFVR var_local_size,reg_save_count (starting at $13 and working downward)
            SP -= 4;
            SETMEMD(SP, FP);    // push FP
            FP = SP;            // mov FP,SP
            SP -= (opcode>>14);    // get size of local variables and allocate them
            dw = (opcode>>10) & 0x0F;    // get save register count
            SP -= 8*dw;
            memcpy(mainKE+SP, mainKE+8*(1+13-dw+1), 8*dw);
            break;

         case 0x354:    /// JSRFR f,$
             PCpreJSR = PC;
            dw = (opcode>>16);    // get argument size
            SP -= 4;
            SETMEMD(SP, dw);    // push size of args
            dw = GETMEMD((((opcode>>12)&0x0F)+1)<<3);    // get target address from register
            SP -= 4;
            SETMEMD(SP, PC);    // push return address
            PC = dw;            // change PC to target
            break;
         case 0x054:    /// JSRFR f,=con    (BYTE address)
             PCpreJSR = PC;
            dw = (opcode>>16);    // get argument size
            SP -= 4;
            SETMEMD(SP, dw);    // push size of args
            dw = GETMEMD(PC);    // get target address
            PC += 4;
            SP -= 4;
            SETMEMD(SP, PC);    // push return address
            PC = dw;            // change PC to target
            break;

         case 0x074:    /// B PUSH =con
         case 0x174:    /// W PUSH =con
            dw = GETMEMD(PC);
            PC += 4;
            SP -= 2;
            SETMEMW(SP, (WORD)dw);
            break;
         case 0x274:    /// D PUSH =con
            dw = GETMEMD(PC);
            PC += 4;
            SP -= 4;
            SETMEMD(SP, dw);
            break;
         case 0x374:    /// Q PUSH =con
            qw = GETMEMQ(PC);
            PC += 8;
            SP -= 8;
            SETMEMQ(SP, qw);
            break;

         case 0x0F4:
         case 0x1F4:    /// B/W PUSHS from (-2M) to (+2M-1)
            w = (WORD)(DWORD)(((KLONG)opcode)>>10);    /// get the value with sign-extension in the upper bits
            SP -= 2;
            SETMEMW(SP, w);
            break;
         case 0x2F4:    /// D PUSHS from (-2M) to (+2M-1)
            dw = (DWORD)(((KLONG)opcode)>>10);    /// get the value with sign-extension in the upper bits
            SP -= 4;
            SETMEMD(SP, dw);
            break;
         case 0x3F4:    /// Q PUSHS from (-2M) to (+2M-1)
            qw = (QWORD)(int64_t)(((KLONG)opcode)>>10);    /// get the value with sign-extension in the upper bits
            SP -= 8;
            SETMEMQ(SP, qw);
            break;

         case 0x00C: case 0x04C: case 0x08C: case 0x0CC: case 0x10C: case 0x14C: case 0x18C: case 0x1CC:
         case 0x20C: case 0x24C: case 0x28C: case 0x2CC: case 0x30C: case 0x34C: case 0x38C: case 0x3CC:    /// JMP [$][x]        where "[x]" is optional, and is absolute address in DWORDS (defaults to 0 if not present)
            PC = GETMEMD(GETMEMD(8*(1+((opcode>>6)&0x0F))) + ((opcode>>10)<<2));    // jump to $ contents plus 'x'
            break;
         case 0x02C:    /// where 'x' is absolute address in DWORDS
            PC = ((opcode>>10)<<2);    // jump to 'x'
            break;

         case 0x0D4:    /// B OP1 $    (NEGF/NEG/NOT/TST/PUSH/POP/PEA/x/CVUU/CVSS/CVUF/CVSF/CVUD/CVSD/CVFS/CVDS/CVFD/CVDF/x/x/x/x/x/x)
         case 0x1D4:    /// W OP1 $    (NEGF/NEG/NOT/TST/PUSH/POP/PEA/x/CVUU/CVSS/CVUF/CVSF/CVUD/CVSD/CVFS/CVDS/CVFD/CVDF/x/x/x/x/x/x)
         case 0x2D4:    /// D OP1 $    (NEGF/NEG/NOT/TST/PUSH/POP/PEA/x/CVUU/CVSS/CVUF/CVSF/CVUD/CVSD/CVFS/CVDS/CVFD/CVDF/x/x/x/x/x/x)
         case 0x3D4:    /// Q OP1 $    (NEGF/NEG/NOT/TST/PUSH/POP/PEA/x/CVUU/CVSS/CVUF/CVSF/CVUD/CVSD/CVFS/CVDS/CVFD/CVDF/x/x/x/x/x/x)
            dptr = 8*(1+(opcode>>16));
            goto op1;
         case 0x0AC:    /// B OP1 [FP][con16]
         case 0x1AC:    /// W OP1 [FP][con16]
         case 0x2AC:    /// D OP1 [FP][con16]
         case 0x3AC:    /// Q OP1 [FP][con16]
            dptr = FP + (DWORD)(((KLONG)(opcode & 0xFFFF0000))>>16);
            goto op1;
         case 0x06C:    /// B OP1 [$][con]
         case 0x16C:    /// W OP1 [$][con]
         case 0x26C:    /// D OP1 [$][con]
         case 0x36C:    /// Q OP1 [$][con]
            dptr = GETMEMD(8*(1+((opcode>>16)&0x0F))) + GETMEMD(PC);
            PC += 4;
            goto op1;
         case 0x0EC:    /// B OP1 [con]
         case 0x1EC:    /// B OP1 [con]
         case 0x2EC:    /// B OP1 [con]
         case 0x3EC:    /// B OP1 [con]
            dptr = GETMEMD(PC);
            PC += 4;
op1:
            switch( (opcode>>8)&0x07F ) {
             case 0:    /// B NEGF
             case 1:    /// W NEGF
                goto floatsize;
             case 2:    /// D NEGF
                dw = GETMEMD(dptr);
                fv = *((float*)&dw);
                fv = -fv;
                dw = *((DWORD*)&fv);
                SETMEMD(dptr, dw);
                break;
             case 3:    /// Q NEGF
                qw = GETMEMQ(dptr);
                dv = *((double*)&qw);
                dv = -dv;
                qw = *((QWORD*)&dv);
                SETMEMD(dptr, qw);
                break;
             case 4:    /// B NEG
                SETMEMB(dptr, -(char)GETMEMB(dptr));
                break;
             case 5:    /// W NEG
                SETMEMW(dptr, -(short)GETMEMW(dptr));
                break;
             case 6:    /// D NEG
                SETMEMD(dptr, -(KLONG)GETMEMD(dptr));
                break;
             case 7:    /// Q NEG
                SETMEMQ(dptr, -(int64_t)GETMEMQ(dptr));
                break;
             case 8:    /// B NOT
                b = ~GETMEMB(dptr);
                SETMEMB(dptr, b);
                SETSTSB(b);
                break;
             case 9:    /// W NOT
                w = ~GETMEMW(dptr);
                SETMEMW(dptr, w);
                SETSTSW(w);
                break;
             case 10:    /// D NOT
                dw = ~GETMEMD(dptr);
                SETMEMD(dptr, dw);
                SETSTSD(dw);
                break;
             case 11:    /// Q NOT
                qw = ~GETMEMQ(dptr);
                SETMEMQ(dptr, qw);
                SETSTSQ(qw);
                break;

             case 12:    /// B TST
                SETSTSB(GETMEMB(dptr));
                break;
             case 13:    /// W TST
                SETSTSW(GETMEMW(dptr));
                break;
             case 14:    /// D TST
                SETSTSD(GETMEMD(dptr));
                break;
             case 15:    /// Q TST
                SETSTSQ(GETMEMQ(dptr));
                break;

             case 16:    /// B PUSH
                SP -= 2;
                SETMEMW(SP, (WORD)GETMEMB(dptr));    // never push BYTE on stack, always at least WORD
                break;
             case 17:    /// W PUSH
                SP -= 2;
                SETMEMW(SP, GETMEMW(dptr));
                break;
             case 18:    /// D PUSH
                SP -= 4;
                SETMEMD(SP, GETMEMD(dptr));
                break;
             case 19:    /// Q PUSH
                SP -= 8;
                SETMEMQ(SP, GETMEMQ(dptr));
                break;

             case 20:    /// B POP
                SETMEMB(dptr, GETMEMB(SP));
                SP += 2;
                break;
             case 21:    /// W POP
                SETMEMW(dptr, GETMEMW(SP));
                SP += 2;
                break;
             case 22:    /// D POP
                SETMEMD(dptr, GETMEMD(SP));
                SP += 4;
                break;
             case 23:    /// Q POP
                SETMEMQ(dptr, GETMEMQ(SP));
                SP += 8;
                break;

             case 24:    /// B PEA
             case 25:    /// W PEA
             case 26:    /// D PEA
             case 27:    /// Q PEA
                SP -= 4;
                SETMEMD(SP, dptr);
                break;

             case 28:    /// B
             case 29:    /// W
             case 30:    /// D
             case 31:    /// Q
                goto badop;

             case 32:    /// B CVUU
                SETMEMQ(dptr, (QWORD)(BYTE)GETMEMB(dptr));
                break;
             case 33:    /// W CVUU
                SETMEMQ(dptr, (QWORD)(WORD)GETMEMW(dptr));
                break;
             case 34:    /// D CVUU
                SETMEMQ(dptr, (QWORD)(DWORD)GETMEMD(dptr));
                break;
             case 35:    /// Q CVUU
                break;

             case 36:    /// B CVSS
                SETMEMQ(dptr, (QWORD)(int64_t)(char)GETMEMB(dptr));
                break;
             case 37:    /// W CVSS
                SETMEMQ(dptr, (QWORD)(int64_t)(short)GETMEMW(dptr));
                break;
             case 38:    /// D CVSS
                SETMEMQ(dptr, (QWORD)(int64_t)(KLONG)GETMEMD(dptr));
                break;
             case 39:    /// Q CVSS
                break;

             case 40:    /// B CVUF
                qw = (QWORD)(BYTE)GETMEMB(dptr);
cvuf:
                SETMEMQ(dptr, 0);
                fv = (float)qw;
                pdw1 = (DWORD*)&fv;
                SETMEMD(dptr, *pdw1);
                break;
             case 41:    /// W CVUF
                qw = (QWORD)(WORD)GETMEMW(dptr);
                goto cvuf;
             case 42:    /// D CVUF
                qw = (QWORD)(DWORD)GETMEMD(dptr);
                goto cvuf;
             case 43:    /// Q CVUF
                qw = (QWORD)GETMEMQ(dptr);
                goto cvuf;

             case 44:    /// B CVSF
                qw = (QWORD)(int64_t)(char)GETMEMB(dptr);
cvsf:
                SETMEMQ(dptr, 0);
                fv = (float)(int64_t)qw;
                pdw1 = (DWORD*)&fv;
                SETMEMD(dptr, *pdw1);
                break;
             case 45:    /// W CVSF
                qw = (QWORD)(int64_t)(short)GETMEMW(dptr);
                goto cvsf;
             case 46:    /// D CVSF
                qw = (QWORD)(int64_t)(KLONG)GETMEMD(dptr);
                goto cvsf;
             case 47:    /// Q CVSF
                qw = (QWORD)(int64_t)GETMEMQ(dptr);
                goto cvsf;

             case 48:    /// B CVUD
                qw = (QWORD)(BYTE)GETMEMB(dptr);
cvud:
                dv = (double)qw;
                qwp = (QWORD*)&dv;
                SETMEMQ(dptr, *qwp);
                break;
             case 49:    /// W CVUD
                qw = (QWORD)(WORD)GETMEMW(dptr);
                goto cvud;
             case 50:    /// D CVUD
                qw = (QWORD)(DWORD)GETMEMD(dptr);
                goto cvud;
             case 51:    /// Q CVUD
                qw = (QWORD)GETMEMQ(dptr);
                goto cvud;

             case 52:    /// B CVSD
                qw = (QWORD)(int64_t)(char)GETMEMB(dptr);
cvsd:
                dv = (double)(int64_t)qw;
                qwp = (QWORD*)&dv;
                SETMEMQ(dptr, *qwp);
                break;
             case 53:    /// W CVSD
                qw = (QWORD)(int64_t)(short)GETMEMW(dptr);
                goto cvsd;
             case 54:    /// D CVSD
                qw = (QWORD)(int64_t)(KLONG)GETMEMD(dptr);
                goto cvsd;
             case 55:    /// Q CVSD
                qw = (QWORD)(int64_t)GETMEMQ(dptr);
                goto cvsd;

             case 56:    /// B CVFS
             case 57:    /// W CVFS
             case 58:    /// D CVFS
             case 59:    /// Q CVFS
                dw = GETMEMD(dptr);
                fvp = (float*)&dw;
                fv = *fvp;
                SETMEMQ(dptr, (QWORD)(int64_t)fv);
                break;

             case 60:    /// B CVDS
             case 61:    /// W CVDS
             case 62:    /// D CVDS
             case 63:    /// Q CVDS
                qw = GETMEMQ(dptr);
                dvp = (double*)&qw;
                dv = *dvp;
                SETMEMQ(dptr, (QWORD)(int64_t)dv);
                break;

             case 64:    /// B CVFD
             case 65:    /// W CVFD
             case 66:    /// D CVFD
             case 67:    /// Q CVFD
                dw = GETMEMD(dptr);
                fvp = (float*)&dw;
                fv = *fvp;
                dv = (double)fv;
                dvp = &dv;
                qw = *(QWORD*)dvp;
                SETMEMQ(dptr, qw);
                break;

             case 68:    /// B CVDF
             case 69:    /// W CVDF
             case 70:    /// D CVDF
             case 71:    /// Q CVDF
                qw = GETMEMQ(dptr);
                dvp = (double*)&qw;
                dv = *dvp;
                SETMEMD(dptr, (DWORD)(float)dv);
                break;
             case 72: case 73: case 74: case 75: case 76: case 77: case 78: case 79:
             case 80: case 81: case 82: case 83: case 84: case 85: case 86: case 87:
             case 88: case 89: case 90: case 91: case 92: case 93: case 94: case 95:
             case 96: case 97: case 98: case 99: case 100: case 101: case 102: case 103:
             case 104: case 105: case 106: case 107: case 108: case 109: case 110: case 111:
             case 112: case 113: case 114: case 115: case 116: case 117: case 118: case 119:
             case 120: case 121: case 122: case 123: case 124: case 125: case 126: case 127:
                goto badop;
            }
            break;
         case 0x01C: case 0x03C: case 0x05C: case 0x07C: case 0x09C: case 0x0BC: case 0x0DC: case 0x0FC:
         case 0x11C: case 0x13C: case 0x15C: case 0x17C: case 0x19C: case 0x1BC: case 0x1DC: case 0x1FC:
         case 0x21C: case 0x23C: case 0x25C: case 0x27C: case 0x29C: case 0x2BC: case 0x2DC: case 0x2FC:
         case 0x31C: case 0x33C: case 0x35C: case 0x37C: case 0x39C: case 0x3BC: case 0x3DC: case 0x3FC:
            /// OP2 $,$
            dptr = (((opcode>>5) & 0x0F)+1)<<3;
            aptr = (((opcode>>16) & 0x0F)+1)<<3;
            goto op2;
         case 0x002: case 0x022: case 0x042: case 0x062: case 0x082: case 0x0A2: case 0x0C2: case 0x0E2:
         case 0x102: case 0x122: case 0x142: case 0x162: case 0x182: case 0x1A2: case 0x1C2: case 0x1E2:
         case 0x202: case 0x222: case 0x242: case 0x262: case 0x282: case 0x2A2: case 0x2C2: case 0x2E2:
         case 0x302: case 0x322: case 0x342: case 0x362: case 0x382: case 0x3A2: case 0x3C2: case 0x3E2:
            /// OP2 [$][con],$
            dptr = GETMEMD((((opcode>>5) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            aptr = (((opcode>>16) & 0x0F)+1)<<3;
            goto op2;
         case 0x012: case 0x032: case 0x052: case 0x072: case 0x092: case 0x0B2: case 0x0D2: case 0x0F2:
         case 0x112: case 0x132: case 0x152: case 0x172: case 0x192: case 0x1B2: case 0x1D2: case 0x1F2:
         case 0x212: case 0x232: case 0x252: case 0x272: case 0x292: case 0x2B2: case 0x2D2: case 0x2F2:
         case 0x312: case 0x332: case 0x352: case 0x372: case 0x392: case 0x3B2: case 0x3D2: case 0x3F2:
            /// OP2 $,[$][con]
            dptr = (((opcode>>5) & 0x0F)+1)<<3;
            aptr = GETMEMD((((opcode>>16) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            goto op2;
         case 0x00A: case 0x02A: case 0x04A: case 0x06A: case 0x08A: case 0x0AA: case 0x0CA: case 0x0EA:
         case 0x10A: case 0x12A: case 0x14A: case 0x16A: case 0x18A: case 0x1AA: case 0x1CA: case 0x1EA:
         case 0x20A: case 0x22A: case 0x24A: case 0x26A: case 0x28A: case 0x2AA: case 0x2CA: case 0x2EA:
         case 0x30A: case 0x32A: case 0x34A: case 0x36A: case 0x38A: case 0x3AA: case 0x3CA: case 0x3EA:
            /// OP2 [$][con],[$][con]
            dptr = GETMEMD((((opcode>>5) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            aptr = GETMEMD((((opcode>>16) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            goto op2;
         case 0x01A: case 0x03A: case 0x05A: case 0x07A: case 0x09A: case 0x0BA: case 0x0DA: case 0x0FA:
         case 0x11A: case 0x13A: case 0x15A: case 0x17A: case 0x19A: case 0x1BA: case 0x1DA: case 0x1FA:
         case 0x21A: case 0x23A: case 0x25A: case 0x27A: case 0x29A: case 0x2BA: case 0x2DA: case 0x2FA:
         case 0x31A: case 0x33A: case 0x35A: case 0x37A: case 0x39A: case 0x3BA: case 0x3DA: case 0x3FA:
            /// OP2 $,[con]
            dptr = (((opcode>>5) & 0x0F)+1)<<3;
            aptr = GETMEMD(PC);
            PC += 4;
            goto op2;
         case 0x006: case 0x026: case 0x046: case 0x066: case 0x086: case 0x0A6: case 0x0C6: case 0x0E6:
         case 0x106: case 0x126: case 0x146: case 0x166: case 0x186: case 0x1A6: case 0x1C6: case 0x1E6:
         case 0x206: case 0x226: case 0x246: case 0x266: case 0x286: case 0x2A6: case 0x2C6: case 0x2E6:
         case 0x306: case 0x326: case 0x346: case 0x366: case 0x386: case 0x3A6: case 0x3C6: case 0x3E6:
            /// OP2 [$][con],[con]
            dptr = GETMEMD((((opcode>>5) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            aptr = GETMEMD(PC);
            PC += 4;
            goto op2;
         case 0x016: case 0x036: case 0x056: case 0x076: case 0x096: case 0x0B6: case 0x0D6: case 0x0F6:
         case 0x116: case 0x136: case 0x156: case 0x176: case 0x196: case 0x1B6: case 0x1D6: case 0x1F6:
         case 0x216: case 0x236: case 0x256: case 0x276: case 0x296: case 0x2B6: case 0x2D6: case 0x2F6:
         case 0x316: case 0x336: case 0x356: case 0x376: case 0x396: case 0x3B6: case 0x3D6: case 0x3F6:
            /// OP2 $,=con
            dptr = (((opcode>>5) & 0x0F)+1)<<3;
            aptr = KEHED_CONSTN;
            if( (opcode & 0x00000600)==0x00000600 ) {
                SETMEMQ(aptr, GETMEMQ(PC));
                PC += 8;
            } else {
                SETMEMD(aptr, GETMEMD(PC));
                PC += 4;
            }
            goto op2;
         case 0x00E: case 0x02E: case 0x04E: case 0x06E: case 0x08E: case 0x0AE: case 0x0CE: case 0x0EE:
         case 0x10E: case 0x12E: case 0x14E: case 0x16E: case 0x18E: case 0x1AE: case 0x1CE: case 0x1EE:
         case 0x20E: case 0x22E: case 0x24E: case 0x26E: case 0x28E: case 0x2AE: case 0x2CE: case 0x2EE:
         case 0x30E: case 0x32E: case 0x34E: case 0x36E: case 0x38E: case 0x3AE: case 0x3CE: case 0x3EE:
            /// OP2 [$][con],=con
            dptr = GETMEMD((((opcode>>5) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            aptr = KEHED_CONSTN;
            if( (opcode & 0x00000600)==0x00000600 ) {
                SETMEMQ(aptr, GETMEMQ(PC));
                PC += 8;
            } else {
                SETMEMD(aptr, GETMEMD(PC));
                PC += 4;
            }
            goto op2;
         case 0x01E: case 0x03E: case 0x05E: case 0x07E: case 0x09E: case 0x0BE: case 0x0DE: case 0x0FE:
         case 0x11E: case 0x13E: case 0x15E: case 0x17E: case 0x19E: case 0x1BE: case 0x1DE: case 0x1FE:
         case 0x21E: case 0x23E: case 0x25E: case 0x27E: case 0x29E: case 0x2BE: case 0x2DE: case 0x2FE:
         case 0x31E: case 0x33E: case 0x35E: case 0x37E: case 0x39E: case 0x3BE: case 0x3DE: case 0x3FE:
            /// OP2 $,=sCon (sss is -8 to +7)
            dptr = (((opcode>>5) & 0x0F)+1)<<3;
            aptr = KEHED_CONSTN;
            dw = (opcode>>16)&0x0F;    // get small constant
            if( dw & 8 ) {
                dw |= 0xFFFFFFF0;    // sign-extend if negative
            }
            if( (opcode & 0x00000600)==0x00000600 ) {    // if QWORD size
                SETMEMQ(aptr, (QWORD)(int64_t)dw);
            } else {
                SETMEMD(aptr, dw);
            }
            goto op2;
         case 0x001: case 0x021: case 0x041: case 0x061: case 0x081: case 0x0A1: case 0x0C1: case 0x0E1:
         case 0x101: case 0x121: case 0x141: case 0x161: case 0x181: case 0x1A1: case 0x1C1: case 0x1E1:
         case 0x201: case 0x221: case 0x241: case 0x261: case 0x281: case 0x2A1: case 0x2C1: case 0x2E1:
         case 0x301: case 0x321: case 0x341: case 0x361: case 0x381: case 0x3A1: case 0x3C1: case 0x3E1:
            /// OP2 [$][con],=sCon (sss is -8 to +7)
            dptr = GETMEMD((((opcode>>5) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            aptr = KEHED_CONSTN;
            dw = (opcode>>16)&0x0F;    // get small constant
            if( dw & 8 ) {
                dw |= 0xFFFFFFF0;    // sign-extend if negative
            }
            if( (opcode & 0x00000600)==0x00000600 ) {    // if QWORD size
                SETMEMQ(aptr, (QWORD)(int64_t)dw);
            } else {
                SETMEMD(aptr, dw);
            }
            goto op2;
         case 0x011: case 0x031: case 0x051: case 0x071: case 0x091: case 0x0B1: case 0x0D1: case 0x0F1:
         case 0x111: case 0x131: case 0x151: case 0x171: case 0x191: case 0x1B1: case 0x1D1: case 0x1F1:
         case 0x211: case 0x231: case 0x251: case 0x271: case 0x291: case 0x2B1: case 0x2D1: case 0x2F1:
         case 0x311: case 0x331: case 0x351: case 0x371: case 0x391: case 0x3B1: case 0x3D1: case 0x3F1:
            /// OP2 $,[FP][con16]
            dptr = (((opcode>>5) & 0x0F)+1)<<3;
            aptr = (DWORD)((KLONG)FP + (((KLONG)opcode) >> 16));
            goto op2;
         case 0x009: case 0x029: case 0x049: case 0x069: case 0x089: case 0x0A9: case 0x0C9: case 0x0E9:
         case 0x109: case 0x129: case 0x149: case 0x169: case 0x189: case 0x1A9: case 0x1C9: case 0x1E9:
         case 0x209: case 0x229: case 0x249: case 0x269: case 0x289: case 0x2A9: case 0x2C9: case 0x2E9:
         case 0x309: case 0x329: case 0x349: case 0x369: case 0x389: case 0x3A9: case 0x3C9: case 0x3E9:
            /// OP2 [$][con],[FP][con16]
            dptr = GETMEMD((((opcode>>5) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            aptr = (DWORD)((KLONG)FP + (((KLONG)opcode) >> 16));
            goto op2;
         case 0x019: case 0x039: case 0x059: case 0x079: case 0x099: case 0x0B9: case 0x0D9: case 0x0F9:
         case 0x119: case 0x139: case 0x159: case 0x179: case 0x199: case 0x1B9: case 0x1D9: case 0x1F9:
         case 0x219: case 0x239: case 0x259: case 0x279: case 0x299: case 0x2B9: case 0x2D9: case 0x2F9:
         case 0x319: case 0x339: case 0x359: case 0x379: case 0x399: case 0x3B9: case 0x3D9: case 0x3F9:
            /// OP2 [con],$
            dptr = GETMEMD(PC);
            PC += 4;
            aptr = (((opcode>>5) & 0x0F)+1)<<3;
            goto op2;
         case 0x005: case 0x025: case 0x045: case 0x065: case 0x085: case 0x0A5: case 0x0C5: case 0x0E5:
         case 0x105: case 0x125: case 0x145: case 0x165: case 0x185: case 0x1A5: case 0x1C5: case 0x1E5:
         case 0x205: case 0x225: case 0x245: case 0x265: case 0x285: case 0x2A5: case 0x2C5: case 0x2E5:
         case 0x305: case 0x325: case 0x345: case 0x365: case 0x385: case 0x3A5: case 0x3C5: case 0x3E5:
            /// OP2 [con],[$][con]
            dptr = GETMEMD(PC);
            PC += 4;
            aptr = GETMEMD((((opcode>>5) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            goto op2;
         case 0x015: case 0x035: case 0x055: case 0x075: case 0x095: case 0x0B5: case 0x0D5: case 0x0F5:
         case 0x115: case 0x135: case 0x155: case 0x175: case 0x195: case 0x1B5: case 0x1D5: case 0x1F5:
         case 0x215: case 0x235: case 0x255: case 0x275: case 0x295: case 0x2B5: case 0x2D5: case 0x2F5:
         case 0x315: case 0x335: case 0x355: case 0x375: case 0x395: case 0x3B5: case 0x3D5: case 0x3F5:
            /// OP2 [con],[con]
            dptr = GETMEMD(PC);
            PC += 4;
            aptr = GETMEMD(PC);
            PC += 4;
            goto op2;
         case 0x00D: case 0x02D: case 0x04D: case 0x06D: case 0x08D: case 0x0AD: case 0x0CD: case 0x0ED:
         case 0x10D: case 0x12D: case 0x14D: case 0x16D: case 0x18D: case 0x1AD: case 0x1CD: case 0x1ED:
         case 0x20D: case 0x22D: case 0x24D: case 0x26D: case 0x28D: case 0x2AD: case 0x2CD: case 0x2ED:
         case 0x30D: case 0x32D: case 0x34D: case 0x36D: case 0x38D: case 0x3AD: case 0x3CD: case 0x3ED:
            /// OP2 [con],=con
            dptr = GETMEMD(PC);
            PC += 4;
            aptr = KEHED_CONSTN;
            if( (opcode & 0x00000600)==0x00000600 ) {
                SETMEMQ(aptr, GETMEMQ(PC));
                PC += 8;
            } else {
                SETMEMD(aptr, GETMEMD(PC));
                PC += 4;
            }
            goto op2;
         case 0x01D: case 0x03D: case 0x05D: case 0x07D: case 0x09D: case 0x0BD: case 0x0DD: case 0x0FD:
         case 0x11D: case 0x13D: case 0x15D: case 0x17D: case 0x19D: case 0x1BD: case 0x1DD: case 0x1FD:
         case 0x21D: case 0x23D: case 0x25D: case 0x27D: case 0x29D: case 0x2BD: case 0x2DD: case 0x2FD:
         case 0x31D: case 0x33D: case 0x35D: case 0x37D: case 0x39D: case 0x3BD: case 0x3DD: case 0x3FD:
            /// OP2 [con],=sCon (sss is -8 to +7)
            dptr = GETMEMD(PC);
            PC += 4;
            aptr = KEHED_CONSTN;
            dw = (opcode>>5)&0x0F;    // get small constant
            if( dw & 8 ) {
                dw |= 0xFFFFFFF0;    // sign-extend if negative
            }
            if( (opcode & 0x00000600)==0x00000600 ) {    // if QWORD size
                SETMEMQ(aptr, (QWORD)(int64_t)dw);
            } else {
                SETMEMD(aptr, dw);
            }
            goto op2;
         case 0x003: case 0x023: case 0x043: case 0x063: case 0x083: case 0x0A3: case 0x0C3: case 0x0E3:
         case 0x103: case 0x123: case 0x143: case 0x163: case 0x183: case 0x1A3: case 0x1C3: case 0x1E3:
         case 0x203: case 0x223: case 0x243: case 0x263: case 0x283: case 0x2A3: case 0x2C3: case 0x2E3:
         case 0x303: case 0x323: case 0x343: case 0x363: case 0x383: case 0x3A3: case 0x3C3: case 0x3E3:
            /// OP2 [con],[FP][con16]
            dptr = GETMEMD(PC);
            PC += 4;
            aptr = (DWORD)((KLONG)FP + (((KLONG)opcode) >> 16));
            goto op2;
         case 0x013: case 0x033: case 0x053: case 0x073: case 0x093: case 0x0B3: case 0x0D3: case 0x0F3:
         case 0x113: case 0x133: case 0x153: case 0x173: case 0x193: case 0x1B3: case 0x1D3: case 0x1F3:
         case 0x213: case 0x233: case 0x253: case 0x273: case 0x293: case 0x2B3: case 0x2D3: case 0x2F3:
         case 0x313: case 0x333: case 0x353: case 0x373: case 0x393: case 0x3B3: case 0x3D3: case 0x3F3:
            /// OP2 [FP][con16],$
            dptr = (DWORD)((KLONG)FP + (((KLONG)opcode) >> 16));
            aptr = (((opcode>>5) & 0x0F)+1)<<3;
            goto op2;
         case 0x00B: case 0x02B: case 0x04B: case 0x06B: case 0x08B: case 0x0AB: case 0x0CB: case 0x0EB:
         case 0x10B: case 0x12B: case 0x14B: case 0x16B: case 0x18B: case 0x1AB: case 0x1CB: case 0x1EB:
         case 0x20B: case 0x22B: case 0x24B: case 0x26B: case 0x28B: case 0x2AB: case 0x2CB: case 0x2EB:
         case 0x30B: case 0x32B: case 0x34B: case 0x36B: case 0x38B: case 0x3AB: case 0x3CB: case 0x3EB:
            /// OP2 [FP][con16],[$][con]
            dptr = (DWORD)((KLONG)FP + (((KLONG)opcode) >> 16));
            aptr = GETMEMD((((opcode>>5) & 0x0F)+1)<<3) + GETMEMD(PC);
            PC += 4;
            goto op2;
         case 0x01B: case 0x03B: case 0x05B: case 0x07B: case 0x09B: case 0x0BB: case 0x0DB: case 0x0FB:
         case 0x11B: case 0x13B: case 0x15B: case 0x17B: case 0x19B: case 0x1BB: case 0x1DB: case 0x1FB:
         case 0x21B: case 0x23B: case 0x25B: case 0x27B: case 0x29B: case 0x2BB: case 0x2DB: case 0x2FB:
         case 0x31B: case 0x33B: case 0x35B: case 0x37B: case 0x39B: case 0x3BB: case 0x3DB: case 0x3FB:
            /// OP2 [FP][con16],[con]
            dptr = (DWORD)((KLONG)FP + (((KLONG)opcode) >> 16));
            aptr = GETMEMD(PC);
            PC += 4;
            goto op2;
         case 0x007: case 0x027: case 0x047: case 0x067: case 0x087: case 0x0A7: case 0x0C7: case 0x0E7:
         case 0x107: case 0x127: case 0x147: case 0x167: case 0x187: case 0x1A7: case 0x1C7: case 0x1E7:
         case 0x207: case 0x227: case 0x247: case 0x267: case 0x287: case 0x2A7: case 0x2C7: case 0x2E7:
         case 0x307: case 0x327: case 0x347: case 0x367: case 0x387: case 0x3A7: case 0x3C7: case 0x3E7:
            /// OP2 [FP][con16],=con
            dptr = (DWORD)((KLONG)FP + (((KLONG)opcode) >> 16));
            aptr = KEHED_CONSTN;
            if( (opcode & 0x00000600)==0x00000600 ) {
                SETMEMQ(aptr, GETMEMQ(PC));
                PC += 8;
            } else {
                SETMEMD(aptr, GETMEMD(PC));
                PC += 4;
            }
            goto op2;
         case 0x017: case 0x037: case 0x057: case 0x077: case 0x097: case 0x0B7: case 0x0D7: case 0x0F7:
         case 0x117: case 0x137: case 0x157: case 0x177: case 0x197: case 0x1B7: case 0x1D7: case 0x1F7:
         case 0x217: case 0x237: case 0x257: case 0x277: case 0x297: case 0x2B7: case 0x2D7: case 0x2F7:
         case 0x317: case 0x337: case 0x357: case 0x377: case 0x397: case 0x3B7: case 0x3D7: case 0x3F7:
            /// OP2 [FP][con16],=sCON (sss is -8 to +7)
            dptr = (DWORD)((KLONG)FP + (((KLONG)opcode) >> 16));
            aptr = KEHED_CONSTN;
            dw = (opcode>>5)&0x0F;    // get small constant
            if( dw & 8 ) {
                dw |= 0xFFFFFFF0;    // sign-extend if negative
            }
            if( (opcode & 0x00000600)==0x00000600 ) {    // if QWORD size
                SETMEMQ(aptr, (QWORD)(int64_t)dw);
            } else {
                SETMEMD(aptr, dw);
            }
            goto op2;
         case 0x00F: case 0x02F: case 0x04F: case 0x06F: case 0x08F: case 0x0AF: case 0x0CF: case 0x0EF:
         case 0x10F: case 0x12F: case 0x14F: case 0x16F: case 0x18F: case 0x1AF: case 0x1CF: case 0x1EF:
         case 0x20F: case 0x22F: case 0x24F: case 0x26F: case 0x28F: case 0x2AF: case 0x2CF: case 0x2EF:
         case 0x30F: case 0x32F: case 0x34F: case 0x36F: case 0x38F: case 0x3AF: case 0x3CF: case 0x3EF:
            /// OP2 [FP][con16],[FP][con]
            dptr = (DWORD)((KLONG)FP + (((KLONG)opcode) >> 16));
            aptr = FP + GETMEMD(PC);
            PC += 4;
op2:
            switch( (opcode>>9)&0x7F ) {
             case 0:    /// B DIVI
                SETMEMB(dptr, (BYTE)((char)GETMEMB(dptr)/(char)GETMEMB(aptr)));
                break;
             case 1:    /// W DIVI
                SETMEMW(dptr, (WORD)((short)GETMEMW(dptr)/(short)GETMEMW(aptr)));
                break;
             case 2:    /// D DIVI
                SETMEMD(dptr, (DWORD)((KLONG)GETMEMD(dptr)/(KLONG)GETMEMD(aptr)));
                break;
             case 3:    /// Q DIVI
                SETMEMQ(dptr, (QWORD)((int64_t)GETMEMQ(dptr)/(int64_t)GETMEMQ(aptr)));
                break;
             case 4:    /// B MODI
                SETMEMB(dptr, (BYTE)((char)GETMEMB(dptr)%(char)GETMEMB(aptr)));
                break;
             case 5:    /// W MODI
                SETMEMW(dptr, (WORD)((short)GETMEMW(dptr)%(short)GETMEMW(aptr)));
                break;
             case 6:    /// D MODI
                SETMEMD(dptr, (DWORD)((KLONG)GETMEMD(dptr)%(KLONG)GETMEMD(aptr)));
                break;
             case 7:    /// Q MODI
                SETMEMQ(dptr, (QWORD)((int64_t)GETMEMQ(dptr)%(int64_t)GETMEMQ(aptr)));
                break;
             case 8:    /// B RSHI
                b = (BYTE)((char)GETMEMB(dptr)>>GETMEMB(aptr));
                SETMEMB(dptr, b);
                SETSTSB(b);
                break;
             case 9:    /// W RSHI
                w = (WORD)((short)GETMEMW(dptr)>>GETMEMB(aptr));
                SETMEMW(dptr, w);
                SETSTSW(w);
                break;
             case 10:    /// D RSHI
                dw = (DWORD)((KLONG)GETMEMD(dptr)>>GETMEMB(aptr));
                SETMEMD(dptr, dw);
                SETSTSD(dw);
                break;
             case 11:    /// Q RSHI
                qw = (QWORD)((int64_t)GETMEMQ(dptr)>>GETMEMB(aptr));
                SETMEMQ(dptr, qw);
                SETSTSQ(qw);
                break;
             case 12:    /// B DIVU
                SETMEMB(dptr, (BYTE)GETMEMB(dptr)/(BYTE)GETMEMB(aptr));
                break;
             case 13:    /// W DIVU
                SETMEMW(dptr, (WORD)GETMEMW(dptr)/(WORD)GETMEMW(aptr));
                break;
             case 14:    /// D DIVU
                SETMEMD(dptr, (DWORD)GETMEMD(dptr)/(DWORD)GETMEMD(aptr));
                break;
             case 15:    /// Q DIVU
                SETMEMQ(dptr, (QWORD)GETMEMQ(dptr)/(QWORD)GETMEMQ(aptr));
                break;
             case 16:    /// B MODU
                SETMEMB(dptr, (BYTE)GETMEMB(dptr)%(BYTE)GETMEMB(aptr));
                break;
             case 17:    /// W MODU
                SETMEMW(dptr, (WORD)GETMEMW(dptr)%(WORD)GETMEMW(aptr));
                break;
             case 18:    /// D MODU
                SETMEMD(dptr, (DWORD)GETMEMD(dptr)%(DWORD)GETMEMD(aptr));
                break;
             case 19:    /// Q MODU
                SETMEMQ(dptr, (QWORD)GETMEMQ(dptr)%(QWORD)GETMEMQ(aptr));
                break;
             case 20:    /// B RSHU
                b = (BYTE)GETMEMB(dptr)>>GETMEMB(aptr);
                SETMEMB(dptr, b);
                SETSTSB(b);
                break;
             case 21:    /// W RSHU
                w = (WORD)GETMEMW(dptr)>>GETMEMB(aptr);
                SETMEMW(dptr, w);
                SETSTSW(w);
                break;
             case 22:    /// D RSHU
                dw = (DWORD)GETMEMD(dptr)>>GETMEMB(aptr);
                SETMEMD(dptr, dw);
                SETSTSD(dw);
                break;
             case 23:    /// Q RSHU
                qw = (QWORD)GETMEMQ(dptr)>>GETMEMB(aptr);
                SETMEMQ(dptr, qw);
                SETSTSQ(qw);
                break;
             case 24:    /// B ADD
                SETMEMB(dptr, (BYTE)GETMEMB(dptr)+(BYTE)GETMEMB(aptr));
                break;
             case 25:    /// W ADD
                SETMEMW(dptr, (WORD)GETMEMW(dptr)+(WORD)GETMEMW(aptr));
                break;
             case 26:    /// D ADD
                SETMEMD(dptr, (DWORD)GETMEMD(dptr)+(DWORD)GETMEMD(aptr));
                break;
             case 27:    /// Q ADD
                SETMEMQ(dptr, (QWORD)GETMEMQ(dptr)+(QWORD)GETMEMQ(aptr));
                break;
             case 28:    /// B SUB
                b = (BYTE)GETMEMB(dptr)-(BYTE)GETMEMB(aptr);
                SETMEMB(dptr, b);
                SETSTSB(b);
                break;
             case 29:    /// W SUB
                w = (WORD)GETMEMW(dptr)-(WORD)GETMEMW(aptr);
                SETMEMW(dptr, w);
                SETSTSW(w);
                break;
             case 30:    /// D SUB
                dw = (DWORD)GETMEMD(dptr)-(DWORD)GETMEMD(aptr);
                SETMEMD(dptr, dw);
                SETSTSD(dw);
                break;
             case 31:    /// Q SUB
                qw = (QWORD)GETMEMQ(dptr)-(QWORD)GETMEMQ(aptr);
                SETMEMQ(dptr, qw);
                SETSTSQ(qw);
                break;
             case 32:    /// B CMP
                b = (BYTE)GETMEMB(dptr)-(BYTE)GETMEMB(aptr);
                SETSTSB(b);
                break;
             case 33:    /// W CMP
                w = (WORD)GETMEMW(dptr)-(WORD)GETMEMW(aptr);
                SETSTSW(w);
                break;
             case 34:    /// D CMP
                dw = (DWORD)GETMEMD(dptr)-(DWORD)GETMEMD(aptr);
                SETSTSD(dw);
                break;
             case 35:    /// Q CMP
                qw = (QWORD)GETMEMQ(dptr)-(QWORD)GETMEMQ(aptr);
                SETSTSQ(qw);
                break;
             case 36:    /// B MUL
                SETMEMB(dptr, (BYTE)GETMEMB(dptr)*(BYTE)GETMEMB(aptr));
                break;
             case 37:    /// W MUL
                SETMEMW(dptr, (WORD)GETMEMW(dptr)*(WORD)GETMEMW(aptr));
                break;
             case 38:    /// D MUL
                SETMEMD(dptr, (DWORD)GETMEMD(dptr)*(DWORD)GETMEMD(aptr));
                break;
             case 39:    /// Q MUL
                SETMEMQ(dptr, (QWORD)GETMEMQ(dptr)*(QWORD)GETMEMQ(aptr));
                break;
             case 40:    /// B TST
                b = (BYTE)GETMEMB(dptr)&(BYTE)GETMEMB(aptr);
                SETSTSB(b);
                break;
             case 41:    /// W TST
                w = (WORD)GETMEMW(dptr)&(WORD)GETMEMW(aptr);
                SETSTSW(w);
                break;
             case 42:    /// D TST
                dw = (DWORD)GETMEMD(dptr)&(DWORD)GETMEMD(aptr);
                SETSTSD(dw);
                break;
             case 43:    /// Q TST
                qw = (QWORD)GETMEMQ(dptr)&(QWORD)GETMEMQ(aptr);
                SETSTSQ(qw);
                break;
             case 44:    /// B LSH
                b = (BYTE)GETMEMB(dptr)<<GETMEMB(aptr);
                SETMEMB(dptr, b);
                SETSTSB(b);
                break;
             case 45:    /// W LSH
                w = (WORD)GETMEMW(dptr)<<GETMEMB(aptr);
                SETMEMW(dptr, w);
                SETSTSW(w);
                break;
             case 46:    /// D LSH
                dw = (DWORD)GETMEMD(dptr)<<GETMEMB(aptr);
                SETMEMD(dptr, dw);
                SETSTSD(dw);
                break;
             case 47:    /// Q LSH
                qw = (QWORD)GETMEMQ(dptr)<<GETMEMB(aptr);
                SETMEMQ(dptr, qw);
                SETSTSQ(qw);
                break;
             case 48:    /// B AND
                b = (BYTE)GETMEMB(dptr)&(BYTE)GETMEMB(aptr);
                SETMEMB(dptr, b);
                SETSTSB(b);
                break;
             case 49:    /// W AND
                w = (WORD)GETMEMW(dptr)&(WORD)GETMEMW(aptr);
                SETMEMW(dptr, w);
                SETSTSW(w);
                break;
             case 50:    /// D AND
                dw = (DWORD)GETMEMD(dptr)&(DWORD)GETMEMD(aptr);
                SETMEMD(dptr, dw);
                SETSTSD(dw);
                break;
             case 51:    /// Q AND
                qw = (QWORD)GETMEMQ(dptr)&(QWORD)GETMEMQ(aptr);
                SETMEMQ(dptr, qw);
                SETSTSQ(qw);
                break;
             case 52:    /// B OR
                SETMEMB(dptr, (BYTE)GETMEMB(dptr)|(BYTE)GETMEMB(aptr));
                break;
             case 53:    /// W OR
                SETMEMW(dptr, (WORD)GETMEMW(dptr)|(WORD)GETMEMW(aptr));
                break;
             case 54:    /// D OR
                SETMEMD(dptr, (DWORD)GETMEMD(dptr)|(DWORD)GETMEMD(aptr));
                break;
             case 55:    /// Q OR
                SETMEMQ(dptr, (QWORD)GETMEMQ(dptr)|(QWORD)GETMEMQ(aptr));
                break;
             case 56:    /// B XOR
                b = (BYTE)GETMEMB(dptr)^(BYTE)GETMEMB(aptr);
                SETMEMB(dptr, b);
                SETSTSB(b);
                break;
             case 57:    /// W XOR
                w = (WORD)GETMEMW(dptr)^(WORD)GETMEMW(aptr);
                SETMEMW(dptr, w);
                SETSTSW(w);
                break;
             case 58:    /// D XOR
                dw = (DWORD)GETMEMD(dptr)^(DWORD)GETMEMD(aptr);
                SETMEMD(dptr, dw);
                SETSTSD(dw);
                break;
             case 59:    /// Q XOR
                qw = (QWORD)GETMEMQ(dptr)^(QWORD)GETMEMQ(aptr);
                SETMEMQ(dptr, qw);
                SETSTSQ(qw);
                break;
             case 60:    /// B MOV
                SETMEMB(dptr, GETMEMB(aptr));
                break;
             case 61:    /// W MOV
                SETMEMW(dptr, GETMEMW(aptr));
                break;
             case 62:    /// D MOV
                SETMEMD(dptr, GETMEMD(aptr));
                break;
             case 63:    /// Q MOV
                SETMEMQ(dptr, GETMEMQ(aptr));
                break;
             case 64:    /// B MOVZ
                SETMEMQ(dptr, (QWORD)GETMEMB(aptr));
                break;
             case 65:    /// W MOVZ
                SETMEMQ(dptr, (QWORD)GETMEMW(aptr));
                break;
             case 66:    /// D MOVZ
                SETMEMQ(dptr, (QWORD)GETMEMD(aptr));
                break;
             case 67:    /// Q MOVZ
                SETMEMQ(dptr, GETMEMQ(aptr));
                break;
             case 68:    /// B ADDF
floatsize:
                sprintf((char*)TmpPath, "BYTE/WORD size illegal for FLOAT/DOUBLE at 0x%8.8X", (unsigned int)GETMEMD(KEHED_PC));
                SystemMessage((char*)TmpPath);
                break;
             case 69:    /// W ADDF
                goto floatsize;
             case 70:    /// D ADDF
                dw = GETMEMD(dptr);
                fv = *((float*)&dw);
                dw = GETMEMD(aptr);
                fv2= *((float*)&dw);
                fv += fv2;
                dw = *((DWORD*)&fv);
                SETMEMD(dptr, dw);
                break;
             case 71:    /// Q ADDF
                qw = GETMEMQ(dptr);
                dv = *((double*)&qw);
                qw = GETMEMQ(aptr);
                dv2= *((double*)&qw);
                dv += dv2;
                qw = *((QWORD*)&dv);
                SETMEMQ(dptr, qw);
                break;
             case 72:    /// B SUBF
                goto floatsize;
             case 73:    /// W SUBF
                goto floatsize;
             case 74:    /// D SUBF
                dw = GETMEMD(dptr);
                fv = *((float*)&dw);
                dw = GETMEMD(aptr);
                fv2= *((float*)&dw);
                fv -= fv2;
                dw = *((DWORD*)&fv);
                SETMEMD(dptr, dw);
                SETMEMB(KEHED_FLAGS, ((fv<0)?4:0) | ((fv==0.0)?2:0));
                break;
             case 75:    /// Q SUBF
                qw = GETMEMQ(dptr);
                dv = *((double*)&qw);
                qw = GETMEMQ(aptr);
                dv2= *((double*)&qw);
                dv -= dv2;
                qw = *((QWORD*)&dv);
                SETMEMQ(dptr, qw);
                SETMEMB(KEHED_FLAGS, ((dv<0)?4:0) | ((dv==0.0)?2:0));
                break;
             case 76:    /// B MULF
                goto floatsize;
             case 77:    /// W MULF
                goto floatsize;
             case 78:    /// D MULF
                dw = GETMEMD(dptr);
                fv = *((float*)&dw);
                dw = GETMEMD(aptr);
                fv2= *((float*)&dw);
                fv *= fv2;
                dw = *((DWORD*)&fv);
                SETMEMD(dptr, dw);
                break;
             case 79:    /// Q MULF
                qw = GETMEMQ(dptr);
                dv = *((double*)&qw);
                qw = GETMEMQ(aptr);
                dv2= *((double*)&qw);
                dv *= dv2;
                qw = *((QWORD*)&dv);
                SETMEMQ(dptr, qw);
                break;
             case 80:    /// B DIVF
                goto floatsize;
             case 81:    /// W DIVF
                goto floatsize;
             case 82:    /// D DIVF
                dw = GETMEMD(dptr);
                fv = *((float*)&dw);
                dw = GETMEMD(aptr);
                fv2= *((float*)&dw);
                fv /= fv2;
                dw = *((DWORD*)&fv);
                SETMEMD(dptr, dw);
                break;
             case 83:    /// Q DIVF
                qw = GETMEMQ(dptr);
                dv = *((double*)&qw);
                qw = GETMEMQ(aptr);
                dv2= *((double*)&qw);
                dv /= dv2;
                qw = *((QWORD*)&dv);
                SETMEMQ(dptr, qw);
                break;
             case 84:    /// B CMPF
                goto floatsize;
             case 85:    /// W CMPF
                goto floatsize;
             case 86:    /// D CMPF
                dw = GETMEMD(dptr);
                fv = *((float*)&dw);
                dw = GETMEMD(aptr);
                fv2= *((float*)&dw);
                fv -= fv2;
                SETMEMB(KEHED_FLAGS, ((fv<0)?4:0) | ((fv==0.0)?2:0));
                break;
             case 87:    /// Q CMPF
                qw = GETMEMQ(dptr);
                dv = *((double*)&qw);
                qw = GETMEMQ(aptr);
                dv2= *((double*)&qw);
                dv -= dv2;
                SETMEMB(KEHED_FLAGS, ((dv<0)?4:0) | ((dv==0.0)?2:0));
                break;
             case 88:    /// B LEA
             case 89:    /// W LEA
             case 90:    /// D LEA
             case 91:    /// Q LEA
                SETMEMD(dptr, aptr);
                break;
             case 92:    /// B MEMMOV
                dw = 1;
                goto domemmov;
             case 93:    /// W MEMMOV
                dw = 2;
                goto domemmov;
             case 94:    /// D MEMMOV
                dw = 4;
                goto domemmov;
             case 95:    /// Q MEMMOV
                dw = 8;
domemmov:
                 dw *= GETMEMD(0xB8);        // get ML (move count) * sizeof_operation
                 memmove(mainKE+dptr, mainKE+aptr, dw);
                break;
             case 96:    ///
             case 97:    ///
             case 98:    ///
             case 99:    ///
             case 100:    ///
             case 101:    ///
             case 102:    ///
             case 103:    ///
             case 104:    ///
             case 105:    ///
             case 106:    ///
             case 107:    ///
             case 108:    ///
             case 109:    ///
             case 110:    ///
             case 111:    ///
             case 112:    ///
             case 113:    ///
             case 114:    ///
             case 115:    ///
             case 116:    ///
             case 117:    ///
             case 118:    ///
             case 119:    ///
badop:
                sprintf((char*)TmpPath, "Illegal opcode at 0x%8.8X\nTerminating program. So terribly sorry.", (unsigned int)GETMEMD(KEHED_PC));
                SystemMessage((char*)TmpPath);
                killpgm |= 1;
                goto stopint;
             case 120:    /// B PUMEM
                 dw = (DWORD)GETMEMB(dptr);
                goto dopumem;
             case 121:    /// W PUMEM
             case 122:    /// D PUMEM
             case 123:    /// Q PUMEM
                 dw = (DWORD)GETMEMW(dptr);
dopumem:
                 if( GETMEMD(KEHED_SE)+100 > SP-dw ) {
stkovf:
                    sprintf((char*)TmpPath, "Stack overflow at 0x%8.8X. Terminating. So sorry.", (unsigned int)GETMEMD(KEHED_PC));
                    SystemMessage((char*)TmpPath);
                    killpgm |= 1;
                    goto stopint;
                 }
                 SP -= dw;
                 memcpy(mainKE+SP, mainKE+aptr, dw);
                break;
             case 124:    /// B POMEM
                dw = (DWORD)GETMEMB(dptr);
                goto dopomem;
             case 125:    /// W POMEM
             case 126:    /// D POMEM
             case 127:    /// Q POMEM
                dw = (DWORD)GETMEMW(dptr);
dopomem:
                if( GETMEMD(KEHED_SB) < SP+dw ) goto stkovf;
                memcpy(mainKE+aptr, mainKE+SP, dw);
                 break;
            }
            break;
        }
//nextop:
        SETMEMB(KEHED_FLAGS, FLAGS);    /// save local copy of FLAGS
        SETMEMD(KEHED_PC, PC);    /// save local copy of PC
        SETMEMD(KEHED_SP, SP);    /// save local copy of SP
        SETMEMD(KEHED_FP, FP);    /// save local copy of FP
    }
/// NOTE: you should NEVER jump to 'stopint' unless it's either:
///     1) A TERMINAL error (killpgm has been set)
///        2) SMOD/EMOD is entering/exiting a Modal (dialog) frame
/// ANY other jump to here will leave garbage on the Stack, causing it to grow without bound.
stopint:
    SETMEMB(KEHED_FLAGS, FLAGS);    /// save local copy of FLAGS
    SETMEMD(KEHED_PC, PC);    /// save local copy of PC
    SETMEMD(KEHED_SP, SP);    /// save local copy of SP
    SETMEMD(KEHED_FP, FP);    /// save local copy of FP
}

///*********************************************************************
///*********************************************************************
///
/// DoSys
///
///*********************************************************************
///*********************************************************************
/// Each DoSys 'function' pops its expected arguments from the passed ptr.
/// If a DoSys() 'function' wants to return a value to the MAIN.KE code,
/// then it must be placed in R6 (if it's <= 8 bytes) or a POINTER to it
/// (an offset from the base of mainKE) must be placed in R6 (whatever
/// the MAIN.KE/DoSys() code coordinates and expects).
///
/// NOTE: Nothing, in the ENTIRE tree of arguments passed to SYS, may
/// contain an absolute pointer, as AllocHeap may realloc(mainKE), which
/// would cause any absolute pointers to become invalid!
/// Only OFFSETS from the beginning of MAIN.KE may be used.
///
/// All CPU registers EXCEPT for R6/R7 MUST be unmodified.

///====================================================
KLONG Kstrncmp(char *pS1, char *pS2, KLONG len) {

    KLONG    ret;

    if( len==0 ) return 0;
    do {
        if( *pS1==0 ) {
            if( *pS2 ) return -1;
            return 0;
        } else if( *pS2==0 ) return 1;
        ret = *pS1++ - *pS2++;
    } while( ret==0 && --len );
    return ret;
}

///====================================================
KLONG    INIsize, INIused;
char    *INIbuf=NULL;
char    *pINIsec, *pINIvar;

#define    INIwhite(s)            (*(s)==' ' || *(s)=='\t')
#define    INIeol(s)            (*(s)=='\r' || *(s)=='\n')
#define    INIwhiteALL(s)        (INIwhite(s) || INIeol(s))
#define    INIskipwhite(s)     {while( INIwhite(s) ) ++s;}
#define    INIskipline(s)      {while( *s && !INIeol(s) ) ++s; while( *s && INIeol(s) ) ++s; }
#define    INIskipwhiteALL(s)    {\
                                do {\
                                    INIskipwhite(s);\
                                    if( INIeol(s) ) INIskipline(s);\
                                } while( INIwhiteALL(s) );\
                            }

#define    INIchunkslop        2048

///====================================================
/// Calculate a checksum for buffer p (length 'len') and return it.
DWORD GetChksum(char *p, DWORD len) {

    DWORD    dw, sum;

    dw = len>>2;    // number of whole DWORDS
    sum = 0;
    while( dw-- ) {
        sum += *((DWORD*)p);
        p += 4;
    }
    len &= 3;
    dw = 0;
    while( len-- ) dw = (dw<<8) | *p++;
    sum += dw;

    return sum;
}

///====================================================
void iniWrite(char *pMem) {

    KLONG    i;
    DWORD    hFile, chksum, seclen;
    char    chkbuf[16], savbuf[10];
    char    *pWsec, *pSum;

    SETMEMD(KEHED_R14, 1);    // preset to SUCCESS
    if( INIbuf != NULL ) {
        if( -1!=(hFile=Kopen(pMem, O_WRBINNEW)) ) {
            pWsec = INIbuf;
            // for each section
            while( *pWsec=='[' ) {
                // save the checksum "internal variables" area and zero it out
                pSum = pWsec+1;
                for(i=0; i<10; i++) {
                    savbuf[i] = pSum[i];
                    pSum[i] = 0;
                }
                // now checksum the section
                seclen = *((DWORD*)savbuf);    // get the section LENGTH
                chksum = GetChksum((char*)pWsec, seclen);
                sprintf(chkbuf, "0x%8.8X", (unsigned int)chksum);
                // and write its ASCII value into the checksum area for this section
                for(i=0; i<10; i++) pSum[i] = chkbuf[i];
                // and write this section to the file
                if( seclen!=Kwrite(hFile, (BYTE*)pWsec, seclen) ) SETMEMD(KEHED_R14, 0);    // failed
                // now restore "internal variables" area
                for(i=0; i<10; i++) pSum[i] = savbuf[i];
                // now move to the next section
                pWsec += seclen;
            }
            Kclose(hFile);
        } else SETMEMD(KEHED_R14, 0);    // failed
    } else SETMEMD(KEHED_R14, 0);    // failed
}

/**===============================================
 If SECTION is found:
    pINIsec = ptr to '[' at beginning of section
    pINIvar = NULL
    returns TRUE
 Else
    pINIsec = ptr to NUL at EOF
    pINIvar = NULL
    returns FALSE
 ================================================*/

BOOL FindSec(char *srchname) {

    KLONG    len;
    char    *pSecName=NULL;

    if( INIbuf != NULL ) {
        len = (KLONG)strlen(srchname);
        pINIvar = NULL;    // need a iniFindVariable before iniGetNum or iniGetStr
        for(pINIsec=INIbuf; *pINIsec; ) {
            if( *pINIsec=='[' ) {
                pSecName = pINIsec + 12;    // skip [0xCHECKSUM=
                if( !Kstrncmp(pSecName, srchname, len) ) {    // if found a section with the same STARTING characters
                    if( *(pSecName+len)==']' ) return TRUE;    // if found matching name doesn't have any additional trailing characters, SUCCESS!
                }
            }
            pINIsec += *((KLONG*)(pINIsec+1));
        }
    }
    // leave pINIsec pointing at End Of File
    return FALSE;
}

/**=======================================================
 Finds a variable in the current SECTION, leaving pINIvar
 EITHER pointing to start of variable name AND returning length of old variable line (including end-of-line sequence),
 OR pointing to the '[' that starts the next section OR pointing to the EOF NUL char AND returning 0.
 =========================================================*/
KLONG FindVar(char *srchvar) {

    KLONG    oldlen, namlen;
    char    *pINItmp;

    if( INIbuf!=NULL && pINIsec!=NULL ) {
        namlen = (KLONG)strlen(srchvar);
        pINIvar = pINIsec + 13;
        INIskipline(pINIvar);    // skip the section line
        while( *pINIvar ) {
            INIskipwhiteALL(pINIvar);
            if( *pINIvar=='[' ) {
                return 0;    // all new variable, didn't exist before
            }
            if( !Kstrncmp(pINIvar, (char*)srchvar, namlen) ) {    // found beginning of old variable (at least)
                pINItmp = pINIvar + namlen;
                if( *pINItmp=='=' ) {    // found old variable
                    INIskipline(pINItmp);
                    oldlen = (KLONG)(pINItmp - pINIvar);
                    // pINIvar now points to the beginning of the VAR line and oldlen is its length
                    return oldlen;
                }
                // start of found variable matched, but is longer than what we're looking for
            }
            INIskipline(pINIvar);
        }
    }
    return 0;
}

///====================================================
BOOL INIopenHole(char *s, KLONG len) {

    char    *m;

    if( INIused+(len) > INIsize ) {    // need to increase size of buffer
        if( NULL==(m=(char*)malloc(INIsize+len+INIchunkslop)) ) return FALSE;
        memcpy(m, INIbuf, s-INIbuf);    // copy stuff above the hole
        memcpy(m+(s-INIbuf)+len, s, INIbuf+INIused-s);    // copy stuff below the hole
        if( pINIsec!=NULL ) pINIsec = m + (pINIsec-INIbuf) + ((pINIsec>s) ? len : 0);
        if( pINIvar!=NULL ) pINIvar = m + (pINIvar-INIbuf) + ((pINIvar>s) ? len : 0);
        free(INIbuf);
        INIbuf = m;
        INIsize += len+INIchunkslop;
        INIused += len;
    } else {
        memmove(s+len, s, INIused - (s-INIbuf));
        if( pINIsec!=NULL && pINIsec>s ) pINIsec += len;
        if( pINIvar!=NULL && pINIvar>s ) pINIvar += len;
        INIused += len;
    }
    return TRUE;
}

///====================================================
void INIcloseHole(char *s, KLONG len) {

    if( INIused-(s-INIbuf) < len ) len = (KLONG)(INIused-(s-INIbuf));
    memcpy(s, s+len, INIused-(s-INIbuf+len));
    if( pINIsec!=NULL && pINIsec>=s+len ) pINIsec -= len;
    if( pINIvar!=NULL && pINIvar>=s+len ) pINIvar -= len;
    INIused -= len;
}

///====================================================
BOOL GetOctDecHex(char **pp, DWORD *pv) {

    char    *p, c;
    BOOL    retval;
    DWORD    val;

    p = *pp;
    retval = FALSE;
    val = 0;

    c = *p;
    if( c>='0' && c<='9' ) {
        if( c=='0' ) {    // OCT or HEX
            ++p;
            c = *p;
            if( toupper(c)=='X' ) {    // HEX
                ++p;
                c = toupper(*p);
                while( (c>='0' && c<='9') || (c>='A' && c<='F') ) {
                    ++p;
                    c -= '0';
                    if( c>9 ) c -= 7;
                    val = 16*val + (DWORD)c;
                    c = toupper(*p);
                }
            } else {    // OCT
                --p;
                c = '0';
                do {
                    ++p;
                    val = 8*val + (c-'0');
                    c = *p;
                } while( c>='0' && c<='7' );
            }
        } else {    // DEC
            do {
                ++p;
                val = 10*val + (c-'0');
                c = *p;
            } while( c>='0' && c<='9' );
        }
        retval = TRUE;
    }
    *pv = val;
    *pp = p;
    return retval;
}

///====================================================
void UnknownSysCmd(void) {
    sprintf((char*)TmpPath, "Unknown SYS command at 0x%8.8X. Ack!", (unsigned int)GETMEMD(KEHED_PC));
    SystemMessage((char*)TmpPath);
}

///====================================================
void DoSysStrMem(DWORD func, DWORD pArgs) {

    char    *pF, *pS, *pZ, *pStr;
    BYTE    *pBS, *pBD;
    KLONG    i;
    QWORD    qw;
    DWORD    dw;

    switch( (BYTE)func ) {
/// long printf(char *buf, char *fmt, 1, DWORD *pStr)    // %s
/// long printf(char *buf, char *fmt, 4, DWORD qw)        // %li,ld,lu,lx,lo,c
/// long printf(char *buf, char *fmt, 8, QWORD qw)        // %lli,lld,llu,llx,llo,c,f,g,e
     case SYS_PRTFMT:
        pF = (char*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get ptr to buffer
        while( *pF ) pF++;    // move to end (we're going to concatenate onto the string)
        pS = pF;

        pZ = (char*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get fmt string

        i = (KLONG)GETMEMD(pArgs); pArgs += 4;    // get length of argument

        switch( i ) {
         case 1:
            pStr = (char*)(mainKE + GETMEMD(pArgs));    // get string to be formatted
            sprintf(pF, pZ, pStr);
            break;
         case 4:
            dw = GETMEMD(pArgs);        // get 4-byte value
            sprintf(pF, pZ, dw);
            break;
         case 8:
            qw = GETMEMQ(pArgs);        // get 8-byte value
            sprintf(pF, pZ, (QWORD)qw);
            break;
         default:
            SystemMessage("SYS_PRTFMT: unsupported arg size");
            break;
        }

        while( *pF ) pF++;
        SETMEMD(KEHED_R14, pF-pS);    // return # chars output
        break;
/// strcpy(char *, char *)
     case SYS_STRCPY:
        pS = (char*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get first string
        pZ = (char*)(mainKE+GETMEMD(pArgs));                // get second string
        if( pS!=pZ ) strcpy(pS, pZ);
        break;
/// strcat(char *, char *)
     case SYS_STRCAT:
        pS = (char*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get first string
        pZ = (char*)(mainKE+GETMEMD(pArgs));                // get second string
        strcat(pS, pZ);
        break;
/// return strlen(char *)
     case SYS_STRLEN:
        pS = (char*)(mainKE+GETMEMD(pArgs));                // get string
        SETMEMD(KEHED_R14, (QWORD)(int64_t)strlen(pS));
        break;
/// return strcmp(char *, char *)
     case SYS_STRCMP:
        pS = (char*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get first string
        pZ = (char*)(mainKE+GETMEMD(pArgs));                // get second string
        SETMEMD(KEHED_R14, (QWORD)(int64_t)strcmp(pS, pZ));
        break;
/// toupper(char *)
    // char* must have room for at least 5 BYTES (4 UTF8 bytes and a NUL) and must contains ONE UTF8-encoded char
     case SYS_TOUPPER:
        pS = (char*)(mainKE+GETMEMD(pArgs));
        {
//            TCHAR    bbb[20];
            NSString    *str = [[NSString stringWithCString:pS encoding:NSUTF8StringEncoding] uppercaseString];
            strcpy(pS, [str UTF8String]);
//            MultiByteToWideChar(CP_UTF8, 0, pS, -1, bbb, 20);
//           CharUpper(bbb);
//            WideCharToMultiByte(CP_UTF8, 0, bbb, -1, pS, 5, NULL, NULL);
        }
        break;
/// memcpy(BYTE *, BYTE *, KLONG len)
     case SYS_MEMCPY:
        pBD = (BYTE*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get first ptr
        pBS = (BYTE*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get second ptr
        i   = GETMEMD(pArgs);
        memcpy(pBD, pBS, i);
        break;
/// memmove(BYTE *, BYTE *, KLONG len)
     case SYS_MEMMOVE:
        pBD = (BYTE*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get first ptr
        pBS = (BYTE*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get second ptr
        i   = GETMEMD(pArgs);
        memmove(pBD, pBS, i);
        break;
/// memset(BYTE *, DWORD val, KLONG len)
     case SYS_MEMSET:
        pBD = (BYTE*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get ptr
        dw  = GETMEMD(pArgs); pArgs += 4;                    // get value
        i   = GETMEMD(pArgs);                                // get len
        memset(pBD, (BYTE)dw, i);
        break;
/// memcmp(BYTE *, BYTE *, KLONG len)
     case SYS_MEMCMP:
        pBS = (BYTE*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get ptr
        pBD = (BYTE*)(mainKE+GETMEMD(pArgs)); pArgs += 4;    // get ptr
        i   = GETMEMD(pArgs);                                // get len
        SETMEMD(KEHED_R14, (QWORD)(int64_t)memcmp(pBS, pBD, i));
        break;
     case SYS_DBGOUT:
        NSLog(@"%s", (char*)(mainKE+GETMEMD(pArgs)));
        break;
     default:
        UnknownSysCmd();
        break;
    }
}

///====================================================
void DoSysGraph(DWORD func, DWORD pArgs) {

    DWORD   hBMD, hBMS, *pDW, clr, clr2;
    KLONG   num;
    KLONG    x, y, x2, y2, rep2x, rep2y, w, h, i;
    char    *pChar;
    KRECT    *pRect;
    QWORD    qw;

    switch( (BYTE)func ) {
/// void DrawLines(DWORD hBM, long *pPoints, long num, DWORD clr)
     case SYS_LINES:
        hBMD = GETMEMD(pArgs); pArgs += 4;        /// pop BM handle
        pDW  = (DWORD*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    /// get pointer to POINTs array
        num  = (KLONG)GETMEMD(pArgs); pArgs += 4;        /// get NUMBER OF POINTS
        clr  = GETMEMD(pArgs);                    /// get COLOR
        DrawLines(hBMD, (KLONG*)pDW, num, clr);
        break;
/// void DrawRect(DWORD hBM, long x1, long y1, long wi, long hi, DWORD fill, DWORD edge)
     case SYS_RECT:
        hBMD = GETMEMD(pArgs); pArgs += 4;
        x    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        y    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        w    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        h    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        clr  = GETMEMD(pArgs); pArgs += 4;
        clr2 = GETMEMD(pArgs);
        DrawRect(hBMD, x, y, w, h, clr, clr2);
        break;
///DWORD LoadIMG(char *fname)
     case SYS_LOADIMG:
        pChar = (char*)(mainKE + GETMEMD(pArgs));    /// get ptr to fname
        hBMS = LoadImg(pChar);

         SETMEMD(KEHED_R14, hBMS);    /// return handle to bitmap
        break;
///void DrawBM(DWORD hDST, long xd, long yd, DWORD hSRC, long xs, long ys, long ws, long hs, long invert)
     case SYS_DRAWBM:
        hBMD = GETMEMD(pArgs); pArgs += 4;
        x    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        y    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        hBMS = GETMEMD(pArgs); pArgs += 4;
        x2   = (KLONG)GETMEMD(pArgs); pArgs += 4;
        y2   = (KLONG)GETMEMD(pArgs); pArgs += 4;
        w    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        h    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        i    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        rep2x= (KLONG)GETMEMD(pArgs); pArgs += 4;
        rep2y= (KLONG)GETMEMD(pArgs); pArgs += 4;
        DrawBM(hBMD, x, y, hBMS, x2, y2, w, h, i, rep2x, rep2y);
        break;
///void DeleteBM(DWORD hHP);
     case SYS_DELBM:
        hBMD = GETMEMD(pArgs);
        DeleteBM(hBMD);
        break;
///QWORD SetAlpha(DWORD hBM, long x, long y, long w, long hlong, QWORD clr, DWORD alpha);
     case SYS_SETALPHA:
         qw = SetAlpha(pArgs);
        SETMEMQ(KEHED_R14, qw);
        break;
///DWORD GetPixelBM(DWORD hBMD, long x, long y);
     case SYS_GETPIXEL:
        hBMD = GETMEMD(pArgs); pArgs += 4;
        x    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        y    = (KLONG)GETMEMD(pArgs);
        clr  = GetPixelBM(hBMD, x, y);
        SETMEMD(KEHED_R14, clr);
        break;
///void SetPixelBM(DWORD hBMD, long x, long y, DWORD clr);
     case SYS_SETPIXEL:
        hBMD = GETMEMD(pArgs); pArgs += 4;
        x    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        y    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        clr  = GETMEMD(pArgs);
        SetPixelBM(hBMD, x, y, clr);
        break;
///void StretchBM(DWORD hBMD, long xd, long yd, long wd, long hd, DWORD hBMS, long xs, long ys, long ws, long hs);
     case SYS_STRETCHBM:
        StretchBM(pArgs);
        break;
///DWORD SaveIMG(DWORD hBM, char *fname, long format)
     case SYS_SAVEIMG:
         hBMS  = GETMEMD(pArgs); pArgs += 4;    /// get bitmap handle
        pChar = (char*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    /// get ptr to fname
        x = (KLONG)GETMEMD(pArgs);        /// get format
        x = (KLONG)SaveImg(hBMS, pChar, x);
         SETMEMD(KEHED_R14, x);    /// return fail/success flag
        break;
///DWORD RGB2HSL(DWORD argb)
     case SYS_RGB2HSL:
         clr = GETMEMD(pArgs);
         clr = RGB2HSL(clr);
         SETMEMD(KEHED_R14, clr);
        break;
///DWORD HSL2RGB(DWORD ahsl)
     case SYS_HSL2RGB:
         clr = GETMEMD(pArgs);
         clr = HSL2RGB(clr);
         SETMEMD(KEHED_R14, clr);
        break;
///void GetInfoBM(DWORD hBM, INFOBM *pIBM)
     case SYS_GETINFOBM:
        hBMS = GETMEMD(pArgs); pArgs += 4;
        pChar = (char*)(mainKE + GETMEMD(pArgs));
        GetInfoBM(hBMS, (INFOBM*)pChar);
        break;
/// void ClipBM(DWORD hBM, long lf, long tp, long rt, long bt, KRECT *pRECT);
/// if pRECT!=NULL then the current clip is stored there before it's changed.
     case SYS_CLIPBM:
        hBMS = GETMEMD(pArgs); pArgs += 4;
        x    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        y    = (KLONG)GETMEMD(pArgs); pArgs += 4;
        x2   = (KLONG)GETMEMD(pArgs); pArgs += 4;
        y2   = (KLONG)GETMEMD(pArgs); pArgs += 4;
        w    = (KLONG)GETMEMD(pArgs);
        pRect= (KRECT*)((w==0) ? NULL : (mainKE + w));
        ClipBM(hBMS, x, y, x2, y2, pRect);
        break;
///QWORD LineStyle(QWORD ls);
     case SYS_LINESTYLE:
         qw   = GETMEMQ(pArgs);
        qw = SetLineStyle(qw);
        SETMEMQ(KEHED_R14, qw);
        break;
///void ColorizeBM(DWORD hBM, long x, long y, long w, long h, long hue, long sat, long light, long contrast)
     case SYS_COLORIZEBM:
         ColorizeBM(pArgs);
        break;
///DWORD DrawSysFontText(DWORD hBM, char *pText, int x, int y, int w, int h, DWORD flags, DWORD bclr, DWORD fclr)
     case SYS_DRAWTEXTBM:
        num = (KLONG)DrawSysFontText(pArgs);
         SETMEMD(KEHED_R14, num);
        break;
 ///void DrawGradientRectBM(hBM, long xo, long yo, long wo, long ho, WORD hue, WORD satmin, WORD satmax, WORD lightmin, WORD lightmax
     case SYS_DRAWGRADRECTBM:
        RectGradientBM(pArgs);
        break;
///void DrawOvalBM(DWORD hBM, long x1, long y1, long w, long h, DWORD fill, DWORD edge)
     case SYS_DRAWOVALBM:
        DrawOvalBM(pArgs);
        break;
     case SYS_CREATEBM:
         w = (KLONG)GETMEMD(pArgs); pArgs += 4;
         h = (KLONG)GETMEMD(pArgs);
        num = (KLONG)CreateBM(w, h);
        SETMEMD(KEHED_R14, num);
        break;
     default:
        UnknownSysCmd();
        break;
    }
}

///====================================================
void DoSysSystem(DWORD func, DWORD pArgs) {

    BYTE    *pB;
    KLONG    i;
    DWORD    *pDW;
//    HGLOBAL    hGlobal;

    switch( (BYTE)func ) {
/// void SystemMessage(char *pMsg)
     case SYS_SYSMSG:
         SystemMessage((char*)(mainKE + GETMEMD(pArgs)));
        pArgs += 4;
        break;
/// long GetEOL(BYTE *buf, long maxbuflen)
     case SYS_GETEOL:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
        i = (KLONG)GETMEMD(pArgs); pArgs += 4;    // get max buffer len
        if( i<3 ) SystemMessage("GetEOL: buffer too small");
        *pB++ = '\r';
        *pB++ = '\n';
        *pB   = '\0';
        SETMEMD(KEHED_R14, 2);
        break;
     case SYS_GETSCREENSIZE:
        SETMEMQ(KEHED_R14, ((QWORD)ScreenH<<32) | ((QWORD)ScreenW));
        break;
/// long GetKeyMsg(DWORD *buf)
/// Discard all pending KMSG_POINTER_MOVE and KMSG_TIMER, then find and return first KMSG_KEY_DOWN or KMSG_KEY_UP message in the queue,
/// storing the KMSG, arg1, arg2, arg3 in buf[0] thru buf[3], and returning TRUE in r6, or return FASLE in r6 if no KMSG_KEY* available.
     case SYS_GETKEYMSG:
        pDW = (DWORD*)(mainKE + GETMEMD(pArgs));    // get pointer to buffer
        SETMEMD(KEHED_R14, KeyMsg(pDW, pDW+1, pDW+2, pDW+3));
        break;
/// long GetPtrMsg(DWORD *buf)
/// Discard all pending KMSG_TIMER messages, then discard all leading KMSG_POINTER_MOVE messages, except the last one, and return it
/// in buf[0] through buf[3], returning TRUE in r6, else return FALSE in r6 if no pending KMSG_POINTER_MOVE message before a non-POINTER_MOVE message.
     case SYS_GETPTRMSG:
        pDW = (DWORD*)(mainKE + GETMEMD(pArgs));    // get pointer to buffer
        SETMEMD(KEHED_R14, PtrMsg(pDW, pDW+1, pDW+2, pDW+3));
        break;
     case SYS_READCLIPBOARD:
        {
            pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
            i  = (KLONG)GETMEMD(pArgs);                // get maxlen of buffer
            NSPasteboard *pasteboard = [NSPasteboard generalPasteboard];
            
            NSString    *nsstr = [pasteboard propertyListForType: NSPasteboardTypeString];
            if( nsstr==nil ) *pB = 0;
            else [nsstr getCString:(char*)pB maxLength:i-1 encoding:NSUTF8StringEncoding];
            
        }
            /*
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
        i  = (KLONG)GETMEMD(pArgs);                // get maxlen of buffer

        if( IsClipboardFormatAvailable(CF_UNICODETEXT) ) {
            LPVOID    pGlobal;
            int        siz, wsiz;

            *pB = 0;    // if nothing on clipboard, return empty string
            OpenClipboard(hWndMain);
            hGlobal = GetClipboardData(CF_UNICODETEXT);
            if( NULL != hGlobal ) {
                pGlobal = GlobalLock(hGlobal);
                wsiz = WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)pGlobal, -1, 0, 0, NULL, NULL);
                if( wsiz<i ) {
                    WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)pGlobal, -1, pB, i, NULL, NULL);
                }
                GlobalUnlock(hGlobal);
            }
            CloseClipboard();
        } else if( IsClipboardFormatAvailable(CF_TEXT) ) {
            LPVOID    pGlobal;
            int        siz;

            *pB = 0;    // if nothing on clipboard, return empty string
            OpenClipboard(hWndMain);
            hGlobal = GetClipboardData(CF_TEXT);
            if( NULL != hGlobal ) {
                siz = GlobalSize(hGlobal);
                if( siz<i ) {
                    pGlobal = GlobalLock(hGlobal);
                    strcpy(pB, (const char *)pGlobal);
                    GlobalUnlock(hGlobal);
                }
            }
            CloseClipboard();
        }
*/
        break;
     case SYS_WRITECLIPBOARD:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
        i  = (KLONG)GETMEMD(pArgs);                // get len of buffer (no NUL assumed)
        {
            NSString    *str = [NSString stringWithUTF8String:(char*)pB];
            [[NSPasteboard generalPasteboard] clearContents];
            [[NSPasteboard generalPasteboard] setString:str forType:NSPasteboardTypeString];
/*
            WCHAR    *SMbuf=NULL;
            int        SMbufLen;

            SMbufLen = 2+MultiByteToWideChar(CP_UTF8, 0, pB, -1, 0, 0);
            SMbuf = (WCHAR*)malloc(SMbufLen * sizeof(WCHAR));
            MultiByteToWideChar(CP_UTF8, 0, pB, -1, SMbuf, SMbufLen);
            hGlobal = GlobalAlloc(GMEM_MOVEABLE, SMbufLen*sizeof(WCHAR));
            pO = GlobalLock(hGlobal);
            memcpy(pO, SMbuf, SMbufLen*sizeof(WCHAR));
            GlobalUnlock(hGlobal);
            OpenClipboard(hWndMain);
            EmptyClipboard();
            SetClipboardData(CF_UNICODETEXT, hGlobal);
            CloseClipboard();
            free(SMbuf);
 */
        }
        break;
     case SYS_CAPTUREMOUSE:
        i = GETMEMD(pArgs);
        KCaptureMouse(i);
        break;
     case SYS_GETWNDPOS:
        pDW = (DWORD*)(mainKE + GETMEMD(pArgs));
        KINT_GetWindowPos(pDW, pDW+1, pDW+2, pDW+3, pDW+4);
        break;
     case SYS_SETWNDPOS:
        pDW = (DWORD*)(mainKE + GETMEMD(pArgs));
        SWPopt = pDW[4];
        SWPh = pDW[3];
        SWPw = pDW[2];
        SWPy = pDW[1];
        SWPx = pDW[0];
        KINT_SetWindowPos();
        break;
     case SYS_GETVIEWSIZE:
        SETMEMQ(KEHED_R14, (((QWORD)SWPvh)<<32) | ((QWORD)SWPvw));
        break;
     case SYS_SETPGMTITLE:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
//            pMem = (BYTE *)AllocPtrs[GETREGD(4*(DWORD)GETREGB(REG_95))] + GETREGD(REG_15);
            if( strlen((char*)pB)<sizeof(titleBuf) ) strcpy(titleBuf, (char*)pB);
            else strcpy(titleBuf, "Title too long");
            KSetTitle();
//         KSetWindowText((char*)(mainKE + GETMEMD(pArgs)));
        break;
     case SYS_GETAPPDATAPATH:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
        strcpy((char *)pB, AppDataPath);
        break;
     case SYS_GETPGMPATH:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
        strcpy((char *)pB, AppPath);
        break;
     case SYS_GETOSVERSION:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs));    // get pointer to buffer
        SETMEMD(KEHED_R14, KGetOSversion(pB));
        break;
     case SYS_GETCTRL:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs));    // get pointer to buffer
        strcpy((char*)pB, (char*)OSctrl_cmdSTR);    // or "CMD" for Mac OS
        break;
     case SYS_SETCURSOR:
         KSetCursor(GETMEMD(pArgs));
        break;
     case SYS_DOHTML:
//        DoHTML((char*)mainKE+GETMEMD(pArgs));
            [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:CFBridgingRelease(CFStringCreateWithCString(NULL, (char*)mainKE+GETMEMD(pArgs), kCFStringEncodingMacRoman))]];
        break;
     case SYS_GETMAXSCREEN:
        SETMEMQ(KEHED_R14, ((QWORD)MaxScreenH<<32) | ((QWORD)MaxScreenW));
        break;
     case SYS_GETKEYSTATUS:
        SETMEMD(KEHED_R14, KeyFlags & GETMEMD(pArgs));
        break;
     default:
        UnknownSysCmd();
        break;
    }
}

///=================================================================================
char base64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

KLONG write64(DWORD hFile, BYTE *buf, KLONG buflen) {

    KLONG    outlen, i, j, k=0, trip;
    char    outbuf[4];

    for(i=outlen=0; i<buflen; ) {
        for(trip=j=0; i<buflen && j<3; j++) trip |= (((KLONG)buf[i++]) << (8*(2-j)));
        for(k=0, j=(j*8+5)/6; j; j--) {    // turn j=1,2,3 bytes into j=2,3,4 6-bit nybbles
            outbuf[k++] = base64[(trip>>18) & 0x3F];
            trip <<= 6;
        }
        outlen += Kwrite(hFile, (BYTE*)outbuf, k);
    }
    while( k++ < 4 ) outlen += Kwrite(hFile, (BYTE*)"=", 1);    // write 0, 1, or 2 '=' pad chars

    return outlen;
}

///====================================================
void DoSysFile(DWORD func, DWORD pArgs) {

    BYTE    *pB, *pBuf, b;
    KLONG    i, *pL, *pL2;
    DWORD    dw, dw2;

    switch( (BYTE)func ) {
/// void fopen(char *pMsg, long flags)
     case SYS_FOPEN:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
        i  = (KLONG)GETMEMD(pArgs);
        SETMEMD(KEHED_R14, Kopen((char*)pB, i));
        break;
     case SYS_FEOF:
         dw = GETMEMD(pArgs);    // get file handle
         SETMEMD(KEHED_R14, Keof(dw));
        break;
     case SYS_FREAD:
        dw = GETMEMD(pArgs); pArgs += 4;    // get file handle
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
         dw2= GETMEMD(pArgs);    // get len to read
         SETMEMD(KEHED_R14, Kread(dw, pB, dw2));
        break;
     case SYS_FWRITE:
        dw = GETMEMD(pArgs); pArgs += 4;    // get file handle
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
         dw2= GETMEMD(pArgs);    // get len to write
         SETMEMD(KEHED_R14, Kwrite(dw, pB, dw2));    // return # bytes written
        break;
     case SYS_FSEEK:
        dw = GETMEMD(pArgs); pArgs += 4;    // get file handle
        dw2= GETMEMD(pArgs); pArgs += 4;    // get offset
         i  = (KLONG)GETMEMD(pArgs);                // get origin
         SETMEMD(KEHED_R14, (KLONG)Kseek(dw, dw2, (int)i)); // return new file position
        break;
     case SYS_FREMOVE:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs));    // get pointer to filename
         Kdelete((char*)pB);
        break;
     case SYS_MKDIR:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs));    // get pointer to buffer
        SETMEMD(KEHED_R14, KMakeFolder((char*)pB));
        break;
     case SYS_RMDIR:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs));    // get pointer to buffer
        KDelFolder((char*)pB);
        break;
     case SYS_FCLOSE:
         dw = GETMEMD(pArgs);                    // get file handle
         Kclose(dw);
        break;
     case SYS_FSIZE:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs));    // get pointer to buffer
        SETMEMD(KEHED_R14, Kstat((char*)pB, &dw, &b));    // return length
        break;
     case SYS_FTIME:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs));    // get pointer to buffer
        Kstat((char*)pB, &dw, &b);
        SETMEMQ(KEHED_R14, (QWORD)dw);    // return last-modified time
        break;
     case SYS_FINDFIRST://char *wildname, char *buf, long *dirflag, long *appdata);
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to file specifier
        pBuf = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;// get pointer to name buffer
        dw = GETMEMD(pArgs); pArgs += 4;
        if( dw!=0 ) pL = (KLONG*)(mainKE+dw);
        else pL = NULL;
        dw = GETMEMD(pArgs);
        if( dw!=0 ) pL2 = (KLONG*)(mainKE+(DWORD)dw);
        else pL2 = NULL;
        {
            BYTE    b1, b2;
            dw = Kfindfirst((char*)pB, pBuf, &b1, &b2);
            if( pL!=NULL ) *pL = (KLONG)b1;
            if( pL2!=NULL) *pL2= (KLONG)b2;
            SETMEMD(KEHED_R14, dw);
        }
        break;
     case SYS_FINDNEXT:
        pBuf = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;// get pointer to name buffer
        dw = GETMEMD(pArgs); pArgs += 4;
        if( dw!=0 ) pL = (KLONG*)(mainKE+(DWORD)dw);
        else pL = NULL;
        dw = GETMEMD(pArgs);
        if( dw!=0 ) pL2 = (KLONG*)(mainKE+(DWORD)dw);
        else pL2 = NULL;
        {
            BYTE    b1, b2;
            dw = Kfindnext(pBuf, &b1, &b2);
            if( pL!=NULL ) *pL = (KLONG)b1;
            if( pL2!=NULL) *pL2= (KLONG)b2;
            SETMEMD(KEHED_R14, dw);
        }
        break;
     case SYS_FINDCLOSE:
         Kfindclose();
        break;
     case SYS_FWRITE64:
        dw = GETMEMD(pArgs); pArgs += 4;    // get file handle
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
         dw2= GETMEMD(pArgs);    // get len to encode
         SETMEMD(KEHED_R14, write64(dw, pB, dw2));    // return # bytes written
        break;
     case SYS_FRENAME:
        pB = (BYTE*)(mainKE + GETMEMD(pArgs)); pArgs += 4;    // get pointer to buffer
        pBuf = (BYTE*)(mainKE + GETMEMD(pArgs));            // get pointer to buffer
        Krename((char*)pB, (char*)pBuf);
        break;
     default:
        UnknownSysCmd();
        break;
    }
}

///====================================================
void DoSysCfg(DWORD func, DWORD pArgs) {

    char    *pMem, *pMem2;
    KLONG    maxlen, i;
    char    c;
///    BYTE    *pB, *pBuf, b;
///    KLONG    i, *pL, *pL2;
    DWORD    dw;

    switch( (BYTE)func ) {
/// BOOL iniRead(char *fname)
/// Returns TRUE if opened & read, FALSE if error & empty buffer created
     case SYS_INIREAD:
         pMem = (char*)(mainKE+GETMEMD(pArgs));
        {
            DWORD    hFile, chksum, seclen, filsum;
            BYTE    *pWsec, *pSum, *pNext;
            BOOL    gotchksum;
            DWORD    s, r;

            SETMEMD(KEHED_R14, 0);    // preset to FAIL

            if( INIbuf!=NULL ) {
                free(INIbuf);
                INIbuf = NULL;
            }
            pINIvar = pINIsec = NULL;
            if( -1!=(hFile=Kopen(pMem, O_RDBIN)) ) {
                s = Kseek(hFile, 0, SEEK_END);
                // one extra for NUL on last line in case no CR/LF on last line
                INIsize = s+1;
                if( s>=10 ) {
                    if( NULL != (INIbuf = (char *)malloc(INIsize)) ) {
                        Kseek(hFile, 0, SEEK_SET);
                        r = Kread(hFile, (BYTE*)INIbuf, s);

                        INIbuf[r] = 0;    // place NUL at end of buffer
                        INIused = r+1;
                        SETMEMD(KEHED_R14, 1);    // success

                        pINIsec =INIbuf;
                        INIskipwhiteALL(pINIsec);
                        pWsec = (BYTE*)pINIsec;
                        while( *pWsec && *pWsec=='[' ) {
                            // find len of each section, checksum it, and compare it to the stored checksum.
                            // if checksums don't match, set flag bit0.
                            pNext = pWsec+1;    // skip the '[', point at the file's checksum for this section
                            gotchksum = GetOctDecHex((char**)&pNext, &filsum);    // get the checksum from the file
                            pNext = pWsec+1;                // point at the start of the checksum area
                            for(i=0; i<10; i++) *pNext++ = 0;    // zero-out the checksum area
                            for(pSum=pWsec; pSum<pNext || (*pSum && *pSum!='['); pSum++) ;    // find the end of this SECTION
                            seclen = (DWORD)(pSum - pWsec);            // get the length of this SECTION
                            chksum = GetChksum((char*)pWsec, seclen);    // get the actual checksum of this SECTION
                            *((DWORD*)(pWsec+1)) = seclen;    // set the length of this SECTION
                            if( !gotchksum || chksum != filsum ) {
                                pWsec[5] = 1;    // if the checksums don't match, set the BAD CHECKSUM flag
                            }
                            pWsec += seclen;
                        }
                    }
                    Kclose(hFile);
                    break;
                }
                Kclose(hFile);
            }
            INIbuf = (char*)malloc(INIchunkslop);
            *INIbuf = 0;
            INIsize = INIchunkslop;
            INIused = 1;
        }
        break;
/// BOOL iniWrite(char *fname)
/// Returns TRUE if write successful
     case SYS_INIWRITE:
         pMem = (char*)(mainKE+GETMEMD(pArgs));
         iniWrite(pMem);
        break;
/// void iniClose()
     case SYS_INICLOSE:
        if( INIbuf!=NULL ) {
            free(INIbuf);
            INIbuf = NULL;
        }
        break;
 /// BOOL iniFindSec(char *pSecName)
/// Returns TRUE if successful
     case SYS_INIFINDSEC:
         pMem = (char*)(mainKE+GETMEMD(pArgs));
        {
            KLONG    len;
            char    *pSec;

            len = (KLONG)strlen((char*)pMem);
            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            pINIvar = NULL;    // need a iniFindVar before iniGetNum or iniGetStr
            if( INIbuf!=NULL ) {
                for(pINIsec=INIbuf; *pINIsec; ) {
                    if( *pINIsec=='[' ) {
                        pSec = pINIsec + 12;    // skip [0xCHECKSUM=
                        if( !Kstrncmp(pSec, pMem, len) && *(pSec+len)==']' ) {
                            SETMEMD(KEHED_R14, 1);    // signal success
                            break;
                        }
                    }
                    pINIsec += *((KLONG*)(pINIsec+1));
                }
            }
        }
        break;
/// BOOL iniFindVar(char *pVarName)
/// Returns TRUE if successful & "read ptr" pointing at start of variables data values (past the '=')
     case SYS_INIFINDVAR:
         pMem = (char*)(mainKE+GETMEMD(pArgs));
        {
            size_t    len;

            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            if( INIbuf!=NULL && pINIsec!=NULL ) {
                len = FindVar((char*)pMem);
                if( len ) {
                    while( *pINIvar && *pINIvar++ != '=' ) ;    // skip to variable values, now ready for iniGetNum and/or iniGetStr
                    SETMEMD(KEHED_R14, 1);    // signal success
                }
            }
        }
        break;
/// BOOL iniGetNum(DWORD *pNum)
/// Return TRUE if successful & value is in *pNum
     case SYS_INIGETNUM:
         pMem = (char*)(mainKE+GETMEMD(pArgs));
        {
            KLONG    sign;
            DWORD    val;

            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            sign = 0;
            if( INIbuf!=NULL && pINIvar!=NULL ) {    // must have a buffer, must have done an iniFindVariable
                INIskipwhite(pINIvar);
                if( *pINIvar=='-' ) {
                    sign = 1;
                    ++pINIvar;
                }
                if( GetOctDecHex(&pINIvar, &val) ) SETMEMD(KEHED_R14, 1);
                if( sign ) val = (DWORD)(-(KLONG)val);
                *((DWORD *)pMem) = val;
            }
        }
        break;
/// KLONG iniGetStr(char *pStr, KLONG maxlen)
/// return -1 if string was longer than maxlen, 0 if not found, else len of found string (string is NUL-terminated)
     case SYS_INIGETSTR:
         dw = GETMEMD(pArgs);
         pMem = (char*)(mainKE+GETMEMD(pArgs)); pArgs += 4;
        {
            maxlen = (KLONG)GETMEMD(pArgs);

            i = 0;
            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            if( INIbuf!=NULL && pINIvar!=NULL ) {    // must have a buffer, must have done an iniFindVariable
                INIskipwhite(pINIvar);
                c = *pINIvar;
                if( c=='"' ) {
                    ++pINIvar;
                    while( i+1<maxlen && (c = *pINIvar) && c!='"' && (c&0xE0) && (c!='\\' || *(pINIvar+1)) ) {
                        if( c=='\\' ) c = *(++pINIvar);
                        pMem[i++] = c;
                        ++pINIvar;
                    }
                    if( *pINIvar=='"' ) {
                        ++pINIvar;
                        SETMEMD(KEHED_R14, i);    // set to length of found string
                    } else SETMEMD(KEHED_R14, 0xFFFFFFFF);    // set to string longer than buffer
                }
            }
            pMem[i] = 0;
        }
        break;
/// BOOL iniSetSec(char *pSecName)
/// Returns TRUE if successful
     case SYS_INISETSEC:
         pMem = (char*)(mainKE+GETMEMD(pArgs));
        {
            DWORD    len, eollen, seclen;
            char    eolbuf[8], *pSec;

            len = (DWORD)strlen((char*)pMem);
            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            if( INIbuf!=NULL ) {
                if( !FindSec((char*)pMem) ) {    // if didn't find section, add it (pINIsec is pointing to the end of file
                    eollen = GetSystemEOL((BYTE*)eolbuf);
                    seclen = len+eollen+13;    // +2 for []'s, +1 for '=', +10 for 0xCHECKSUM
                    if( INIopenHole(pINIsec, seclen) ) {
                        pSec = pINIsec;
                        *pSec++ = '[';
                        for(i=0; i<10; i++) *pSec++ = 0;    // clear checksum area for LENGTH and FLAGS
                        *pSec++ = '=';
                        strcpy(pSec, (char*)pMem);
                        pSec += len;
                        *pSec++ = ']';
                        for(i=0; i<eollen; i++) *pSec++ = eolbuf[i];
                        *((DWORD*)(pINIsec+1)) = seclen;
                        pINIvar = NULL;
                        SETMEMD(KEHED_R14, 1);    // signal success
                    }
                } else SETMEMD(KEHED_R14, 1);    // signal success
            }
        }
        break;
/// BOOL iniSetVar(char *pVarName, char *pVarValue)
/// Returns TRUE if successful
     case SYS_INISETVAR:
         pMem = (char*)(mainKE+GETMEMD(pArgs)); pArgs += 4;
        pMem2 =(char *)(mainKE+GETMEMD(pArgs));
        {
            KLONG    oldlen, namlen, newlen, varlen, eollen;
            BYTE    eolbuf[8];

            eollen = GetSystemEOL(eolbuf);
            namlen = (KLONG)strlen((char*)pMem);
            varlen = (KLONG)strlen((char*)pMem2);
            newlen = namlen+1+varlen+ eollen;// +1 for '='

            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            if( INIbuf!=NULL && pINIsec!=NULL ) {
                oldlen = FindVar((char*)pMem);
                if( oldlen>newlen ) INIcloseHole(pINIvar, oldlen-newlen);
                else if( newlen!=oldlen ) INIopenHole(pINIvar, newlen-oldlen);
                *((KLONG*)(pINIsec+1)) += (newlen-oldlen);    // adjust SECTION LENGTH

                strcpy(pINIvar, (char*)pMem);    // copy name
                pINIvar += namlen;
                *pINIvar++ = '=';
                strcpy(pINIvar, (char*)pMem2);
                pINIvar += varlen;
                for(i=0; i<eollen; i++) *pINIvar++ = eolbuf[i];
                SETMEMD(KEHED_R14, 1);    // signal success
            }
        }
        break;
/// void iniDelSec()
/// must have done an iniFindSec() previously to set the current section
     case SYS_INIDELSEC:
        {
            KLONG    len;

            if( INIbuf!=NULL && pINIsec!=NULL ) {
                len = *((KLONG*)(pINIsec+1));
                INIcloseHole(pINIsec, len);
                pINIsec = INIbuf;
                pINIvar = NULL;
            }
        }
        break;
/// BOOL iniDelVar(char *pVarName)
/// Returns TRUE if successful
     case SYS_INIDELVAR:
         pMem = (char*)(mainKE+GETMEMD(pArgs));
        {
            KLONG    oldlen;

            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            if( INIbuf!=NULL && pINIsec!=NULL ) {
                oldlen = FindVar((char*)pMem);
                if( oldlen ) {
                    INIcloseHole(pINIvar, oldlen);
                    *((KLONG*)(pINIsec+1)) -= oldlen;
                    SETMEMD(KEHED_R14, 1);    // signal success
                }
            }
        }
        break;
/// KLONG iniNextSec(char *pSecName, KLONG maxlen)
/// must have done an iniFindSec() previously to set the current section
/// Returns -1 if found section name is longer than maxlen, 0 if no next section (EOF), else len of 'next' (new 'current') section name
     case SYS_ININEXTSEC:
         pMem = (char*)(mainKE+GETMEMD(pArgs)); pArgs += 4;
        {
            char    *pSec;

            maxlen = GETMEMD(pArgs);

            i = 0;
            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            if( INIbuf!=NULL && pINIsec!=NULL ) {
                pINIsec += *((KLONG*)(pINIsec+1));
                if( *pINIsec ) {
                    pSec = pINIsec+12;    // skip [0xCHECKSUM=
                    while( i+1<maxlen && *pSec!=']' ) pMem[i++] = *pSec++;
                    SETMEMD(KEHED_R14, (i+1<maxlen || *pSec==']')?i:0xFFFFFFFF);
                } else pINIsec = NULL;
                pINIvar = NULL;
            }
            pMem[i] = 0;
        }
        break;
/// void iniDelAll()
/// Deletes entire contents of ini buffer, leaves buffer allocated
     case SYS_INIDELALL:
        if( INIbuf!=NULL ) {
            INIused = 1;
            *INIbuf = 0;
            pINIsec = pINIvar = NULL;
        }
        break;
/// BOOL iniIsEndVar()
/// Returns TRUE if at End-Of-Line for current variable (no more data for the current variable)
     case SYS_INIENDVAR:
        SETMEMD(KEHED_R14, 1);    // preset to TRUE, is end of cur var data
        if( INIbuf!=NULL && pINIvar!=NULL ) {
            INIskipwhite(pINIvar);
            SETMEMD(KEHED_R14, (*pINIvar==0 || INIeol(pINIvar)) ? 1 : 0);
        }
        break;
/// BOOL iniAddVarNum(char *pVarName, DWORD val, DWORD format)
/// Returns TRUE if successful
/// 'format' is 0 for decimal, 1 for octal, 2 for hex
/// 'val' is formatted as a SIGNED value for decimal, UNSIGNED for octal and hex
     case SYS_INIADDVARNUM:
         pMem = (char*)(mainKE+GETMEMD(pArgs)); pArgs += 4;
        {
            KLONG    val, form, oldlen, namlen, newlen, varlen, eollen;
            BYTE    eolbuf[8], numbuff[16];

            val = GETMEMD(pArgs); pArgs += 4;
            form= GETMEMD(pArgs);

            if( form==2 ) sprintf((char*)numbuff, " 0x%8.8X", (DWORD)val);
            else if( form==1 ) sprintf((char*)numbuff, " 0%o", (DWORD)val);
            else sprintf((char*)numbuff, " %d", (int)val);
            pMem2 = (char*)numbuff;

            eollen = GetSystemEOL(eolbuf);
            namlen = (KLONG)strlen((char*)pMem);
            varlen = (KLONG)strlen((char*)pMem2);
            newlen = namlen+1+varlen+ eollen;// +1 for '='

            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            if( INIbuf!=NULL && pINIsec!=NULL ) {
                oldlen = FindVar((char*)pMem);
                if( oldlen ) {    // var existed before
                    INIopenHole(pINIvar+oldlen, varlen);
                    *((KLONG*)(pINIsec+1)) += varlen;    // adjust SECTION LENGTH
                    pINIvar += oldlen-eollen;    // setup to overwrite previous EOL and new hole with formatted string
                } else {    // else variable didn't exist before, create it
                    INIopenHole(pINIvar, newlen);//namlen);
                    *((KLONG*)(pINIsec+1)) += newlen;    // adjust SECTION LENGTH
                    strcpy(pINIvar, (char*)pMem);    // copy name
                    pINIvar += namlen;
                    *pINIvar++ = '=';
                }
                for(i=0; i<varlen; i++) {    // copy out the formatted number string
                    *pINIvar++ = pMem2[i];
                }

                for(i=0; i<eollen; i++) *pINIvar++ = eolbuf[i];    // output eol sequence
                pINIvar = NULL;    // NULL pointer since it's not in a good place to do further work
                SETMEMD(KEHED_R14, 1);    // signal success
            }
        }
        break;
/// BOOL iniAddVarStr(char *pVarName, char *pStr)
/// pStr is an unquoted, NUL-terminated string (it will get ""s added around it)
     case SYS_INIADDVARSTR:
         pMem = (char*)(mainKE+GETMEMD(pArgs)); pArgs += 4;
        pMem2= (char*)(mainKE+GETMEMD(pArgs));
        {
            KLONG    oldlen, namlen, newlen, varlen, eollen, formvlen;
            BYTE    eolbuf[8];

            eollen = GetSystemEOL(eolbuf);
            namlen = (KLONG)strlen((char*)pMem);
            varlen = (KLONG)strlen((char*)pMem2);
            newlen = namlen+1+varlen+ eollen;// +1 for '='

            SETMEMD(KEHED_R14, 0);    // preset to FAIL
            if( INIbuf!=NULL && pINIsec!=NULL ) {
                // add 3 to target length, 1 for leading space, 2 for surrounding quotes.
                // then add one more for every '\' or '"' in the string, which will need to be escaped by a '\'
                for(i=0, formvlen=varlen+3; i<varlen; i++) if( pMem2[i]=='\\' || pMem2[i]=='"' ) ++formvlen;
                oldlen = FindVar((char*)pMem);
                if( oldlen ) {    // var existed before
                    INIopenHole(pINIvar+oldlen, formvlen);
                    *((KLONG*)(pINIsec+1)) += formvlen;    // adjust SECTION LENGTH
                    pINIvar += oldlen-eollen;    // setup to overwrite previous EOL and new hole with formatted string
                } else {    // else variable didn't exist before, create it
                    INIopenHole(pINIvar, namlen + (formvlen-varlen));
                    *((KLONG*)(pINIsec+1)) += (newlen+(formvlen-varlen));    // adjust SECTION LENGTH
                    strcpy(pINIvar, (char*)pMem);    // copy name
                    pINIvar += namlen;
                    *pINIvar++ = '=';
                }
                *pINIvar++ = ' ';    // output leading space
                *pINIvar++ = '"';    // output leading quote
                for(i=0; i<varlen; i++) {    // copy out the unquoted string, escaping any '\' or '"' chars with a '\' char.
                    if( pMem2[i]=='\\' || pMem2[i]=='"' ) *pINIvar++ = '\\';
                    *pINIvar++ = pMem2[i];
                }
                *pINIvar++ = '"';

                for(i=0; i<eollen; i++) *pINIvar++ = eolbuf[i];    // output eol sequence
                pINIvar = NULL;    // NULL pointer since it's not in a good place to do further work
                SETMEMD(KEHED_R14, 1);    // signal success
            }
        }
        break;
/// BOOL iniNextVar(char *pBuf, KLONG maxlen)
/// Copies the ENTIRE next variable line to pBuf
     case SYS_ININEXTVAR:
         pMem = (char*)(mainKE+GETMEMD(pArgs)); pArgs += 4;
        {
            KLONG    maxlen;
            char    c;

            maxlen = GETMEMD(pArgs);
            i = 0;
            SETMEMD(KEHED_R14, 0);    // preset to FAIL (no string found)
            if( INIbuf!=NULL && pINIsec!=NULL ) {    // must have a buffer, must have done an iniFindSec
                if( pINIvar==NULL ) {    // first time after iniFindSec
                    pINIvar = pINIsec+12;
                    INIskipline(pINIvar);
                    if( *pINIvar==0 || *pINIvar=='[' ) {
                        pINIvar = pINIsec = NULL;
                        break;
                    }
                }
                while( i+1<maxlen && (c = *pINIvar) && !INIeol(pINIvar) ) {
                    if( c=='\\' ) c = *(++pINIvar);
                    pMem[i++] = c;
                    ++pINIvar;
                }
                if( *pINIvar && INIeol(pINIvar) ) {
                    SETMEMD(KEHED_R14, i);    // set to length of found string
                } else {
                    SETMEMD(KEHED_R14, 0xFFFFFFFF);    // set to string longer than buffer
                }
                INIskipline(pINIvar);
                if( *pINIvar==0 || *pINIvar=='[' ) pINIvar = pINIsec = NULL;
            }
            pMem[i] = 0;
        }
         break;
     default:
        UnknownSysCmd();
        break;
    }
}

NSTimer *TimerID=nil;

//******************************************************************
void StartTimer(DWORD timval) {
    
    // create periodic timer
    if( TimerID==nil ) TimerID = [NSTimer scheduledTimerWithTimeInterval:((CGFloat)timval)/1000.0 target:pKV selector: @selector(OnTimer:) userInfo:nil repeats:YES];
}

//******************************************************************
void StopTimer(void) {
    
    if( TimerID!=nil ) {
        [TimerID invalidate];
        TimerID = nil;
    }
}

///====================================================
void DoSys() {

    DWORD    pArgs, func, dw, SP;
    char    *pBuf;

    /// get ptr to the arguments (starting with the SYS function as a DWORD, then continuing to higher addresses with any other arguments)
    pArgs = GETMEMD(KEHED_R15);
    /// get DoSys function#
    func  = GETMEMD(pArgs);
    pArgs += 4;

    switch( func>>8 ) {    /// first get the major group
     case SYS_FILE:
        DoSysFile(func, pArgs);
        break;
     case SYS_PRINT:

        break;
     case SYS_TIME:
        switch( func & 0x0FF ) {
         case SYS_SETTIMER:
            dw = GETMEMD(pArgs);
            if( dw ) StartTimer(dw);
            else StopTimer();
            break;
         case SYS_TIMEMILLI:
            SETMEMD(KEHED_R14, KGetTicks());
            break;
         case SYS_TIMESTR:
            pBuf = (char*)(mainKE+GETMEMD(pArgs));
             KTimeToString((BYTE*)pBuf);
            break;
        }
        break;
     case SYS_STRMEM:
        DoSysStrMem(func, pArgs);
        break;
     case SYS_WINDOW:

        break;
     case SYS_GRAPH:
        DoSysGraph(func, pArgs);
        break;
     case SYS_SOUND:
        switch( func & 0x0FF ) {
         case SYS_PLAYSOUND:
            pBuf = (char*)(mainKE + GETMEMD(pArgs));    // get pointer to name buffer
            KPlaySound(pBuf);
            break;
         case SYS_PLAYMUSIC:
             dw = GETMEMD(pArgs);       // get offset to name buffer
             if( dw==-1 ) StopMusic();   //
             else if( dw==-2 ) PlayMusic(lastMusic);
             else {
                 strcpy(lastMusic, (char*)(mainKE+dw));
                 PlayMusic((char*)(mainKE+dw));
             }
            break;
         case SYS_STOPMUSIC:
            StopMusic();
            break;
         case SYS_ISMUSIC:
            SETMEMD(KEHED_R14, (DWORD)MusicPlaying);
            break;
        }
        break;
     case SYS_SYSTEM:
        DoSysSystem(func, pArgs);
        break;
     case SYS_CFG:
        DoSysCfg(func, pArgs);
        break;
     case SYS_HEAP:
        dw = GETMEMD(pArgs);
         switch( func & 0x0FF ) {
         case SYS_HALLOC:
            SETMEMD(KEHED_R14, AllocHeap(dw));    // return the HANDLE of the HEAP block
            break;
         case SYS_HFREE:
            FreeHeap(dw);                        // free the Heap HANDLE block
            break;
         case SYS_HLOCK:
            SP = GETMEMD(KEHED_SP);                // get current SP
            SETMEMD(KEHED_SP, SP+20);            // move it back up beyond the main.ke HeapLock(hHeap) call, so auto-unlock doesn't kick in before main.ke's HeapLock(hHeap) can return to its caller
            SETMEMD(KEHED_R14, LockHeap(dw));    // lock the Heap HANDLE and return the *ptr
            SETMEMD(KEHED_SP, SP);                // restore SP
            break;
         case SYS_HUNLOCK:
            UnlockHeap(dw);                        // unlock the Heap HANDLE
            break;
        /// NOTE: Use of SYS_HPTR must be RESPONSIBLE. The returned pointer is good UNTIL something can possibly cause the Heap to be moved (in whatever way). Use with care, or you'll develop a serious case of teeth-marks in your posterior.
         case SYS_HPTR:
            SETMEMD(KEHED_R14, GetHeapAdr(dw));    // return the *ptr
            break;
         }
        break;
     default:
        sprintf((char*)TmpPath, "Unknown SYS command at 0x%8.8X. Ack!", GETMEMD(KEHED_PC));
        SystemMessage((char*)TmpPath);
        break;
    }
}

/*
                     dw = GETMEMD(dptr);
                     b = GETMEMB(dw);
                     if( !(b & 0x80) ) SETMEMB(dw, toupper(b));
                     else {
                        if( (b & 0xE0)==0xC0 ) i = 2;
                        else if( (b & 0xF0)==0xE0 ) i = 3;
                        else i = 4;
                        *(DWORD*)UTF8buf = *(DWORD*)(mainKE + dw);
                        MultiByteToWideChar(CP_UTF8, 0, UTF8buf, i, (LPWSTR)UTF16buf, 512);
                        UTF16buf[1] = UTF16buf[2] = UTF16buf[3] = 0;
                        UTF16buf[0] = towupper_l(UTF16buf[0], locale);
                        j = WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)UTF16buf, -1, UTF8buf, 0, NULL, NULL);
                        if( i+1!=j ) {
                            SystemMessage("TOUPPER returned different byte-sized character");
                        } else {
                            WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)UTF16buf, -1, UTF8buf, sizeof(UTF8buf), NULL, NULL);
                            for(j=0; j<i; j++) SETMEMB(dw+j, UTF8buf[j]);
                        }
        _free_locale(locale);
                     }
                     break;
                 case 12:            /// UTF8LOW        11000111 00ssdddd
                     b = GETMEMB(dptr);
                     if( !(b & 0x80) ) SETMEMB(dptr, tolower(b));
                     else {
                        if( (b & 0xE0)==0xC0 ) i = 2;
                        else if( (b & 0xF0)==0xE0 ) i = 3;
                        else i = 4;
                        *(DWORD*)UTF8buf = *(DWORD*)(mainKE + dptr);
                        MultiByteToWideChar(CP_UTF8, 0, UTF8buf, i, (LPWSTR)UTF16buf, 512);
                        UTF16buf[1] = UTF16buf[2] = UTF16buf[3] = 0;
                        UTF16buf[0] = towlower(UTF16buf[0]);
                        if( i+1!=WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)UTF16buf, -1, UTF8buf, 0, NULL, NULL) ) SystemMessage("TOLOWER returned different byte-sized character");
                        else {
                            WideCharToMultiByte(CP_UTF8, 0, (LPCWSTR)UTF16buf, -1, UTF8buf, sizeof(UTF8buf), NULL, NULL);
                            for(j=0; j<i; j++) SETMEMB(dptr+j, UTF8buf[j]);
                        }
                     }
                     break;
                 case 13:            /// UTF8SKIP        11000111 01ssdddd
                     dw = GETMEMD(dptr);
                     b = GETMEMB(dw);
                     if( !(b & 0x80) ) SETMEMD(dptr, 1+dw);
                     else if( (b & 0xE0)==0xC0 ) SETMEMD(dptr, 2+dw);
                    else if( (b & 0xF0)==0xE0 ) SETMEMD(dptr, 3+dw);
                    else SETMEMD(dptr, 4+dw);
                     break;
*/

///************************************************************
void StringFindReplace(BYTE *src, BYTE *strF, BYTE *strR) {
    
    int        s, d, f, r;

    for(s=d=0; src[s]; ) {
        if( src[s]==strF[0] ) {
            for(f=0; strF[f] && src[s+f]; f++) if( strF[f]!=src[s+f] ) break;
            if( strF[f]==0 ) {
                for(r=0; strR[r]; r++) src[d+r] = strR[r];
                s += f;
                d += r;
            } else {
                src[d++] = src[s++];
            }
        } else {
            src[d++] = src[s++];
        }
    }
    src[d] = 0;
}

void MacStringFixup(BYTE *inString) {
    
#if USE_CMD_KEY
    StringFindReplace (inString, (BYTE*)"Ctl", (BYTE*)"Cmd");
    StringFindReplace (inString, (BYTE*)"CTL", (BYTE*)"CMD");
    StringFindReplace (inString, (BYTE*)"Ctrl", (BYTE*)"Cmd");
    StringFindReplace (inString, (BYTE*)"CTRL", (BYTE*)"CMD");
#endif
}
#if 0
BYTE        *pFontData;    // ptr to malloc'd RAM for fonts
WORD        NumFonts;    // number of fonts in pFontData
UNALIGNED DWORD        *pFontTable;    // ptr to table of offsets to fonts in pFontData
BYTE        FontSelection[MAXFONTS];    // used in prioritizing fonts in SysGetFont

//***************************************************************
// Find a font such that "text" will be as large as possible
// while still fitting within a rectangle of width "w" and height "h"
// and matching the attribute "flags".
WORD FitFont(BYTE *text, WORD w, WORD h, WORD flags) {

	int		i, i1;
	WORD	*pF;
	WORD	tw, th, ta, saveCF;
	
	if( NumFonts==0 ) return 0;	// to save us from checking all the time within this function
	
#if MAC_PORT
	MacStringFixup (text);
#endif
	saveCF = CurFont;
	for(i=0; i<NumFonts; i++) {
		FontSelection[i] = 0;
		pF = (WORD *)(pFontData + pFontTable[i]);
		th = pF[0];
		if( th <= h ) {	// if height is <= desired height
			th = pF[2];
			if( !((th ^ flags) & 1) ) {// if correct FIXED/VARIABLE pitch
				FontSelection[i] = 1;	// mark as a possibility
				if( !((th ^ flags) & 6) ) FontSelection[i] = 2; // if correct BOLD/ITALICS
				CurFont = (WORD)i;
				TextSizeBMB(text, &tw, &th, &ta);
				if( tw>w ) FontSelection[i] = 0;
			}
		}
	}
	CurFont = saveCF;
	
	// Fonts are assumed to be sorted in order of increasing height within the FONTS file.
	// So, start at the top and work down, remembering the first file with FontSelection[]==1
	// and TAKING the first file with FontSelection[]==2.  If no 2's are found, and there was
	// a '1', take the first '1'.  Else, select font 0 as the default, which should be the
	// smallest, variable pitch font.
	
	i1 = 0;
	for(i=NumFonts-1; i>=0; i--) {
		if( FontSelection[i]==2 ) return i;
		if( i1==0 && FontSelection[i]==1 ) i1 = i;
	}
	if( i1 ) return i1;
	
	return 0;
}

//*********************************************************
void RelFont(KLONG w) {

	kFONT[w].used = false;
	while( FONTcnt && !kFONT[FONTcnt-1].used ) --FONTcnt;
}
//**********************************************************
void SetTextStyle(KLONG font, DWORD textClr, DWORD backClr) {

	CurFont = font;
	CurTextColor = textClr;
	CurBackColor = backClr;
}
#endif

///***************************************************************
#if 0
#define	SYSFONTMINW	2048
#define	SYSFONTNUM	18

#define	NUMSYSFONT	100
typedef struct {
	int		h, flags;
	int		prevFont, nextFont;
} SYSFONT;
//CTFontRef	hFont[NUMSYSFONT];
NSFont	*hFont[NUMSYSFONT];

SYSFONT	SysFonts[NUMSYSFONT];
KLONG	firstSysFont;

int		SysFontW;	// width of SysFontBuf
int		SysFontH;	// height of SysFontBuf
KLONG	SysFontBMB=-1;
//NSString	*SysFontWbuf=NULL;
//int		SysFontWbufLen;
//HDC		SFdc=NULL;
//HBITMAP	oldSFbm;

///***************************************************************
/// Creates a font such that "text" will be as large as possible
/// while still fitting within a rectangle of width "w" and height "h".
NSFont *FitSysFont(NSString *text, int w, int h, DWORD flags, CGSize *fontsize) {
	
	int		i, len;
	NSFont	*fnt;
	CGSize	size;
	NSString *fntName;//, *fntAttribs;

//	Dwrite("FitSysFont ENTER");
	i = h;
/*	if( flags & ST_FIXED ) {
		fntName = @"Courier";
		if( flags & ST_BOLD ) {
			if( flags & ST_ITALIC ) fntAttribs = @"Bold Oblique";
			else fntAttribs = @"Bold";
		} else if( flags & ST_ITALIC ) fntAttribs = @"Oblique";
		else fntAttribs = @"";
	} else {
		if( flags & ST_SERIF ) {
			fntName = @"Times";
			if( flags & ST_BOLD ) {
				if( flags & ST_ITALIC ) fntAttribs = @"Bold Italic";
				else fntAttribs = @"Bold";
			} else if( flags & ST_ITALIC ) {
				fntAttribs = @"Italic";
			} else fntAttribs = @"";
		} else {
			fntName = @"Helvetica";
			if( flags & ST_BOLD ) {
				if( flags & ST_ITALIC ) fntAttribs = @"Bold Oblique";
				else fntAttribs = @"Bold";
			} else if( flags & ST_ITALIC ) fntAttribs = @"Oblique";
			else fntAttribs = @"";
		}
	}

	 // create the font
	NSDictionary *fontAttribs = [NSDictionary dictionaryWithObjectsAndKeys:
								fntName, (NSString*)kCTFontFamilyNameAttribute,
								fntAttribs, (NSString *)kCTFontStyleNameAttribute,
								[NSNumber numberWithFloat:160.0],
								(NSString *)kCTFontSizeAttribute,
								nil];
	CTFontDescriptorRef descriptor = CTFontDescriptorCreateWithAttributes((CFDictionaryRef)fontAttribs);
	CTFontRef font = CTFontCreateWithFontDescriptor(descriptor, 0.0, NULL);
	CFRelease(descriptor);
	 
	// set up the string and font
	CFStringRef str = CFStringCreateWithCString(NULL, "\320\215y", kCFStringEncodingUTF8);
	CFStringRef keys[] = {kCTFontAttributeName};
	CFTypeRef values[] = {font};
	CFDictionaryRef attributes = CFDictionaryCreate(kCFAllocatorDefault, (const void**)&keys,
												(const void**)&values, sizeof(keys)/sizeof(keys[0]),
												&kCFTypeDictionaryKeyCallBacks, &kCFTypeDictionaryValueCallBacks);
	CFAttributedStringRef attrString = CFAttributedStringCreate(kCFAllocatorDefault, str, attributes);
	CFRelease(attributes);
	 
	// set the text position and draw it
	CTLineRef line = CTLineCreateWithAttributedString(attrString);
	CGFloat	ah, dh, lh;
	CTLineGetTypographicBounds(line, &ah, &dh, &lh);
	
	CGContextSetTextPosition(kBM[0].bitmapContext, 100,  kBM[0].physH-200);// [self frame].size.height);
	CTLineDraw(line, kBM[0].bitmapContext);
	//	CGContextSetTextPosition(context, 100, 100);
	//	CTLineDraw(line, context);
	CFRelease(line);
	 
	//	NSString *tmpWbuf = [[NSString alloc] initWithUTF8String:"\320\215y"];
	 
//	NSRange	strRange = [text rangeOfString:text];

	i = 8;
*/
	len = (int)[text length];
	if( flags & ST_FIXED ) {
		if( flags & ST_BOLD ) {
			if( flags & ST_ITALIC ) fntName = @"Courier-BoldOblique";
			else fntName = @"Courier-Bold";
		} else if( flags & ST_ITALIC ) {
			fntName = @"Courier-Oblique";
		} else fntName = @"Courier";
	} else {
		if( flags & ST_SERIF ) {
			if( flags & ST_BOLD ) {
				if( flags & ST_ITALIC ) fntName = @"Times-BoldItalic";
				else fntName = @"Times-Bold";
			} else if( flags & ST_ITALIC ) {
				fntName = @"Times-Italic";
			} else fntName = @"Times";
		} else {
			if( flags & ST_BOLD ) {
				if( flags & ST_ITALIC ) fntName = @"Helvetica-BoldOblique";
				else fntName = @"Helvetica-Bold";
			} else if( flags & ST_ITALIC ) {
				fntName = @"Helvetica-Oblique";
			} else fntName = @"Helvetica";
		}
	}
	NSMutableDictionary *attribs = [[NSMutableDictionary alloc] init];
//	NSMutableAttributedString *string = [[NSMutableAttributedString alloc] initWithString:text];
//	[string beginEditing];
	do {
		++i;
//		[string addAttribute:NSFontAttributeName value:[NSFont fontWithName:fntName size:(CGFloat)i] range:strRange];
		fnt = [NSFont fontWithName:fntName size:i];
		[attribs setObject:fnt forKey:NSFontAttributeName];
		size = [text sizeWithAttributes:attribs];
	} while( len && size.width<w && size.height<h );
	do {
		--i;
//		[string beginEditing];
//		[string addAttribute:NSFontAttributeName value:[NSFont fontWithName:fntName size:(CGFloat)i] range:strRange];
//		[string endEditing];
		fnt = [NSFont fontWithName:fntName size:i];
		[attribs setObject:fnt forKey:NSFontAttributeName];
		size = [text sizeWithAttributes:attribs];

		if( i<=4 || (size.width<w && size.height<h) ) break;
	} while( i>4 && (size.width>=w || size.height>=h) );

	if( len==0 || size.width>=w || size.height>=h ) {
//		[string beginEditing];
//		[string addAttribute:NSFontAttributeName value:[NSFont fontWithName:fntName size:(CGFloat)i] range:strRange];
//		[string endEditing];
		fnt = [NSFont fontWithName:fntName size:i];
		[attribs setObject:fnt forKey:NSFontAttributeName];
		size = [text sizeWithAttributes:attribs];
	}
//	[string endEditing];

//	NSFont *somefont;
//	CGSize	size = [text sizeWithAttributes:@{NSFontAttributeName: somefont}];
/*	NSString * hws = @"Hello world!";
	 NSPoint	p;
	 
	 p = NSMakePoint(10,100);
	 [hws drawAtPoint:p withAttributes:attribs];
*/
/*
 	hdc = GetDC(NULL);
	len = wcslen(text);
	i = 8;
	logpixy = GetDeviceCaps(hdc, LOGPIXELSY);
	sFont.lfWidth = 0;
	sFont.lfEscapement = sFont.lfOrientation = 0;
	sFont.lfStrikeOut = FALSE;
	sFont.lfCharSet = ANSI_CHARSET;
	sFont.lfOutPrecision = OUT_TT_PRECIS;
	sFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	sFont.lfQuality = PROOF_QUALITY;// DEFAULT_QUALITY;//2=PROOF_QUALITY;

	
	
	sFont.lfWeight = (flags & ST_BOLD)?FW_BOLD:FW_NORMAL;
	sFont.lfItalic = (flags & ST_ITALIC)?TRUE:FALSE;
	sFont.lfUnderline = (flags & ST_UNDERLINED)?TRUE:FALSE;
	if( flags & ST_FIXED ) {
		sFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
		wcscpy(sFont.lfFaceName, L"Courier New");
	} else {
		if( flags & ST_SERIF ) {
			sFont.lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN;
			wcscpy(sFont.lfFaceName, L"Times New Roman");
		} else {
			sFont.lfPitchAndFamily = VARIABLE_PITCH | FF_SWISS;
			wcscpy(sFont.lfFaceName, L"Tahoma");
		}
	}
 */
	if( fontsize!=NULL ) {
		fontsize->width = size.width;
		fontsize->height = size.height;
	}
//	Dwrite("FitSysFont EXIT");
	return fnt;
}

//**************************************
void InitSysFonts(int w, int h) {
	
//	HDC		hDC;
	
	firstSysFont = -1;
	memset(&SysFonts[0], 0xFF, sizeof(SysFonts));
	if( w<SYSFONTMINW ) w = SYSFONTMINW;
	SysFontW = w;
	SysFontH = h;
	SysFontBMB = CreateBMB(SysFontW, SysFontH, TRUE);
//	SysFontWbufLen = 2048;
//	SysFontWbuf = (WCHAR*)malloc(SysFontWbufLen * sizeof(WCHAR));
	
//	hDC = GetDC(NULL);
//	if( NULL!=(SFdc=CreateCompatibleDC(hDC)) ) {
//		SetBkMode(SFdc, TRANSPARENT);
//		SetTextAlign(SFdc, TA_LEFT | TA_TOP);
//		oldSFbm = (HBITMAP)SelectObject(SFdc, SysFontBMB->hBitmap);
//	}
//	ReleaseDC(NULL, hDC);
}

//**************************************
void FreeSysFonts() {
	
	int		i;
	
//	SelectObject(SFdc, oldSFbm);
//	DeleteDC(SFdc);
//	SFdc = NULL;
	
	while( firstSysFont >= 0 ) {
		i = SysFonts[firstSysFont].nextFont;
		hFont[firstSysFont] = nil;//DeleteObject(SysFonts[firstSysFont].hFont);
		SysFonts[firstSysFont].prevFont = SysFonts[firstSysFont].nextFont = -1;
		firstSysFont = i;
	}
	
//	if( SysFontBMB>=0 ) DeleteBMB(SysFontBMB);
//	SysFontBMB = -1;
//	if( SysFontWbuf!=NULL ) {
//		free(SysFontWbuf);
//		SysFontWbuf = NULL;
//	}
}

/// flags:
///	BIT 0 ( 1) = 1 if FIXED font
///	BIT 1 ( 2) = 1 if BOLD
///	BIT 2 ( 4) = 1 if ITALIC
///	BIT 3 ( 8) = 1 if UNDERLINED
///	BIT 4 (16) = 1 if SERIF
///	BIT 5 (32) = 1 if CENTERED
///	BIT 6 (64) = 1 if RIGHT-JUSTIFIED (if both BIT5 and BIT6 are set, text is CENTERED)
///	BIT 7 (128)= 1 of ROTATE counter-clockwise into target bitmap (vertical text) so the "top-left corner" of the text becomes the bottom-left corner in the target
///		NOTE: ROTATE can NOT be used if bclr==CLR_NONE.  ROTATE is forced OFF in that case.
///	BIT 8 (256)= 1 if break text on any character boundary if the text overflows (x+w).  BIT8 takes precedence over BIT9 if both are set.
///	BIT 9 (512)= 1 if break text on a SPACE (word) boundary if the text overflows (x+w).  If neither BIT8 nor BIT9 are set, then a partial character may appear at (x+w) if the text overflows.

/// BIT 15(32768) = 1 if pBM is invalid and do NOT draw the text, just return the WIDTH of the text

/// RETURN # of CHARs consumed from pText in lower WORD, pixel-width of characters drawn in upper WORD

DWORD DrawSysFontText(PBMB pBM, char *pText, int x, int y, int w, int h, int flags, DWORD bclr, DWORD fclr, KLONG *pW) {
	
	char		c;
	int			wcnt=0, n, p, fontix=0, dx, dy;
	int			i, j, ww, savend, curend;
//	HBRUSH		hBrush;
//	RECT		rect;
//	CGSize		tsize;
//	WCHAR		tmpWbuf[8];
//	NSSize		tsize;
	NSString	*tmpWbuf;
	WORD		th;
	SYSFONT		*pSF;
	
//	Dwrite("DrawSysFontText ENTER");
	/// bail if nothing to do
	if( SysFontBMB<0 || w==0 || h==0 || *pText==0 ) return 0;
	if( bclr==0xFFFFFFFF ) flags &= ~128;	// don't allow rotate if we're not filling the background
	
	/// find or create the desired font
	for(i=(int)firstSysFont, j=0; i>=0 && (SysFonts[i].h!=h || SysFonts[i].flags!=(flags & ST_FONT_CHARS)); j++) {
		fontix = i;	// save last 'good' SysFont found (the least-used one, in case we're out of slots)
		i = SysFonts[i].nextFont;
	}
	/// if the desired font hasn't been created yet, create it
	if( i<0 ) {	/// font doesn't already exist
		if( j >= NUMSYSFONT ) {	/// there's NO room for another
			pSF = &SysFonts[fontix];	/// point to the least-used font
			if( pSF->nextFont >= 0 ) SysFonts[pSF->nextFont].prevFont = pSF->prevFont;	/// unlink it from the list
			if( pSF->prevFont >= 0 ) SysFonts[pSF->prevFont].nextFont = pSF->nextFont;
			hFont[fontix] = nil;// DeleteObject(SysFonts[fontix].hFont);	/// delete it
		} else {	/// there's room for another font, somewhere
			/// find a free slot
			for(fontix=0; fontix<NUMSYSFONT; fontix++) if( SysFonts[fontix].h<0 ) break;
		}
		/// fontix now indexes to an empty SysFonts[] slot, create the font there
		
/*		NSPoint	p;
		NSMutableDictionary *attribs;
		NSColor	*c;
		NSFont	*fnt;
		fnt = FitSysFont(hws, 1000, 100, FSFflags, NULL);
		p = NSMakePoint(10,100);
		attribs = [[NSMutableDictionary alloc] init];
		c = [NSColor redColor];
		[attribs setObject:c forKey:NSForegroundColorAttributeName];
		[attribs setObject:fnt forKey:NSFontAttributeName];
*/
		
		pSF = &SysFonts[fontix];
		
		tmpWbuf = [[NSString alloc] initWithUTF8String:"\320\215y"];
		hFont[fontix] = FitSysFont(tmpWbuf, 2048, h, flags, NULL);
		
		/// link the new font into the front of the list, as it is now most-recent
		pSF->h = h;
		pSF->flags = flags & ST_FONT_CHARS;
		pSF->prevFont = -1;
		pSF->nextFont = (int)firstSysFont;
		if( pSF->nextFont >= 0 ) SysFonts[pSF->nextFont].prevFont = fontix;	/// point previous 'first' font at this new 'first' font
		firstSysFont = fontix;
	} else {	/// font exists, move it to the front of the list (most-recently used) if it's not already there
		fontix = i;
		if( fontix != firstSysFont ) {	/// it's not first
			pSF = &SysFonts[fontix];
			n = pSF->nextFont;
			p = pSF->prevFont;
			if( n >= 0 ) SysFonts[n].prevFont = p;	/// unlink it from the list
			if( p >= 0 ) SysFonts[p].nextFont = n;
			/// we know firstSysFont != -1, because THIS font already exists and was found
			/// so just link this font into the front of the list (now most-recently used)
			pSF->prevFont = -1;
			if( firstSysFont >= 0 ) SysFonts[firstSysFont].prevFont = fontix;
			pSF->nextFont = (int)firstSysFont;
			firstSysFont = fontix;
		}
	}
/*
	CTFontRef	font=CFBridgingRetain(hFont[fontix]);
	
	// set up the string and font
	CFStringRef str = CFStringCreateWithCString(NULL, pText, kCFStringEncodingUTF8);
	CFStringRef keys[] = {kCTFontAttributeName};
	CFTypeRef values[] = {font};
	CFDictionaryRef attributes = CFDictionaryCreate(kCFAllocatorDefault, (const void**)&keys,
													(const void**)&values, sizeof(keys)/sizeof(keys[0]),
													&kCFTypeDictionaryKeyCallBacks, &kCFTypeDictionaryValueCallBacks);
	CFAttributedStringRef attrString = CFAttributedStringCreate(kCFAllocatorDefault, str, attributes);
	CFRelease(attributes);
*/
	tmpWbuf = [[NSString alloc] initWithUTF8String:pText];
	CGSize	size;// = [tmpWbuf sizeWithAttributes:@{NSFontAttributeName: hFont[fontix]}];
	NSPoint	point;
	 
	point = NSMakePoint(0,0);
	NSMutableDictionary *attribs = [[NSMutableDictionary alloc] init];
	[attribs setObject:hFont[fontix] forKey:NSFontAttributeName];

	[attribs setObject:[NSColor colorWithRed:(CGFloat)(fclr&0xFF)/255.0 green:(CGFloat)((fclr>>8)&0xFF)/255.0 blue:(CGFloat)((fclr>>16)&0xFF)/255.0 alpha:1.0] forKey:NSForegroundColorAttributeName];
	if( flags & 8 ) [attribs setObject:[NSNumber numberWithInt:NSUnderlineStyleSingle] forKey:NSUnderlineStyleAttributeName];

	size = [tmpWbuf sizeWithAttributes:attribs];

//	[tmpWbuf drawAtPoint:point withAttributes:attribs];

	// set the text position and draw it
/*
 CTLineRef line = CTLineCreateWithAttributedString(attrString);
	CGFloat	ah, dh, lh, toth;
	CTLineGetTypographicBounds(line, &ah, &dh, &lh);
	
	CGContextSetTextPosition(kBM[SysFontBMB].bitmapContext, 0,  kBM[SysFontBMB].physH-toth);// [self frame].size.height);
*/
	/// set up for text drawing to SysFontBMB
//	SetTextColor(SFdc, fclr);
//	SelectObject(SFdc, SysFonts[firstSysFont].hFont);
	
//	SetupBMD(&SysFontBMB);
	
	/// convert UTF8 string to WCHAR
	// first, make sure the buffer is big enough
//	i = MultiByteToWideChar(CP_UTF8, 0, pText, -1, 0, 0);
//	if( i>SysFontWbufLen ) {
//		free(SysFontWbuf);
//		SysFontWbufLen = i+512;
//		SysFontWbuf = (WCHAR*)malloc(SysFontWbufLen * sizeof(WCHAR));
//	}
	// second, convert it
//	wcnt = MultiByteToWideChar(CP_UTF8, 0/*MB_PRECOMPOSED*/, pText, -1, SysFontWbuf, SysFontWbufLen);
	wcnt = (int)[tmpWbuf length];
	
//	CTLineDraw(line, kBM[SysFontBMB].bitmapContext);
//	CFRelease(line);
	/*
	 if( wcnt == 0 ) {
	 char* msg = "Unknown error";
	 
	 switch( GetLastError() ) {
	 case ERROR_INSUFFICIENT_BUFFER:
	 msg = "Buffer size not large enough";
	 break;
	 case ERROR_INVALID_FLAGS:
	 msg = "Invalid flags";
	 break;
	 case ERROR_INVALID_PARAMETER:
	 msg = "Invalid parameter";
	 break;
	 case ERROR_NO_UNICODE_TRANSLATION:
	 msg = "Invalid Unicode in string";
	 break;
	 };
	 MessageBoxA(NULL, msg, "MultiByteToWideChar error", MB_OK);
	 }
	 */
	curend = wcnt;	/// because wcnt includes the NUL char, apparently
	/// now draw the string (possibly multiple times if it's too long for the space)
	ww = -1;	/// flag this is the first time through
	
	dy = kBM[SysFontBMB].physH-size.height-[hFont[fontix] descender];
	[NSGraphicsContext saveGraphicsState];
	[NSGraphicsContext setCurrentContext:[NSGraphicsContext graphicsContextWithCGContext:kBM[SysFontBMB].bitmapContext flipped:FALSE]];

	if( bclr==0xFFFFFFFF ) {
		BltBMB(&kBM[SysFontBMB], 0, 0, pBM, x, y, w, h, (int)FALSE, (int)FALSE);
	} else {
		[[NSColor colorWithCalibratedRed:(CGFloat)(bclr & 0xFF)/255.0 green:(CGFloat)((bclr>>8)&0xFF)/255.0 blue:(CGFloat)((bclr>>16)&0xFF)/255.0 alpha:1.0] set];
		NSRectFill(NSMakeRect(0, kBM[SysFontBMB].physH-h, (flags & 4) ? min(w+h, 2048) : w, h));
	}
	NSMutableString *frag = [@"" mutableCopy];
	
	if( size.width>w ) {
		if( (flags & 512) ) {	// if breaking on SPACE
			curend = 0;
			int lastSpace=0;
			for(curend=0; curend<wcnt; curend++) {
				[frag appendString:[tmpWbuf substringWithRange:NSMakeRange(curend, 1)]];
				if( [frag characterAtIndex:curend]==' ' ) lastSpace = curend;
				if( [frag sizeWithAttributes:attribs].width > w ) {
					if( curend==0 ) return 0;	// if not room to output even a single char
					if( lastSpace==0 && (flags & 256) ) {
						frag = [@"" mutableCopy];
						goto breakany;
					}
	// the following line should be commented out!  It causes breaks in the middle of words
	//				if( lastSpace==0 ) lastSpace = curend-1;
					while( curend && lastSpace>=0 && curend > lastSpace ) {
						[frag deleteCharactersInRange:NSMakeRange(curend--, 1)];
					}
					if( [frag length]==1 && [frag characterAtIndex:0]==' ' ) return 0;
					break;
				}
			}
		} else if( (flags & 256) ) {	// if breaking on ANY CHAR
breakany:
			for(curend=0; curend<wcnt; curend++) {
				[frag appendString:[tmpWbuf substringWithRange:NSMakeRange(curend, 1)]];
				if( [frag sizeWithAttributes:attribs].width > w ) {
					if( curend==0 ) return 0;	// if not room to output even a single char
					[frag deleteCharactersInRange:NSMakeRange(curend, 1)];
					break;
				}
			}
		} else {	// no break
			frag = [tmpWbuf mutableCopy];
		}
	} else frag = [tmpWbuf mutableCopy];
	dx = 0;
//	[frag characterAtIndex:0]==' ' ? h/6 : 0;	// if starts with space, give previous char a little more room so we don't clip it
	ww = [frag sizeWithAttributes:attribs].width;
	[frag drawWithRect:NSMakeRect(dx, dy, kBM[SysFontBMB].physW, size.height) options:0 attributes:attribs];
	
	if( flags & 4 ) {	// italics
		ww += h/6;	// hack! a little slop for last char of italics
	}
	
	if( !(flags & 32768) ) {	// if not just doing a "get text width," copy the drawn text
		/// flags & 32 = CENTERED
		/// flags & 64 = RIGHT-JUSTIFIED
		/// flags & 128= ROTATED counterclockwise
		/// copy SysFontBMB to pBM
		if( flags & 128 ) {	// rotate our WORK bitmap
			th = kBM[SysFontBMB].logH;					//	swap logW and logH
			kBM[SysFontBMB].logH = kBM[SysFontBMB].logW;
			kBM[SysFontBMB].logW = th;
			kBM[SysFontBMB].orient = BMO_270;
			kBM[SysFontBMB].clipX1 = kBM[SysFontBMB].clipY1 = 0;
			kBM[SysFontBMB].clipX2 = kBM[SysFontBMB].physH;
			kBM[SysFontBMB].clipY2 = kBM[SysFontBMB].physW;
		}
		if( flags & 32 ) {			/// CENTERED
			/// if transparent (no background color) we have to redo it, to get the PROPER background image
			if( bclr==0xFFFFFFFF ) {
				BltBMB(&kBM[SysFontBMB], 0, 0, pBM, x+(w-ww)/2, y, ww, h, (int)FALSE, (int)FALSE);
				ww = [frag sizeWithAttributes:attribs].width;
//				dx = [frag characterAtIndex:0]==' ' ? h/6 : 0;	// if starts with space, give previous char a little more room so we don't clip it
				[frag drawWithRect:NSMakeRect(dx, dy, kBM[SysFontBMB].physW, size.height) options:0 attributes:attribs];
				if( flags & 4 ) {	// italics
					ww += h/6;	// hack! a little slop for last char of italics
				}
			}
			if( flags & 128 ) BltBMB(pBM, x, y+(w-ww)/2, &kBM[SysFontBMB], 0, kBM[SysFontBMB].physW-ww, h, ww, (int)FALSE, (int)FALSE);
			else {
				BltBMB(pBM, x+(w-ww)/2, y, &kBM[SysFontBMB], 0, 0, ww, h, (int)FALSE, (int)FALSE);
			}
		} else if( flags & 64 ) {	/// RIGHT JUSTIFIED
			/// if transparent (no background color) we have to redo it, to get the PROPER background image
			if( bclr==0xFFFFFFFF ) {
				BltBMB(&kBM[SysFontBMB], 0, 0, pBM, x+w-ww, y, ww, h, (int)FALSE, (int)FALSE);
				ww = [frag sizeWithAttributes:attribs].width;
//				dx = [frag characterAtIndex:0]==' ' ? h/6 : 0;	// if starts with space, give previous char a little more room so we don't clip it
				[frag drawWithRect:NSMakeRect(dx, dy, kBM[SysFontBMB].physW, size.height) options:0 attributes:attribs];
				if( flags & 4 ) {	// italics
					ww += h/6;	// hack! a little slop for last char of italics
				}
			}
			if( flags & 128 ) BltBMB(pBM, x, y, &kBM[SysFontBMB], 0, kBM[SysFontBMB].physW-ww, h, ww, (int)FALSE, (int)FALSE);
			else BltBMB(pBM, x+w-ww, y, &kBM[SysFontBMB], 0, 0, ww, h, (int)FALSE, (int)FALSE);
		} else {					/// LEFT JUSTIFIED
			if( flags & 128 ) BltBMB(pBM, x, y+w-ww, &kBM[SysFontBMB], 0, kBM[SysFontBMB].physW-min(w,ww), h, min(w,ww), (int)FALSE, (int)FALSE);
			else BltBMB(pBM, x, y, &kBM[SysFontBMB], 0, 0, min(w,ww), h, (int)FALSE, (int)FALSE);
		}
		if( flags & 128 ) {	// rotate our WORK bitmap back
			th = kBM[SysFontBMB].logH;					//	swap logW and logH
			kBM[SysFontBMB].logH = kBM[SysFontBMB].logW;
			kBM[SysFontBMB].logW = th;
			kBM[SysFontBMB].orient = BMO_NORMAL;
			kBM[SysFontBMB].clipX1 = kBM[SysFontBMB].clipY1 = 0;
			kBM[SysFontBMB].clipX2 = kBM[SysFontBMB].physW;
			kBM[SysFontBMB].clipY2 = kBM[SysFontBMB].physH;
		}
	}
	[NSGraphicsContext restoreGraphicsState];

	for(i=0, savend=curend; savend && pText[i]; --savend) {
		c = pText[i];
		if( c & 0x80 ) {
			if( (c & 0xE0)==0xC0 ) {		/// 2-byte code
				c = pText[++i];
				if( (c & 0xC0)==0x80 ) ++i;
			} else if( (c & 0xF0)==0xE0 ) {	/// 3-byte code
				c = pText[++i];
				if( (c & 0xC0)==0x80 ) {
					c = pText[++i];
					if( (c & 0xC0)==0x80 ) ++i;
				}
			} else if( (c & 0xF8)==0xF0 ) {	/// 4-byte code
				c = pText[++i];
				if( (c & 0xC0)==0x80 ) {
					c = pText[++i];
					if( (c & 0xC0)==0x80 ) {
						c = pText[++i];
						if( (c & 0xC0)==0x80 ) ++i;
					}
				}
			}
		} else ++i;							/// 1-byte code
	}
	/// return length drawn (in lower word) & pixel-width of drawn text (in upper word)
//	Dwrite("DrawSysFontText EXIT");
	return (ww<<16)+i;
}

#endif

//***********************************************************
//* SysStartup() is called from MAIN during startup, and is *
//* a chance to do any one-time initialization stuff.       *
//***********************************************************
void SysStartup(void) {
    
//    DWORD    FileSize, BytesRead, hFile;
    
//    Dwrite("SysStartUp ENTER");
    KINTmsgTimer = [NSTimer scheduledTimerWithTimeInterval:5.0/1000.0 target:pKV selector: @selector(KINTtimer:) userInfo:nil repeats:YES];
/*
    NumFonts = 0;
    // Open the file: read access, prohibit write access
    hFile = Kopen("fonts", O_RDBIN, DIR_GAME);
    if( -1 != hFile ) {
        //        SEEK_SET    0
        //        SEEK_CUR    1
        //        SEEK_END    2
        FileSize = Kseek(hFile, 0, 2);    // get the file size
        Kseek(hFile, 0, 0);    // move back to start of file
        if( NULL!=(pFontData=(BYTE *)malloc(FileSize)) ) {
            BytesRead = Kread(hFile, pFontData, FileSize);
            if( BytesRead==FileSize ) {
                NumFonts = *((WORD *)pFontData);
                pFontTable = (DWORD *)(pFontData+2);
            } else {
                free(pFontData);
            }
        }
        Kclose(hFile);
    } else {
        SystemMessage("FONTS file missing");
        exit(0);
    }
*/
//    Dwrite("SysStartUp EXIT");
}

/*
// arg2==1 indicates to game code that we're coming back from being hidden
// arg3==OS, 0==Android, 1==iOS
void SysMinimize(Boolean isMin) {
	
	while( runKEmsg ) ;
	if( KEloaded>1 ) AddMsg(KHDR_WINDOW_HIDDEN, isMin, 0, 1);
//	if( KEloaded ) AddMsg(KHDR_WINDOW_HIDDEN, isMin, 0, 1);
}
*/
